{--------------------------------------------------------}
{
{           MataSpam - rotinas para trabalhar com arquivo de bloqueados
{
{--------------------------------------------------------}

unit carbloq;

interface

uses
    classes,
    dvWin,
    sysutils,
    carMsg;

function carregaArqProibidas: boolean;
function buscaProibidas (s: string): boolean;
procedure destroiLinhasArquivo;

var
    linhasArquivo: TStringList;

implementation

{-------------------------------------------------------------}
{       Carrega todas as linhas do arquivo na memria
{-------------------------------------------------------------}

function carregaLinhasArquivo (nomeArq: string): boolean;
begin
    linhasArquivo := TStringList.create;
    carregaLinhasArquivo := true;
    try
        linhasArquivo.loadFromFile (nomeArq);
    except
         carregaLinhasArquivo := false;
    end;
end;

{-------------------------------------------------------------}
{       Destroi todas as linhas do arquivo da memria
{-------------------------------------------------------------}

procedure destroiLinhasArquivo;
begin
    linhasArquivo.free;
end;

{-------------------------------------------------------------}
{       Cria o arquivo de bloqueados padro
{-------------------------------------------------------------}

procedure criaArqBloqueados (nomeArq: string);
var
    arq: text;
begin
    assign (arq, nomeArq);
    {$i-} rewrite (arq); {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('MSERRESC', 1); {'Erro de escrita no arquivo'}
            exit;
        end;

    {$i-} writeln (arq, '.SCR'); {$I+}
    if ioresult <> 0 then
        mensagem ('MSERRESC', 1) {'Erro de escrita no arquivo'}
    else
        begin
            writeln (arq, '.EXE"');
            writeln (arq, '!.ZIP');
            writeln (arq, 'DISCOUNT');
            writeln (arq, 'INCREASE');
            writeln (arq, 'CURRENT');
            writeln (arq, 'EMAGRECA-DORMINDO');
            writeln (arq, 'EMAGRECER-DORMINDO');
            writeln (arq, '"THE "');
            writeln (arq, 'PILLS');
            writeln (arq, 'ENLARGEMENT');
            writeln (arq, 'ONLINE CASINO');
            writeln (arq, '.CHARGES');
            writeln (arq, 'CLIQUE AQUI');
        end;

    {$i-} close (arq); {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{       Remove as aspas do incio e do fim dos itens da lista.
{-------------------------------------------------------------}

procedure removeAspas;
var
    i: integer;
    s: string;
begin
    for i := (linhasArquivo.count -1) downto 0 do
        begin
            s := trim (linhasArquivo[i]);
            if (s = '') or (s[1] <> '"') or (s[length(s)] <> '"') then continue;
            delete (s, 1, 1);
            delete (s, length(s), 1);
            linhasArquivo[i] := s;
        end;
end;

{-------------------------------------------------------------}
{       Carrega o arquivo de nomes proibidos na memria
{-------------------------------------------------------------}

function carregaArqProibidas: boolean;
var
    nomeArq: string;
begin
    carregaArqProibidas := false;
    nomeArq := sintAmbiente ('MATASPAM', 'ARQBLOQUEADOS');
    if nomeArq = '' then
        nomeArq := 'c:\winvox\msbloque.ini';
    if not fileExists (nomeArq) then
        criaArqBloqueados (nomeArq);
    if carregaLinhasArquivo (nomeArq) then
        begin
            removeAspas;
            carregaArqProibidas := true;
        end;
end;

{-------------------------------------------------------------}
{       Testa se a string  proibida
{-------------------------------------------------------------}

function buscaProibidas (s: string): boolean;
    var
    i: integer;
begin
    s := AnsiUpperCase(s);
    buscaProibidas := false;
    for i := 0 to (linhasArquivo.count -1) do
        if (trim(s) <> '') and (pos(linhasArquivo[i], s) <> 0) then
            begin
                buscaProibidas := true;
                break;
            end;
end;

{-------------------------------------------------------------}

end.
