{-------------------------------------------------------------}
{
{           CartaVox - Cliente POP3
{
{-------------------------------------------------------------}

unit carPop3;

interface

uses
    dvcrt,
    dvForm,
    dvHora,
    dvWin,
    sysUtils,
    windows,
    carRede,
    winSock,  //Declarar depois de carRede
    carDecod,
    careMudo,
    carMsg,
    carTela,
    carUtil,
    carVars,
    carRegras,
    classes,
    carResp,
    carFolInt;

function receberCartas (    opcaoMudo: boolean): integer;
function receberCartasRespAut(primeiraPassagem: boolean; cartasExistentes, cartasChegadas: integer): integer;
function receberCartasServidor: integer;
function apagaCartaServidor(vetorAApagar: Array of integer; primeiraCartaPop3: integer): integer;
function trazCartaServidor(vetorATrazer: Array of integer; naoApagar: boolean; primeiraCartaPop3: integer; email: string): integer;
procedure tamanhoTotalServidor;
function senhaValida(iHostPop3, iContaUsuario: shortString; iPortaPOP3: integer; iUsaSSL: boolean): boolean;
function receberCartasGrupoContas (opcaoMudo: boolean): integer;

implementation

var
    mudo, ignoraTodas, recebeTodas, trazerMudo: boolean;
    acessoServidor, naoApagaCarta, acessoGrupoContas: boolean;
    cartasTrazidas, totalDeCartas: integer;
    mascaraBip, nBip: integer;
    vetorEnviados : Array[0..2000] of string;

{-------------------------------------------------------------}
{           tratamento das teclas durante a recepo
{-------------------------------------------------------------}

function trataTecla (tamanhoAFalar, totalLidos: longint): char;
var c: char;
begin
    repeat
        c := readkey;
    until not keypressed;

    trataTecla := c;

    if c = #$1b then exit;

    if (c = ' ') or (c = #$08) then
                        begin
        mudo := not mudo;
    sintBip;
                        end
    else
        begin
            write (#$0d);  clreol;
//            mensagem ('CTCARTA', 0); {'Carta'}
            sintwrite (' '+ intToStr(cartasTrazidas) + '/'+ intToStr (totalDeCartas));
            if (tamanhoAFalar <> 0) and (totalLidos <> 0) then
                begin
                    write (' com ');
                    sintWrite (intToStr((totalLidos * 100) div tamanhoAFalar) + ' % de '+ formataTamanhoArq (tamanhoAFalar));
                end
            else
                sintWrite (' iniciada');
            writeln;
        end;
end;

{-------------------------------------------------------------}
{           d bips de vez em quando
{-------------------------------------------------------------}

procedure trataBips (totalLidos: longint);
begin
      nBip := totalLidos div 16384;
      if nBip <> mascaraBip then
          begin
              write ('*');
              if not mudo then
                  if bipaNoSpeaker then bipSpeaker (22)
                                   else sintClek;
              mascaraBip := nBip;
          end;
 end;


{-------------------------------------------------------------}
{  Recebe multiplas linhas do POP3 para a resposta automtica e
{  para o folheamento interativo no servidor
{-------------------------------------------------------------}

function multiLineReceiveRespAut(nomeArq: string; naoSonoriza, acessoServidor: boolean): boolean;
var
    arq: text;
    s: string;
    i, lidos: integer;
    trazendo: boolean;
    totalLidos: longint;
    gravouAlgo: boolean;
    c: char;

label erro, erroDisco;
begin
    multiLineReceiveRespAut := true;
    gravouAlgo := false;

    assign (arq, nomeArq);
    {$I-}  rewrite (arq);  {$I+}
    if ioresult <> 0 then
        begin
erroDisco:
            mensagem ('CTPROGRV', 1);  {'Problemas para gravar carta no disco'}
            multiLineReceiveRespAut := false;
            {$I-}  close (arq);  {$I+}
            if ioresult <> 0 then;
            exit;
        end;

    c := ' ';
    s := '';
    totalLidos := 0;
    trazendo := true;
    mascaraBip := 999;

    while trazendo do
        begin
            if keypressed then     { cancelamento }
                repeat
                    c := readkey;
                until not keypressed;

            if c = #$1b then goto erro;

            if (acessoServidor) and (c <> ' ') and (c <> #$08) then
                begin
                   write (#$0d);  clreol;
                   mensagem ('CTCARTA', 0); {'Carta'}
                   sintwrite (' '+ intToStr(cartasTrazidas) + '/'+ intToStr(totalDeCartas) + ' carregada');
                   c := ' ';
                end;

            lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
            if (lidos <= 0) then goto erro;

            bufRecebe [lidos] := #$0;

            if (totalLidos = 0) and (bufRecebe[0] <> '+') then
                begin
                    mensagem ('CTERRSRV', 1);   {'Erro no servidor, veja o que ele disse:'}
                    sintWriteln (strPas(bufRecebe));
                    writeln (arq, strPas(bufRecebe));
                    goto erro;
                end;

            totalLidos := totalLidos + lidos;
            if naoSonoriza = false then
                trataBips (totalLidos);

            for i := 0 to lidos-1 do
                begin
                    s := s + bufRecebe[i];
                    if bufRecebe[i] = #$0a then
                         begin
                             delete (s, length (s), 1);
                             if s [length(s)] = #$0d then
                                 delete (s, length (s), 1);
                             while (s <> '') and (s[length(s)] = ' ') do
                                  delete (s, length (s), 1);
                             if (s = '.') then
                                 trazendo := false
                             else
                                 begin
                                     if gravouAlgo then
                                         begin    // no grava +OK
                                             if copy (s, 1, 2) = '..' then
delete (s, 1, 1);
                                             {$I-}  writeln (arq, s);
{$I+}
                                             if ioresult <> 0 then goto
erroDisco;
                                         end;
                                         gravouAlgo := true;
                                 end;

                             s := '';
                         end;

                    if (s = '.' + #$0d) then
                        trazendo := false;
                end;
        end;

    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then goto erroDisco;
    if naoSonoriza = false then writeln;
    exit;

erro:
    limpaBufTec;
    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then;

    if not gravouAlgo then
        begin
            {$I-}  erase (arq);  {$I+}
            if ioresult <> 0 then;
        end;

    writeln;
    multiLineReceiveRespAut := false;
end;

{-------------------------------------------------------------}
{       recebe multiplas linhas do POP3
{-------------------------------------------------------------}

function multiLineReceive (nomeArq: string; tamanhoAFalar: longint):
boolean;
var
   arq: text;
   s: string;
   i, lidos: integer;
   trazendo: boolean;
   totalLidos: longint;
   gravouAlgo: boolean;

label erro, erroDisco;
begin
    multiLineReceive := true;
    gravouAlgo := false;

    assign (arq, nomeArq);
    {$I-}  rewrite (arq);  {$I+}
    if ioresult <> 0 then
        begin
erroDisco:
            mensagem ('CTPROGRV', 1);  {'Problemas para gravar carta no disco'}
            multiLineReceive := false;
            {$I-}  close (arq);  {$I+}
            if ioresult <> 0 then;
            exit;
        end;

    s := '';
    totalLidos := 0;
    trazendo := true;
    mascaraBip := 999;

    while trazendo do
        begin
            if keypressed then     { cancelamento }
                if trataTecla (tamanhoAFalar, totalLidos) = #$1b then
                      goto erro;

            lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
            if (lidos <= 0) then
                begin
                    mensagem ('CTPROCON', 2);  {'Problemas na conexo'}
                    goto erro;
                end;
            bufRecebe [lidos] := #$0;

            if (totalLidos = 0) and (bufRecebe[0] <> '+') then
                begin
                    mensagem ('CTERRSRV', 1);   {'Erro no servidor, veja o que ele disse:'}
                    sintWriteln (strPas(bufRecebe));
                    writeln (arq, strPas(bufRecebe));
                    break;
                end;

            totalLidos := totalLidos + lidos;
            trataBips (totalLidos);

            for i := 0 to lidos-1 do
                begin
                    s := s + bufRecebe[i];
                    if bufRecebe[i] = #$0a then
                         begin
                             delete (s, length (s), 1);
                             if s [length(s)] = #$0d then
                                 delete (s, length (s), 1);
                             while (s <> '') and (s[length(s)] = ' ') do
                                  delete (s, length (s), 1);
                             if (s = '.') then
                                 trazendo := false
                             else
                                 begin
                                     if gravouAlgo then
                                         begin    // no grava +OK
                                             if copy (s, 1, 2) = '..' then
                                                  delete (s, 1, 1);
                                             {$I-}  writeln (arq, s);
{$I+}
                                             if ioresult <> 0 then goto erroDisco;
                                         end;
                                         gravouAlgo := true;
                                 end;

                             s := '';
                         end;

                    if (s = '.' + #$0d) then
                        trazendo := false;
                end;
        end;

    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then goto erroDisco;
    writeln;
    exit;

erro:
    limpaBufTec;
    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then;

    if not gravouAlgo then
        begin
            {$I-}  erase (arq);  {$I+}
            if ioresult <> 0 then;
        end;

    writeln;
    multiLineReceive := false;
end;

{-------------------------------------------------------------}
{       envia conta e senha para POP3 e ve quantas cartas
{-------------------------------------------------------------}

function inicializaPOP3: boolean;
var
    i, lidos, posErro: integer;
    salvaAttr: word;
    s, s2, senha: string;
    c1, c2: char;
label deNovo, erro;

    procedure falaQuantasNoServidor;
    begin
        if numCartasPOP3 > 1 then
            mensagem ('CTEXISTM', 0)  {'Existem no servidor '}
        else
            mensagem ('CTEXISTE', 0);  {'Existe no servidor '}
//        sintWriteInt (numCartasPOP3);
//        write(' ');

if numCartasPOP3  = 1 then
begin
        mensagem ('CTUMACAR', 2); {'Uma carta'}
        write('1 carta');
end;

if numCartasPOP3  = 2 then
begin
        mensagem ('CTDUACAR', 2); {'Duas cartas'}
        write('2 cartas');
end;

if numCartasPOP3  > 2 then
begin
        sintWriteInt (numCartasPOP3);
        write(' ');
            mensagem ('CTCARTAS', 0); {'cartas'}
    write (' ');
end;
        mensagem ('CTCOMUSO', 0);  {' com uso de '}
        sintWriteln (formataTamanhoArq (numBytesPop3));
        writeln;
    end;

begin
    inicializaPOP3 := false;
    sockPOP3 := abreConexao (hostPOP3, portaPOP3, trazerMudo);
    if sockPOP3 = -1 then
        goto erro;

    if usaSSL then
        if not ativaSSL(sockPOP3) then
            begin
                mensagem ('CTSSLNAO', 2);   {'Segurana SSL no pode ser ativada'}
                fechaConexao (sockPOP3);
                goto erro;
            end;

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        goto erro;
    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, lidos);
    if (not trazerMudo) and (not acessoServidor) then
begin
//        mensagem ('CTPEGCOR', 1);  {'Pegando a correspondncia'}
end;
    StrPCopy (bufEnvia, 'USER '+ contaUsuario + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        goto erro;

    while bufRecebe[lidos-1] <> #$0a do
        begin
            lidos := lidos + receive (sockPOP3, @bufRecebe[lidos], BUFSIZE, 0);
            bufRecebe [lidos] := #$0;
        end;

    bufRecebe [lidos] := #$0;

    if bufRecebe [0] <> '+' then
        begin
            mensagem ('CTACONT', 0);  {'A conta '}
            sintwrite (contaUsuario);
            mensagem ('CTNAOACE', 1);  {' no foi aceita, servidor falou assim'}
            sintWriteln (strPas (bufRecebe));
            goto erro;
        end
    else
        netDebug (bufRecebe, lidos);

    if not trazerMudo then
        if trim (senhaSalvaPop3) = '' then
            begin
                senha := '';
                salvaAttr := textattr;
                textBackground (RED);
                mensagem ('CTINFSEN', 1);  {'Informe sua senha'}
                textBackground (BLACK);
                textColor (BLACK);
                c1 := sintEditaCampoMudo (senha, 1, wherey, 255, 80, true);
                writeln;
                textAttr := salvaAttr;
                if trim (senha) <> '' then senhaSalvaPop3 := senha;
                if (c1 = ESC) or (trim(senhaSalvaPop3) = '') then goto erro;
            end;

    StrPCopy (bufEnvia, 'PASS '+ senhaSalvaPop3 + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        begin
            senhaSalvaPop3 := '';
            goto erro;
        end;

    while bufRecebe[lidos-1] <> #$0a do
        begin
            lidos := lidos + receive (sockPOP3, @bufRecebe[lidos], BUFSIZE, 0);
            bufRecebe [lidos] := #$0;
        end;

    bufRecebe [lidos] := #$0;
    if bufRecebe [0] <> '+' then
        begin
            senhaSalvaPop3 := '';
            mensagem ('CTASENHA', 0);  {'A senha '}
            mensagem ('CTNAOACE', 1);  {' no foi aceita, servidor falou assim'}
            sintWriteln (strPas (bufRecebe));
            goto erro;
        end;

    StrPCopy (bufEnvia, 'STAT' + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if lidos <= 0 then
        goto erro;

    while bufRecebe[lidos-1] <> #$0a do
        begin
            lidos := lidos + receive (sockPOP3, @bufRecebe[lidos], BUFSIZE, 0);
            bufRecebe [lidos] := #$0;
        end;

    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, lidos);

    s := strPas (bufRecebe) + ' 0 0 ';   {sentinela}
    i := 1;
    while not (s[i] in ['0'..'9']) do i := i + 1;
    numCartasPOP3 := 0;
    while s[i] in ['0'..'9'] do
        begin
            numCartasPOP3 := (numCartasPOP3 * 10) + (ord(s[i]) - ord ('0'));
            i := i + 1;
        end;

    while not (s[i] in ['0'..'9']) do i := i + 1 ;
    numBytesPOP3 := 0;
    while s[i] in ['0'..'9'] do
        begin
            numBytesPOP3 := (numBytesPOP3 * 10) + (ord(s[i]) - ord ('0'));
            i := i + 1;
        end;

    if not trazerMudo then
        begin
            if numCartasPOP3 > 0 then
                falaQuantasNoServidor
            else
                mensagem ('CTNAOEXS', 2);  {'No existem cartas no servidor.'}

            if numCartasPOP3 > 2 then
                begin
        deNovo:
                    repeat
                        textBackground (MAGENTA);
            mensagem ('CTQUACAR', 0);   {'Quantas trago agora ? '}
                        textBackground (BLACK);
                        s := '';
                        c1 := sintEditaCampo (s, wherex, wherey, 255, 80, true);
                        writeln;
                        if not (c1 in [ENTER, ESC]) then
                            falaQuantasNoServidor;
                    until c1 in [ENTER, ESC];
                    if acessoGrupoContas then
                        if s = '0' then
                            begin
                                inicializaPOP3 := true;
                                numCartasPOP3 := 0;
                                exit;
                            end;
                    if (c1 = ESC) or (s = '0') then goto erro;
                    s2 := s;
                    if (s <> '') and (pos (';', s) <> 0) then
                        begin
                            s := copy (s, 1, pos(';', s)-1);
                            delete (s2, 1, pos (';', s2));
                            val (s, i, posErro);
                            if (posErro = 0) and (i > 0) and (numCartasPOP3 > i) then
                                primeiraCartaPop3 := i;
                        end;

                    val (s2, i, posErro);
                    if (posErro = 0) and (i > 0) and (numCartasPOP3 > i) then
                        numCartasPOP3 := i;
                end;
//            limpaBufTec;

            if (numCartasPOP3 > 0) and (not acessoServidor) then
                begin
                    repeat
                        mensagem ('CTSELINT', 0);  {'Quer selecionar interativamente ? '}
                        sintLeTecla (c1, c2);
                        writeln;
                        if not (upcase(c1) in ['S', 'N', ENTER, ESC, 'G', 'R', 'T']) then
                            falaQuantasNoServidor;
                    until upcase(c1) in ['S', 'N', ENTER, ESC, 'G', 'R', 'T'];
                    if c1 = ESC then goto erro;
                    interativoPOP3 := upcase(c1) = 'S';
                    ignoraTodas := upcase (c1) = 'G';
                    recebeTodas := upcase (c1) = 'R';
                    recebeTodas := upcase (c1) = 'T';
                end;
        end;

    inicializaPOP3 := true;
    exit;

erro:
end;

{-------------------------------------------------------------}
{       pega o tamanho da carta
{-------------------------------------------------------------}

function pegaTamanhoCarta (qual: integer): longint;
var
    s: string;
    lidos: integer;
    tamanho: longint;
    i: integer;
begin
    pegaTamanhoCarta := 0;

    str (qual, s);
    StrPCopy (bufEnvia, 'LIST ' + s + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        exit;
    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, strlen (bufRecebe));
    if bufRecebe [0] <> '+' then
        begin
            sintWriteln ('Bug na carta: ' + intToStr (qual) + ':' + strPas(bufRecebe));
            exit;
        end;

    s := strPas (bufRecebe) + ' 0 0 ' ;  { sentinela }
    i := 1;
    while not (s[i] in ['0'..'9']) do i := i + 1;
    while (s[i] in ['0'..'9']) do i := i + 1;
    while not (s[i] in ['0'..'9']) do i := i + 1;
    tamanho := 0;
    while s[i] in ['0'..'9'] do
        begin
            tamanho := (tamanho * 10) + (ord(s[i]) - ord ('0'));
            i := i + 1;
        end;

    pegaTamanhoCarta := tamanho;
end;

{-------------------------------------------------------------}
{       Ajuda das opes do recebimento interativo
{-------------------------------------------------------------}

procedure ajudaOpcInterativa;
begin
    telaPrincipal;
    textBackground (BLUE);
    mensagem ('CTAJUD01', 0); {'As opes so:'}
    textBackground (BLACK);
    writeln;
    mensagem ('CTAJIN01', 1); {'ENTER ou S - Traz a carta'}
    mensagem ('CTAJIN02', 1); {'N - No traz a carta'}
    mensagem ('CTAJIN03', 1); {'D - Liga ou desliga o debug'}
    mensagem ('CTAJIN04', 1); {'G - Ignora todas as cartas grandes'}
    mensagem ('CTAJIN05', 1); {'T - Traz todas as cartas'}
    mensagem ('CTAJIN06', 1); {'I - Informaes sobre a carta'}
    mensagem ('CTAJEN07', 1); {'ESC - Cancela'}
    if keypressed and (readkey <> ESC) then
        begin
//            limpaBufTec;
            readkey;
        end;
//    limpaBufTec;
    telaPrincipal;
end;

{-------------------------------------------------------------}
{       Seleciona as opes do recebimento interativo com as setas
{-------------------------------------------------------------}

function selSetasOpcInterativa: char;
var
    n: integer;
const
    tabOpcInterativa: string [9] = 'SNDGTIAZ'+ESC;
begin
    popupMenuCria (35, wherey, 50, 6, RED);
    MenuAdiciona ('CTAJIN01'); {'ENTER ou S - Traz a carta'}
    MenuAdiciona ('CTAJIN02'); {'N - No traz a carta'}
    MenuAdiciona ('CTAJIN03'); {'D - Liga ou desliga o debug'}
    MenuAdiciona ('CTAJIN04'); {'G - Ignora todas as cartas grandes'}
    MenuAdiciona ('CTAJIN05'); {'T - Traz todas as cartas'}
    MenuAdiciona ('CTAJIN06'); {'I - Informaes sobre a carta'}
    MenuAdiciona ('CTAJIN07'); {'A - Assunto da carta'}
    MenuAdiciona ('CTAJIN08'); {'Z - Tamanho da carta'}
    MenuAdiciona ( 'CTAJEN07'); {'ESC - Cancela'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= 9) then
        selSetasOpcInterativa := tabOpcinterativa[n]
    else
        selSetasOpcInterativa := #0;
end;

{-------------------------------------------------------------}
{       pega uma carta
{-------------------------------------------------------------}

{ Retornos }
const
    COD_OK = 0;
    COD_DESIST    = 1;
    COD_CANCELA   = 2;
    COD_ERRODISCO = 3;

function pegaUmaCartaPOP3 (qual: integer): integer;
var
    s, s2, s4, nomeTemp, nomeArqRecebe: string;
    autor, email, assunto, data, reply_to: shortString;
    temAnexo: boolean;
    tempPath, tempFileName: array [0..144] of char;
    arq: text;
    arqFile: file;
    lidos, x: integer;
    c1, c2: char;
    tamanhoAFalar: integer;

label erroDisco, pula, trazTodas;

    {-------------------------------------------------------------}

    procedure apagaCarta;
    begin
           if debug then exit;

           str (qual, s);
           StrPCopy (bufEnvia, 'DELE ' + s + CRLF);
           sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
           netDebug (bufEnvia, strlen (bufEnvia));

           lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
           if lidos > 0 then
               begin
                   bufRecebe [lidos] := #$0;
                   netDebug (bufRecebe, lidos);
               end;
    end;

    {-------------------------------------------------------------}

    procedure falaCartaInterativa;
    begin
        if temAnexo then sintBip;
        if (autor) = '' then
            sintwriteln (email)
        else
            sintWriteln (autor);
//        mensagem ('CTASSUNT', 0);  {'Assunto '}
        sintWriteln (assunto);
        if (tamanhoAFalar > 1000000) or (tamanhoAFalar > maxTamAuto) then
            begin
                mensagem ('CTTAMAN', 0); {'Tamanho '}
                sintWriteln (formataTamanhoArq (tamanhoAFalar));
            end;
    end;

    {-------------------------------------------------------------}

    procedure informaCartaInterativa;
    var tamanhoCarta: shortString;
    begin
        limpaParteTela (2, 25);
        gotoxy (1, 5);
        tamanhoCarta := formataTamanhoArq (tamanhoAFalar);
        formCria;
        formCampo     ('CTENVPOR', 'Autor: ', autor, 50);
        formCampo     ('CTEMAIL', 'e-mail: ', email, 50);
        formCampo     ('CTASSUNT', 'Assunto: ', assunto, 70);
        formCampo     ('CTDATENV', 'Data de envio: ', data, 50);
        formCampo     ('CTTAMAN', 'Tamanho da carta: ', tamanhoCarta, 15);
        formCampo     ('CTENCPAR', 'Encaminhada para: ', reply_to, 50);
        formCampoBool ('CTCOMANE',  'Contem anexo: ',  temAnexo);

        formEdita (false);
        mensagem ('CTOK', -1); {'OK'}
//        limpabuftec;
    end;

    {-------------------------------------------------------------}

begin
    pegaUmaCartaPOP3 := COD_OK;

    tamanhoAFalar := pegaTamanhoCarta (qual);

    if recebeTodas then
        goto trazTodas
    else
    if (ignoraTodas) and (tamanhoAFalar > maxTamAuto) then
        begin
            pegaUmaCartaPOP3 := COD_DESIST;
            exit;
        end
    else
    if ignoraTodas then
        goto trazTodas;

    if interativoPOP3 or (tamanhoAFalar > maxTamAuto) then
        begin
            str (qual, s);
            StrPCopy (bufEnvia, 'TOP ' + s + ' 0' + CRLF);
            sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
            netDebug (bufEnvia, strlen (bufEnvia));

            getTempPath (144, tempPath);
            getTempFileName(tempPath, 'xxx', 0, tempFileName);
            nomeTemp := strPas (tempFileName);
            if not multiLineReceive (nomeTemp, tamanhoAFalar) then
                 begin
erroDisco:
                     mensagem ('CTERRTMP', 2);  {'Problemas no arquivo temporrio'}
                     pegaUmaCartaPOP3 := COD_ERRODISCO;
                     exit;
                 end;

            assign (arq, nomeTemp);
            {$I-}  reset (arq);   {$I+}
            if ioresult <> 0 then
                goto erroDisco;

            temAnexo := false;
            while not eof (arq) do
                begin
                    readln (arq, s);
                    if s = '' then goto pula;

begin

                    if copy (s, 1, 16) = 'X-Original-From:'    then
                        begin
                            if(s <> '') and (s [length(s)] = '=') then
                                begin
                                    s4 := '';
                                    while (s <> '') and (s [length(s)] = '=') and (not  eof (arq)) do
                                        begin
                                            if (s)[1] = '=' then s := (s);
                                            decodificarString (s);
                                            s4 := s4 + s;
                                            readln (arq, s);
                                        end;
                                end
                                    else
                                begin
                                    if (s)[1] = '=' then s := (s);
                                    decodificarString (s);
                                    s4 := s;
                                end;
                            autor := limpaTexto (s4);
                            if maiuscansi (copy (autor, 1, 16)) = 'X-ORIGINAL-FROM:'    then
                                delete (autor, 1, 16);
                            x := pos ('<', autor);
                            if x <> 0 then
                                email := copy (autor,  x+1, length(autor)-(x+1))
                            else
                                email := autor;

                            x := pos ('<', autor);
                            if x > 2 then
                                autor := copy (autor, 1, x-1);
//                    if (s4) = '' then goto pula; //nenoLinhaEmTeste
                        end
                    else
                    if copy (s, 1, 8) = 'Subject:' then
                        begin
                            s := copy (s, 9, length (s)-8);
                            decodificarString(s);
                            s2 := s;
                            readln (arq, s);
                            while (s <> '') and ((s [1] = ' ') or (s [1] = TAB)) and (not  eof (arq)) do
                                begin
                                    s := (s);
                                    decodificarString(s);
                                    s2 := s2 + s;
                                    readln (arq, s);
                                end;
                            assunto := pegaPrefixoAssunto(s2) + limpaAssunto(s2);
                        end
                    else
                    if copy (s, 1, 5) = 'Date:' then
                        data := converteData (copy (s, 6, (length(s)-6)), false)
                    else
                    if copy (s, 1, 9) = 'Reply-To:' then
                    begin
                        reply_to := (copy (s, 10, (length(s)-10)));
                        s := reply_to;
                        if pos ('?', s) <> 0 then
                        begin
                        s := s + '=';
                        decodificarString(s);
                        end
                        else;
                        reply_to := s;
                    end
                    else

end;

                    if copy (s, 1, 5) = 'From:'    then
                        begin
                            if(s <> '') and (s [length(s)] = '=') then
                                begin
                                    s2 := '';
                                    while (s <> '') and (s [length(s)] = '=') and (not  eof (arq)) do
                                        begin
                                            if (s)[1] = '=' then s := (s);
                                            decodificarString (s);
                                            s2 := s2 + s;
                                            readln (arq, s);
                                        end;
                                end
                                    else
                                begin
                                    if (s)[1] = '=' then s := (s);
                                    decodificarString (s);
                                    s2 := s;
                                end;
                    if (s4) = '' then
begin
                            autor := limpaTexto (s2);
end;
                            if maiuscansi (copy (autor, 1, 5)) = 'FROM:'    then
                                delete (autor, 1, 5);
                            x := pos ('<', autor);
                            if x <> 0 then
                                email := copy (autor,  x+1, length(autor)-(x+1))
                            else
                                email := autor;
                            x := pos ('<', autor);
                            if x > 2 then
                                autor := copy (autor, 1, x-1);
                        end
                    else
                    if copy (s, 1, 8) = 'Subject:' then
                        begin
                            s := copy (s, 9, length (s)-8);
                            decodificarString(s);
                            s2 := s;
                            readln (arq, s);
                            while (s <> '') and ((s [1] = ' ') or (s [1] = TAB)) and (not  eof (arq)) do
                                begin
                                    s := (s);
                                    decodificarString(s);
                                    s2 := s2 + s;
                                    readln (arq, s);
                                end;
                            assunto := pegaPrefixoAssunto(s2) + limpaAssunto(s2);
                        end
                    else
                    if copy (s, 1, 5) = 'Date:' then
                        data := converteData (copy (s, 6, (length(s)-6)), false)
                    else
                    if copy (s, 1, 9) = 'Reply-To:' then
                    begin
                        reply_to := (copy (s, 10, (length(s)-10)));
                        s := reply_to;
                        if pos ('?', s) <> 0 then
                        begin
                        s := s + '=';
                        decodificarString(s);
                        end
                        else;
                        reply_to := s;
                    end
                    else

                    if pos ('BOUNDARY', maiuscAnsi(s)) <> 0 then
                        temAnexo := true;
                    if (s) = '' then goto pula;
                end;
pula:
            {$I-}  close (arq);  {$I+}
            if ioresult <> 0 then ;
            {$I-}  erase (arq);  {$I+}
            if ioresult <> 0 then ;

            c1 := 'a';
            repeat
                if c1 <> #0 then
                    falaCartaInterativa;
                mensagem ('CTPODTRA', 0);  {'Quer trazer ? '}
                c1 := readkey;
                if c1 = #0 then c2 := readkey;
                writeln (c1);
                if upcase(c1) in ['S', 'N', 'D', 'G', 'R', 'T', 'I'] then
//                    sintetiza (c1);

                if c1 = #0 then
                    case c2 of
                        F1: ajudaOpcInterativa;
                        F8:     falaHora;
                        CTLF8:   falaDia;
                        BAIX, CIMA: c1 := selSetasOpcInterativa;
                    end;

                case upcase (c1) of
                    'S', ENTER:; //Baixa a carta do provedor.
                    'N':    begin
                                pegaUmaCartaPOP3 := COD_DESIST;
                                repeat
                                    mensagem ('CTAPGCAR', 0);  {'Apago do servidor '}
                                    mensagem ('CTSIMNAO', 0);  {'(S/N) ?'}
                                    sintLeTecla (c1, c2);
                                    writeln;
                                    until upcase (c1) in ['S', 'N', ENTER, ESC, #0];
                                if upcase(c1) = 'S' then
                                    apagaCarta;
                                if c1 <> #0 then
                                    exit;
                            end;

                    'D':    begin
                                 debug := not debug;
                                 if debug then
                                     msgBaixo ('CTMODDEB')   {'Modo debug: cartas no sero apagadas'}
                                 else
                                     msgBaixo ('CTMODNOR');  {'Modo normal'}
                            end;

                    'G':    begin
                                ignoraTodas := true;
                                pegaUmaCartaPOP3 := COD_DESIST;
                                exit;
                            end;

                    'R':    recebeTodas := true;
                    'T':    recebeTodas := true;
                    'I': informaCartaInterativa;
                    ESC:   begin
                                pegaUmaCartaPOP3 := COD_CANCELA;
                                exit;
                            end;

                    #0, 'A': if (upcase(c1) = 'A') or (c2 = ESQ) then
                            begin
                                if temAnexo then sintBip;
                                sintetiza (assunto);
                                c1 := #0;
                            end
                        else
                            if not (c2 in [F8, CTLF8]) then
                                c1 := 'I'; //Fala remetente e assunto.


                    'Z':    begin
                mensagem ('CTTAMAN', 0); {'Tamanho '}
                                sintetiza (formataTamanhoArq (tamanhoAFalar));
                                c1 := #0;
                            end;

                else
                    mensagem ('CTOPVINV', 1); {'Opo invlida, aperte F1 para ajuda'}
                end;
            until upcase (c1) in ['S', ENTER, 'R', 'T'];
        end;

    {--- pega finalmente a carta ---}

trazTodas:
    s := intToStr (qual);
    StrPCopy (bufEnvia, 'RETR ' + s + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

//NenoNeno
    nomeArqRecebe := novoNomeCarta (nbaseRecebe, dirRecebe, '.$$$');
    if not multiLineReceive (nomeArqRecebe, tamanhoAFalar) then
        pegaUmaCartaPOP3 := COD_CANCELA
    else
        apagaCarta;
    assignFile (arqFile, nomeArqRecebe);
    {$I-} rename (arqFile, copy(nomeArqRecebe, 1, length(nomeArqRecebe)-3) + 'car');  {$I+}
    if ioresult <> 0 then
        msgBaixo ('CTPROGRV');  {'Problemas para gravar carta no disco'}

end;

{-------------------------------------------------------------}
{       Finaliza o pop3
{-------------------------------------------------------------}

function finalizaPop3: boolean;
var lidos: integer;
begin
    finalizaPop3 := false;
    if (debug) or (naoApagaCarta) then
        begin
            StrPCopy (bufEnvia, 'RSET' + CRLF);
            sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
            netDebug (bufEnvia, strlen (bufEnvia));
            lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
            netDebug (bufRecebe, lidos);
        end;

    StrPCopy (bufEnvia, 'QUIT' + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if lidos <= 0 then
        exit;
    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, lidos);
    finalizaPop3 := true;
end;

{-------------------------------------------------------------}
{  Pega uma carta temporria do servidor, o nmero da carta
{   passado atravs do parmetro 'qual'
{-------------------------------------------------------------}

function pegaUmaCartaTempPOP3 (qual: integer): integer;
var
    s, nomeTemp: string;
    tempPath, tempFileName: array [0..144] of char;
begin
    pegaUmaCartaTempPOP3 := COD_OK;

    str (qual, s);
    StrPCopy (bufEnvia, 'TOP ' + s + ' 0' + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    getTempPath (144, tempPath);
    getTempFileName(tempPath, 'xxx', 0, tempFileName);
    nomeTemp := strPas (tempFileName);
    if not multiLineReceiveRespAut (nomeTemp, true, true) then
        begin
            pegaUmaCartaTempPOP3 := COD_ERRODISCO;
            exit;
        end;
    adicionaStrListaNomeArqTemp(nomeTemp);
end;

{-------------------------------------------------------------}
{        Pega uma carta para a resposta automtica
{-------------------------------------------------------------}

{ Retornos }
const
    RESP_RECEBEU = 1;
    RESP_OK = 0;
    RESP_CANCELA   = -1;
    RESP_ERRODISCO = -2;

function pegaUmaCartaPOP3RespAut (qual: integer): integer;
var
    s, s2, nomeTemp, nomeArqRecebe: string;
    autor, email: shortString;
    tempPath, tempFileName: array [0..144] of char;
    arq: text;
    arqFile: file;
    lidos, x, i: integer;
    jaEnviado: boolean;

label erroDisco;

    {-------------------------------------------------------------}
    procedure apagaCarta;
    begin
           if debug then exit;

           str (qual, s);
           StrPCopy (bufEnvia, 'DELE ' + s + CRLF);
           sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
           netDebug (bufEnvia, strlen (bufEnvia));

           lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
           if lidos > 0 then
               begin
                   bufRecebe [lidos] := #$0;
                   netDebug (bufRecebe, lidos);
               end;
    end;
    {-------------------------------------------------------------}
begin
    pegaUmaCartaPOP3RespAut := RESP_OK;
    jaEnviado := false;

    str (qual, s);
    StrPCopy (bufEnvia, 'TOP ' + s + ' 0' + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    getTempPath (144, tempPath);
    getTempFileName(tempPath, 'xxx', 0, tempFileName);
    nomeTemp := strPas (tempFileName);
    if not multiLineReceiveRespAut (nomeTemp, true, false) then
        begin
erroDisco:
            pegaUmaCartaPOP3RespAut := RESP_ERRODISCO;
            exit;
        end;

    assign (arq, nomeTemp);
    {$I-}  reset (arq);   {$I+}
    if ioresult <> 0 then
        goto erroDisco;

    while not eof (arq) do
        begin
            readln (arq, s);
            if copy (s, 1, 5) = 'From:'    then
                begin
                    if(s <> '') and (s [length(s)] = '=') then
                         begin
                             s2 := '';
                             while (s <> '') and (s [length(s)] = '=') and (not  eof (arq)) do
                                  begin
                                      if trim(s)[1] = '=' then s := trim(s);
                                            decodificarString (s);
                                            s2 := s2 + s;
                                            readln (arq, s);
                                  end;
                         end
                    else
                         begin
                              if trim(s)[1] = '=' then s := trim(s);
                              decodificarString (s);
                              s2 := s;
                         end;
                    autor := limpaTexto (s2);
                    if maiuscansi (copy (autor, 1, 5)) = 'FROM:'    then
                         delete (autor, 1, 5);
                    x := pos ('<', autor);
                    if x <> 0 then
                         email := copy (autor,  x+1, length(autor)-(x+1))
                    else
                         email := autor;
                end
        end;

    {$I-}  close (arq);  {$I+}
    if ioresult <> 0 then ;
    {$I-}  erase (arq);  {$I+}
    if ioresult <> 0 then ;

    i := 0;
    while i < 2000 do
        begin
            if vetorEnviados[i] = email then
                begin
                    jaEnviado := true;
                    i := 2000;
                end
            else if vetorEnviados[i] = '' then
                begin
                    vetorEnviados[i] := email;
                    i := 2000;
                end;
            i := i+1;
        end;
    if jaEnviado = false then
        begin
            s := intToStr (qual);
            StrPCopy (bufEnvia, 'RETR ' + s + CRLF);
            sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
            netDebug (bufEnvia, strlen (bufEnvia));

            nomeArqRecebe := novoNomeCarta (nbaseRecebe, dirRecebe, '.$$$');
            if not multiLineReceiveRespAut (nomeArqRecebe, false, false) then
                begin
                    pegaUmaCartaPOP3RespAut := RESP_CANCELA;
                    exit;
                end
            else
                begin
                    apagaCarta;
                    assignFile (arqFile, nomeArqRecebe);
                    {$I-} rename (arqFile, copy(nomeArqRecebe, 1, length(nomeArqRecebe)-3) + 'car');  {$I+}
                    if ioresult <> 0 then
                        msgBaixo ('CTPROGRV');  {'Problemas para gravar carta no disco'}
                    criaListaCAR;
                    adicionaListaCAR (nomeArqRecebe);
                end;

            pegaUmaCartaPOP3RespAut := RESP_RECEBEU;
        end;
end;

{-------------------------------------------------------------}
{ Comunicao com o servidor POP3 para receber cartas temporrias
{ para montar a lista do folheamento interativo no servidor
{-------------------------------------------------------------}

function receberCartasServidor: integer;
var
    ncar, codPega: integer;

const
    CANCELA = -1;

label erro;
begin
    codPega := 0;

    trazerMudo := false;
    mudo := false;

    primeiraCartaPop3 := 1;
    acessoServidor := true;

    telaPrincipal;
    textBackground (MAGENTA);
//    mensagem ('CTCONTAC', 2);  {'Contactando servidor para receber correspondncia'}
    textBackGround (BLACK);

    if not inicializaPOP3 then goto erro;

    acessoServidor := false;
    totalDeCartas := numCartasPop3;
    if numCartasPop3 > 0 then criaListaNomeArqTemp;

    for ncar := primeiraCartaPop3 to numCartasPOP3 do
        begin
            cartasTrazidas := nCar;
            codPega := pegaUmaCartaTempPOP3(ncar);
            if codPega = COD_ERRODISCO then goto erro;
        end;

    if not finalizaPop3 then goto erro;
    if codPega = RESP_CANCELA then goto erro;

    fechaConexao (sockPOP3);

    if numCartasPop3 > 0 then receberCartasServidor := primeiraCartaPop3
    else receberCartasServidor := CANCELA;

    exit;

erro:
    acessoServidor := false;
    if sockPOP3 >= 0 then
        fechaConexao (sockPOP3);
    writeln;
    while keypressed do readkey;
    mensagem ('CTCONCAN', 1);  {'Conexao com servidor foi cancelada'}
    receberCartasServidor := CANCELA;
end;

{-------------------------------------------------------------}
{       comunicao com o servidor POP3
{-------------------------------------------------------------}

function receberCartas (opcaoMudo: boolean): integer;
var
    ncar, quantasReceber, codPega, esperaPOP3: integer;
    apagadasDoServidor: integer;
    s: string;
    c1, c3, c4: char;
    chegoulaco: boolean;

label  erro, laco;
begin
    chegoulaco := false;
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao + ' - Recebendo...');
    receberCartas := 0;
    codPega := 0;
    if opcaoMudo then
        trazerMudo := true
    else
        trazerMudo := false;

    s := sintAmbiente ('CARTAVOX', 'CLEK');
    if trim (s) = '' then
        mudo := false
    else
        mudo := copy (s, 1, 1) = 'N';
    s := sintAmbiente ('CARTAVOX', 'ESPERAPOP3');
    if trim (s) = '' then
        esperaPOP3 := 1
    else
        esperaPOP3 := strToInt (s) * 1000;

    interativoPOP3 := false;
    ignoraTodas := false;
    recebeTodas := false;
    primeiraCartaPop3 := 1;
    apagadasDoServidor := 0;

    telaPrincipal;
    textBackground (MAGENTA);
    if trazerMudo  then
    write (pegaTextoMensagem ('CTCONTAC'))  {'Contactando servidor para receber correspondncia'}
    else
begin

            textBackground (MAGENTA);
            mensagem ('CTLIMPAC', 0);  {'Limpa a conta? '}
            textBackground (BLACK);
            sintLeTecla (c3, c4);

                if upcase (c3) in ['S', ENTER] then
begin
                        mataSpam;
                                end;

//        mensagem ('CTCONTAC', 1);  {'Contactando servidor para receber correspondncia'}
    textBackGround (BLACK);
    writeln;
end;

    if not inicializaPOP3 then goto erro;

    totalDeCartas := numCartasPop3;
    trazerMudo := true;
    for ncar := primeiraCartaPop3 to numCartasPOP3 do
laco:
        begin
            cartasTrazidas := ncar;
            textBackGround (BROWN);
            if interativoPOP3 or
               (not mudo and (ignoraTodas or recebetodas)) then
                begin
//                    mensagem ('CTCARTA', 0);  {'carta'}
                    write (' ');
                    sintWriteint (ncar);
                end
            else
                write ('Carta ', ncar);

            textBackGround (BLACK);
            writeln;

            codPega := pegaUmaCartaPOP3 (ncar - apagadasDoServidor);
            if codPega = COD_CANCELA then
                chegoulaco := true;
            if codPega in [COD_CANCELA, COD_ERRODISCO]  then goto erro;

        s := sintAmbiente ('CARTAVOX', 'QUANTASRECEBER');
        if (s) = '' then quantasReceber := 25
        else quantasReceber := strToInt (s);

            if (esperaPOP3 >= 0) and (not interativoPop3) and (not debug) and ((ncar mod quantasReceber) = 0) then
                begin
                    if not finalizaPop3 then goto erro;
                    fechaConexao (sockPOP3);
                    delay (esperaPOP3);
                    if not inicializaPOP3 then goto erro;
                    apagadasDoServidor := apagadasDoServidor + quantasReceber;
                end;
        end;

    if not     finalizaPop3 then goto erro;
    if codPega = COD_CANCELA then goto erro;

    fechaConexao (sockPOP3);
    if (numCartasPop3 > 0) and not opcaoMudo then
        mensagem ('CTOKPEG', 1);  {'Ok, peguei a correspondncia'}
    if numCartasPop3 > 0 then
        receberCartas := cartasTrazidas;

    if (aplicRegras) and (numCartasPop3 > 0) then
        aplicarRegrasCartas('N');

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
    exit;

erro:
    if chegoulaco then
    begin
        repeat
            writeln;
            mensagem ('CTCANREC', 0); {'Deseja cancelar o recebimento das cartas?:'}
            c1 := readkey ;
        until upcase (c1) in ['S', 'N', ENTER, ESC];
        if upcase (c1) in ['N', ESC] then
            goto laco;
    end;
    if sockPOP3 >= 0 then
        fechaConexao (sockPOP3);
    writeln;
    while keypressed do readkey;
    mensagem ('CTCONCAN', 2);  {'Conexao com servidor foi cancelada'}
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
end;

{-------------------------------------------------------------}
{  comunicao com o servidor POP3 para o grupo de contas
{-------------------------------------------------------------}

function receberCartasGrupoContas (opcaoMudo: boolean): integer;
var
    ncar, codPega, esperaPOP3: integer;
    apagadasDoServidor: integer;
    s: string;
    c1: char;
    chegoulaco: boolean;

label  erro, laco;
begin
    chegoulaco := false;
    ncar := 0;
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao + ' - Recebendo...');
    receberCartasGrupoContas := -1;
    codPega := 0;
    if trim (senhaSalvaPop3) = '' then
        trazerMudo := false
    else
    if opcaoMudo then
        trazerMudo := true
    else
        trazerMudo := false;

    s := sintAmbiente ('CARTAVOX', 'CLEK');
    if trim (s) = '' then
        mudo := false
    else
        mudo := copy (s, 1, 1) = 'N';
    s := sintAmbiente ('CARTAVOX', 'ESPERAPOP3');
    if trim (s) = '' then
        esperaPOP3 := 1
    else
        esperaPOP3 := strToInt (s) * 1000;

    interativoPOP3 := false;
    ignoraTodas := false;
    recebeTodas := false;
    primeiraCartaPop3 := 1;
    apagadasDoServidor := 0;

    telaPrincipal;
    textBackground (MAGENTA);
    if trazerMudo  then
        write('Acessando conta ' + nomeConfiguracao)
    else
        begin
//            mensagem ('CTCONTAC', 0); {'Contactando servidor para receber correspondncia'}
            sintWriteln(nomeConfiguracao);
        end;
    textBackGround (BLACK);
    writeln;

    acessoGrupoContas := true;
    if not inicializaPOP3 then goto erro;
    acessoGrupoContas := false;
    totalDeCartas := numCartasPop3;
    trazerMudo := true;
    for ncar := primeiraCartaPop3 to numCartasPOP3 do
laco:
        begin
            cartasTrazidas := ncar;
            textBackGround (BROWN);
            if (interativoPOP3 and (not (ignoraTodas or recebetodas))) or
               (not mudo and (ignoraTodas or recebetodas)) then
                begin
                    mensagem ('CTCARTA', 0);  {'carta'}
                    write (' ');
                    sintWriteint (ncar);
                end
            else
                write ('Carta ', ncar);

            textBackGround (BLACK);
            writeln;

            codPega := pegaUmaCartaPOP3 (ncar - apagadasDoServidor);
            if codPega = COD_CANCELA then
                chegoulaco := true;
            if codPega in [COD_CANCELA, COD_ERRODISCO]  then goto erro;

            if (esperaPOP3 >= 0) and (not interativoPop3) and (not debug) and
                ((ncar mod 25) = 0) and (nCar < numCartasPOP3) then
                begin
                    if not finalizaPop3 then goto erro;
                    fechaConexao (sockPOP3);
                    delay (esperaPOP3);
                    if not inicializaPOP3 then goto erro;
                    apagadasDoServidor := apagadasDoServidor + 25;
                end;
        end;

    ncar := 0;
    if not     finalizaPop3 then goto erro;
    if codPega = COD_CANCELA then goto erro;

    fechaConexao (sockPOP3);
    if (numCartasPop3 > 0) and not opcaoMudo then
        mensagem ('CTOKPEG', 1);  {'Ok, peguei a correspondncia'}
    if numCartasPop3 >= 0 then
        receberCartasGrupoContas := numCartasPop3;

    if (aplicRegras) and (numCartasPop3 > 0) then
        aplicarRegrasCartas('N');

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
    exit;

erro:
    if chegoulaco then
    begin
        repeat
            writeln;
            mensagem ('CTCANREC', 0); {'Deseja cancelar o recebimento das cartas?:'}
            c1 := readkey ;
        until upcase (c1) in ['S', 'N', ENTER, ESC];
        if upcase (c1) in ['N', ESC] then
            goto laco;
    end;
    if sockPOP3 >= 0 then
        fechaConexao (sockPOP3);
    writeln;
    while keypressed do readkey;
    acessoGrupoContas := false;
    mensagem ('CTCONCAN', 2);  {'Conexao com servidor foi cancelada'}
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
end;


{-------------------------------------------------------------}
{  Comunicao com o servidor POP3 para a resposta automtica
{-------------------------------------------------------------}

function receberCartasRespAut(primeiraPassagem: boolean; cartasExistentes, cartasChegadas: integer): integer;
var
    codPega: integer;
    cartasRecebidas, i: integer;
    s: string;

label  erro;
begin
    receberCartasRespAut := 0;
    cartasRecebidas := 0;
    codPega := 0;
    trazerMudo := true;

    if primeiraPassagem = true then
        begin
           for i := 0 to 2000 do
               begin
                   vetorEnviados[i] := '';
               end;
        end;

    s := sintAmbiente ('CARTAVOX', 'CLEK');
    if trim (s) = '' then
        mudo := false
    else
        mudo := copy (s, 1, 1) = 'N';
    s := sintAmbiente ('CARTAVOX', 'ESPERAPOP3');

    interativoPOP3 := false;
    ignoraTodas := false;
    recebeTodas := false;

    if not inicializaPOP3 then goto erro;

    trazerMudo := true;
    while cartasChegadas > cartasExistentes do
        begin
            codPega := pegaUmaCartaPOP3RespAut (cartasChegadas);

            if (codPega = RESP_CANCELA) or (codPega = RESP_ERRODISCO) then goto erro;
            if codPega = RESP_RECEBEU then cartasRecebidas := cartasRecebidas + 1;
            cartasChegadas := cartasChegadas - 1;
        end;

    if not     finalizaPop3 then goto erro;
    if codPega = RESP_CANCELA then goto erro;

    fechaConexao (sockPOP3);
    if numCartasPop3 > 0 then
        receberCartasRespAut := cartasRecebidas;

    if (aplicRegras) and (numCartasPop3 > 0) then
        aplicarRegrasCartas('N', true);

    exit;

erro:
    if sockPOP3 >= 0 then
        fechaConexao (sockPOP3);
    writeln;
    while keypressed do readkey;
    mensagem ('CTCONCAN', 1);  {'Conexao com servidor foi cancelada'}
    receberCartasRespAut := -1;
end;

{-------------------------------------------------------------}
{  Imprime o tamanho total de cartas ocupado pelas cartas no servidor
{-------------------------------------------------------------}

procedure tamanhoTotalServidor;
label erro;
begin
    trazerMudo := true;
    mudo := true;
    if not inicializaPOP3 then exit;
    if not finalizaPop3 then exit;
    fechaConexao (sockPOP3);

    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTTAMAN', 0); {'Tamanho '}
    write ('  ');
    sintWrite (formataTamanhoArq (numBytesPOP3) + ' no servidor');
    textBackground (BLACK);
    writeln;
end;

{-------------------------------------------------------------}
{  Apaga do cartavox as cartas cujos nmeros so passados
{  atravs do parmetro 'vetorAApagar'
{-------------------------------------------------------------}

function apagaCartaServidor(vetorAApagar: Array of integer; primeiraCartaPop3: integer): integer;
var
    s: string;
    lidos, i: integer;
label erro;

begin
    i := 0;
    trazerMudo := true;
    if not inicializaPOP3 then goto erro;

    while vetorAApagar[i] <> -1 do
        begin
            str (vetorAApagar[i] + primeiraCartaPop3 - 1, s);
            StrPCopy (bufEnvia, 'DELE ' + s + CRLF);
            sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
            netDebug (bufEnvia, strlen (bufEnvia));

            lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
            if bufRecebe[0] <> '+' then
                begin
                    mensagem ('CTERRSRV', 1);   {'Erro no servidor, veja o que ele disse:'}
                    sintWriteln (strPas(bufRecebe));
                    goto erro;
                end;
            if lidos > 0 then
                begin
                    bufRecebe [lidos] := #$0;
                    netDebug (bufRecebe, lidos);
                end;
            i := i+1;
        end;

    if not finalizaPop3 then goto erro;
    fechaConexao (sockPOP3);
    apagaCartaServidor := 0;
    exit;

erro:
    apagaCartaServidor := -1;
end;

{-------------------------------------------------------------}
{  Traz para o cartavox as cartas cujos nmeros so passados
{  atravs do parmetro 'vetorATrazer'
{  O parmetro 'naoApagar' indica se a carta ser ou no apagada
{  do servidor
{-------------------------------------------------------------}

function trazCartaServidor(vetorATrazer: Array of integer; naoApagar: boolean; primeiraCartaPop3: integer; email: string): integer;
var
    s, nomeArqRecebe: string;
    i, lidos, x: integer;
    arqFile: file;
label erro;

{-------------------------------------------------------------}
    procedure apagaCartaServidor;
    begin
        str (vetorATrazer[i] + primeiraCartaPop3 - 1, s);
        StrPCopy (bufEnvia, 'DELE ' + s + CRLF);
        sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
        netDebug (bufEnvia, strlen (bufEnvia));

        lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
        if lidos > 0 then
            begin
                bufRecebe [lidos] := #$0;
                netDebug (bufRecebe, lidos);
            end;
    end;
{-------------------------------------------------------------}

begin
    trazerMudo := true;
    if not inicializaPOP3 then goto erro;

    x := pos ('@', email);
    delete(email, 1, x);
    x := pos ('.', email);
    delete(email, x, length(email));
    i := 0;
    while vetorATrazer[i] <> -1 do
        begin
            if (email = 'bol') and (naoApagar) then
                begin
                    s := intToStr (vetorATrazer[i] + primeiraCartaPop3 - 1);
                    StrPCopy (bufEnvia, 'TOP ' + s + ' 100000' + CRLF);
                    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
                    netDebug (bufEnvia, strlen (bufEnvia));

                    nomeArqRecebe := novoNomeCarta (nbaseRecebe, dirRecebe, '.$$$');
                    if not multiLineReceiveRespAut (nomeArqRecebe, true, true) then goto erro;
                    assignFile (arqFile, nomeArqRecebe);
                    {$I-} rename (arqFile, copy(nomeArqRecebe, 1, length(nomeArqRecebe)-3) + 'car');  {$I+}
                    if ioresult <> 0 then
                        msgBaixo ('CTPROGRV');  {'Problemas para gravar carta no disco'}
                    i := i+1;
                end
            else
                begin
                    s := intToStr (vetorATrazer[i] + primeiraCartaPop3 - 1);
                    StrPCopy (bufEnvia, 'RETR ' + s + CRLF);
                    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
                    netDebug (bufEnvia, strlen (bufEnvia));

                    nomeArqRecebe := novoNomeCarta (nbaseRecebe, dirRecebe, '.$$$');
                    if not multiLineReceiveRespAut (nomeArqRecebe, true, true) then
                        goto erro;
                    apagaCartaServidor;
                    assignFile (arqFile, nomeArqRecebe);
                    {$I-} rename (arqFile, copy(nomeArqRecebe, 1, length(nomeArqRecebe)-3) + 'car');  {$I+}
                    if ioresult <> 0 then
                        msgBaixo ('CTPROGRV');  {'Problemas para gravar carta no disco'}
                    i := i+1;
                end;
        end;

    if naoApagar then naoApagaCarta := true;
    if not finalizaPop3 then goto erro;
    naoApagaCarta := false;
    fechaConexao (sockPOP3);

    trazCartaServidor := 0;
    exit;
erro:
    naoApagaCarta := false;
    trazCartaServidor := -1;
end;

{-------------------------------------------------------------}
{  Pede ao usurio que digite a senha de sua conta para
{  verificar se ela  vlida
{-------------------------------------------------------------}

function senhaValida(iHostPop3, iContaUsuario: shortString; iPortaPOP3: integer; iUsaSSL: boolean): boolean;
var
    lidos: integer;
    salvaAttr: word;
    senha: string;
    c1: char;
label erro;

begin
    senhaValida := false;
    sockPOP3 := abreConexao (iHostPop3, iPortaPOP3, true);
    if sockPOP3 = -1 then
        goto erro;

    if iUsaSSL then
        if not ativaSSL(sockPOP3) then
            begin
                mensagem ('CTSSLNAO', 2);   {'Segurana SSL no pode ser ativada'}
                fechaConexao (sockPOP3);
                goto erro;
            end;

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        goto erro;
    bufRecebe [lidos] := #$0;
    netDebug (bufRecebe, lidos);
    StrPCopy (bufEnvia, 'USER '+ iContaUsuario + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        goto erro;
    bufRecebe [lidos] := #$0;

    if bufRecebe [0] <> '+' then
        begin
            mensagem ('CTACONT', 0);  {'A conta '}
            sintwrite (iContaUsuario);
            mensagem ('CTNAOACE', 1);  {' no foi aceita, servidor falou assim'}
            sintWriteln (strPas (bufRecebe));
            goto erro;
        end
    else
        netDebug (bufRecebe, lidos);

    if trim (senhaSalvaPop3) = '' then
        begin
            senha := '';
            salvaAttr := textattr;
            textBackground (RED);
            mensagem ('CTINFSEN', 1);  {'Informe sua senha'}
            textBackground (BLACK);
            textColor (BLACK);
            c1 := sintEditaCampoMudo (senha, 1, wherey, 255, 80, true);
            writeln;
            textAttr := salvaAttr;
            if trim (senha) <> '' then senhaSalvaPop3 := senha;
            if (c1 = ESC) or (trim(senhaSalvaPop3) = '') then goto erro;
        end;

    StrPCopy (bufEnvia, 'PASS '+ senhaSalvaPop3 + CRLF);
    sendbuf (sockPOP3, bufEnvia, strlen (bufEnvia), 0);
    netDebug (bufEnvia, strlen (bufEnvia));

    lidos := receive (sockPOP3, bufRecebe, BUFSIZE, 0);
    if (lidos <= 0) then
        begin
            senhaSalvaPop3 := '';
            goto erro;
        end;
    bufRecebe [lidos] := #$0;
    if bufRecebe [0] <> '+' then
        begin
            senhaSalvaPop3 := '';
            mensagem ('CTASENHA', 0);  {'A senha '}
            mensagem ('CTNAOACE', 1);  {' no foi aceita, servidor falou assim'}
            sintWriteln (strPas (bufRecebe));
            goto erro;
        end;

    if not finalizaPop3 then goto erro;
    fechaConexao (sockPOP3);

    senhaValida := true;
    exit;

erro:
end;

{-------------------------------------------------------------}
begin
end.
