{-------------------------------------------------------------}
{
{       Programa de correio, cliente SMTP e POP3
{
{       Autor: Jose' Antonio Borges
{       Em 10 de abril de 1998
{
{       Atualizado por: Neno Henrique da Cunha Albernaz
{       De 2002 a 2015
{
{-------------------------------------------------------------}

{-------------------------------------------------------------}
{       arquivos de inclusao obrigatoria
{-------------------------------------------------------------}

program Cartavox;
uses
    dvcrt,
    dvform,
    dvhora,
    dvWin,
    sysutils,
    windows,
    videovox,
    carApeli,
    carConf,
    carDecod,
    carEnvia,
    carFolhe,
    carList,
    carMonit,
    carMsg,
    carpreli,
    carPop3,
    carRede,
    carSMTP,
    carTela,
    carUtil,
    carVars,
    carRegras,
    carResp,
    carFolInt,
    carSpam,
    carIMAP,
    carCont;

{-------------------------------------------------------------}
{       rotina de inicializacao
{-------------------------------------------------------------}

procedure inicializa;
var s: string;
    avisaConfiguracao: boolean;  { Avisa a configurao ao ser carregado o Dosvox }
    sz: array [0..144] of char;
     erro: integer;
     velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
     par: string;
     c: char;
begin
    randomize;
    debug := false;
//    sintInic (0, sintambiente ('CARTAVOX', 'DIRCARTAVOX'));

    dirSomCartavox := sintAmbiente ('CARTAVOX', 'DIRCARTAVOX');

    s := sintAmbiente ('CARTAVOX', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 3
    else
        val (s, velGeral, erro);
    sintInic (velGeral, DirSomCartavox);

    c := primeiraLetra (sintAmbiente('CARTAVOX', 'SAPIATIVADO'));

    if trim(c) = '' then
        begin
            comSapi := copy (sintAmbiente ('TRADUTOR', 'SAPI'), 1, 1) <> 'N';
            if comSapi then
                begin
                    val (sintAmbiente('SERVFALA', 'VOZ'), confNum, erro);
                    if erro <> 0 then val (sintAmbiente('CARTAVOX', 'NUMEROSAPI'), confNum, erro);
                    if erro <> 0 then confNum := 1;

                    val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
                    if erro <> 0 then val (sintAmbiente('CARTAVOX', 'TIPOSAPI'), confTipoSapi, erro);
                    if erro <> 0 then confTipoSapi := 3;

                    val (sintAmbiente('SERVFALA', 'TOM'), confTonal, erro);
                    if erro <> 0 then val (sintAmbiente('CARTAVOX', 'TONALIDADESAPI'), confTonal, erro);
                    if erro <> 0 then confTonal:= 0;

                    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
                end;
        end
    else
        begin
            comSapi := upcase(c) = 'S';
            val (sintAmbiente('CARTAVOX', 'NUMEROSAPI'), confNum, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'VOZ'), confNum, erro);
            if erro <> 0 then confNum := 1;

            val (sintAmbiente('CARTAVOX', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then confTipoSapi := 3;

            val (sintAmbiente('CARTAVOX', 'VELOCIDADESAPI'), confVeloc, erro);
            if erro <> 0 then confVeloc:= 0;
            val (sintAmbiente('CARTAVOX', 'TONALIDADESAPI'), confTonal, erro);
            if erro <> 0 then confTonal:= 0;

            sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
        end;

    setWindowText (crtWindow, 'CARTAVOX');
    clrscr;
//    limpaBufTec;
    textBACKGROUND (BLUE);
    mensagem ('CTINIC1', 0);  {'CARTAVOX - Correio Eletrnico - NCE/UFRJ - v.'}
    writeln (VERSAO);
{    sintetiza (VERSAO);}
    textBackground (BLACK);
    writeln;

    s := sintAmbiente ('CARTAVOX', 'AVISACONFIGURACAO');
    if s = '' then
    begin
    avisaConfiguracao := copy (sintAmbiente ('CARTAVOX', 'AVISACONFIGURACAO'), 1, 1) = 'N';
    end
    else
    avisaConfiguracao := copy (sintAmbiente ('CARTAVOX', 'AVISACONFIGURACAO'), 1, 1) <> 'N';
        if avisaConfiguracao then
begin
    nomeConfiguracao := sintAmbiente ('CARTAVOX', 'CONFIGURACAO');
    delay (5);
                            sintetiza (nomeConfiguracao);
    end;

    nomeConfiguracao := sintAmbiente ('CARTAVOX', 'CONFIGURACAO');
    if nomeConfiguracao <> '' then
        begin
            strPCopy (sz, 'CARTAVOX ' + nomeConfiguracao);
            setWindowText (crtWindow, sz);
        end;

    nomeArqspams := sintAmbiente ('CARTAVOX', 'ARQBLOQUEADOS');

    pegaConfigInicial;

    if (hostSMTP = '') or (hostPOP3 = '') or (enderUsuario = '') or (contaUsuario = '') or
       (dirRecebe = '') or (dirEnvia = '') then
            configurar;

    nbaseEnvia  := 0;
    nbaseRecebe := 0;
    nbaseCopia  := 0;
    pCC  := NIL;
    pBCC := NIL;

    abreRede;

    if paramCount >= 1 then
        prepararCarta ('P', 0, false, paramStr(1), pegaDirAtual);
end;

{-------------------------------------------------------------}
{       ajuda
{-------------------------------------------------------------}

procedure ajuda;
begin
    telaPrincipal;
    mensagem ('CTAJUD01', 1);  {'As opes so'}
    mensagem ('CTAJUD02', 1);  {'  E   enviar carta'}
    mensagem ('CTAJUD03', 1);  {'  T   transmitir cartas escritas'}
    mensagem ('CTAJUD04', 1);  {'  R   receber cartas do correio'}
    mensagem ('CTAJUD05', 1);  {'  F   folhear as cartas j recebidas'}
    mensagem ('CTAJUD06', 1);  {'  C   configurar o programa'}
    mensagem ('CTSETOPC', 1);  {'Use as setas para conhecer outras opes'}

//    limpaBufTec;
    sintBip;
end;

{--------------------------------------------------------}
{       seleciona a opo com as setas
{--------------------------------------------------------}

function selSetasOpcao: char;
var n: integer;
const
    tabLetrasOpcoes: string [20] = 'etrfnlicvamzqsbujkxy';

begin
    telaPrincipal;
    writeln (pegaTextoMensagem ('CTAJUD01'));  {'As opes so'}
    popupMenuCria (wherex, wherey, 50, 20, MAGENTA);
    MenuAdiciona ('CTAJUD02');  {'  E   enviar carta'}
    MenuAdiciona ('CTAJUD03');  {'  T   transmitir cartas escritas'}
    MenuAdiciona ('CTAJUD04');  {'  R   receber cartas do correio'}
    MenuAdiciona ('CTAJUD05');  {'  F   folhear as cartas j recebidas'}
    MenuAdiciona ('CTAJUD5A');  {'  N   Folhear as cartas no lidas'}
    MenuAdiciona ('CTAJUD5B');  {'  L   Folhear as cartas lidas'}
    MenuAdiciona ('CTAJUD5C');  {'  I   Informar configurao atual'}
    MenuAdiciona ('CTAJUD06');  {'  C   configurar o programa'}
    MenuAdiciona ('CTAJUD6A');  {'  V   verificar cartas preparadas ou transmitidas'}
    MenuAdiciona ('CTAJUD07');  {'  A   editar apelidos'}
    MenuAdiciona ('CTAJUD08');  {'  M   monitorar correio'}
    MenuAdiciona ('CTAJUD09');  {'  Z   apagar cartas duplicadas no lidas'}
    MenuAdiciona ('CTAJUD10');  {'  Q   informar total de cartas'}
    MenuAdiciona ('CTAJUD11');  {'  S   mata Spam'}
    MenuAdiciona ('CTAJUD12');  {'  B   Regras'}
    MenuAdiciona ('CTAJUD13');  {'  U   Resposta automtica'}
    MenuAdiciona ('CTAJUD14');  {'  J   Folhear cartas no servidor'}
    MenuAdiciona ('CTAJUD15');  {'  K   Grupo de contas'}
    MenuAdiciona ('CTAJUD16');  {'  X   Conexo com IMAPUtil'}
    MenuAdiciona ('CTAJUD17');  {'  Y   Mata Spam nas cartas no lidas'}

    n := popupMenuSeleciona;
    if (n > 0) and (n <= 20) then
        selSetasOpcao := tabLetrasOpcoes[n]
    else
        selSetasOpcao := ENTER;
end;

{--------------------------------------------------------}
{       verificar cartas enviadas
{--------------------------------------------------------}

procedure verificarPreparadasOuTransmitidas;
var
    c: char;
begin
    repeat
        telaPrincipal;
        msgBaixo ('CTQUEVER');    {'Verificar preparadas ou transmitidas ? '}
        c := upcase (readkey);
    until c in ['T', 'P', ^T, ^P, ESC];

    if c = esc then
        msgBaixo ('CTDESIST')
    else
        folhearCartas (c);
end;

{-------------------------------------------------------------}
{       Fala nmero de cartas nos folheamentos
{-------------------------------------------------------------}

procedure falaNumeroTotalDeCartas;
var
    i: integer;
    dirVazio: boolean;
begin
    dirVazio := true;
    i := numeroDeCartas ('P');
    if i > 0 then
        begin
            mensagem  ('CTPREPAR', 0); {'Preparadas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('N');
    if i > 0 then
        begin
            mensagem  ('CTNAOLID', 0); {'No lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('L');
    if i > 0 then
        begin
            mensagem ('CTLIDAS', 0); {'Lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartas ('T');
    if i > 0 then
        begin
            mensagem ('CTTRANSM', 0); {'Transmitidas'}
            sintwriteln ('  ' + intTostr(i));
            dirVazio := false;
        end;
    if dirVazio then
        mensagem ('CTSEMCAR', 1); {'No tem carta neste diretrio'}
    writeln;
end;

{-------------------------------------------------------------}
{       Rotina de saida do Cartavox
{-------------------------------------------------------------}

function terminaPrograma: boolean;
var
    c1, c2: char;
    sair: boolean;
begin
    sair := false;
    telaPrincipal;
    if perguntaAoSair then
        begin
            repeat
                msgBaixo ('CTCONSAI'); {'Confirma saida do Cartavox?'}
                sintletecla (c1, c2);
            until upcase (c1) in ['S', 'N', ENTER, ESC];
            if upcase (c1) in ['S', ENTER] then
                sair := true;
        end
    else
        sair := true;

    if sair then
        sair := not transmitirPreparadas;

    if not sair then
        begin
            msgBaixo ('CTDESIST'); {'Desistiu'}
        telaPrincipal;
        end;

    TerminaPrograma := sair;
end;

{-------------------------------------------------------------}
{                     programa principal
{-------------------------------------------------------------}

var
    c1, c2: char;
    dirAtual: string;
    s: string;
    avisaCartas: boolean;  { Avisa se tem cartas ao ser carregado o Dosvox }
    nCarRecebidas: integer;
    k, l, m, n, o: integer;
c: char;
    processando: boolean;
    sz, szNomeConfig: array [0..144] of char;
    nomeConfig: string;
label executa;
begin
    inicializa;
    delay (80);
    s := sintAmbiente ('CARTAVOX', 'AVISACARTAS');
    if s = '' then
    begin
    avisaCartas := copy (sintAmbiente ('CARTAVOX', 'AVISACARTAS'), 1, 1) = 'N';
    end
    else
    avisaCartas := copy (sintAmbiente ('CARTAVOX', 'AVISACARTAS'), 1, 1) <> 'N';
        if avisaCartas then
begin
    k := temCartasAEnviar;
    if k > 0 then
begin
    textBackGround (MAGENTA);
    if k = 1 then
begin
        mensagem ('CTEXTCA3', 0); {'Ateno, ainda existe uma carta a ser enviada'}
    write (' ');
end;
    if k = 2 then
begin
        mensagem ('CTEXTCA1', 0); {'Ainda existem'}
//    sintwriteInt(k);
    write (' ');
            mensagem ('CTDUAS', 0);  {'Duas'}
        mensagem ('CTEXTCA2', 0); {'cartas a serem enviadas'}
//    sintwriteInt(k);
    write (' ');
end;
    if k > 2 then
begin
        mensagem ('CTEXTCA1', 0); {'Ainda existem'}
    sintwriteInt(k);
    write (' ');
        mensagem ('CTEXTCA2', 0); {'cartas a serem enviadas'}
end;
end;
    textBackGround (BLACK);
            writeln;writeln;
    end;
    delay (80);

    getDir(0, dirAtual);
    processando := true;
    while (processando)  do
        begin
            textBackground (BLUE);
            mensagem ('CTQUALOP', 0);  {'Qual sua opo ? '}
            textBackground (BLACK);
           sintLeTecla (c1, c2);
           writeln;
            if (c1 = #0) and (c2 in [CIMA, BAIX, F9]) then
                begin
                    c1 := selSetasOpcao;
                    goto executa;
                end
           else
           if (c1 = #0) and (c2 = F1) then
               ajuda
           else
           if (c1 = #0) and (c2 = CTLF8) then
               falaDia
           else
           if (c1 = #0) and (c2 = F11) then
begin
    adicionaOriginal := not adicionaOriginal;
    if adicionaOriginal then
    mensagem ('CTCOMORI', 1)  {'Com original'}
    else
    mensagem ('CTSEMORI', 1);  {'Sem original'}
end
           else
           if (c1 = #0) and (c2 = F4) then
begin
        mensagem ('CTVELOC', 1);  {'Qual a velocidade, de 1 a 5'}
    sintLeTecla (c, c2);
    writeln;
    if c in ['1'..'5'] then
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end
           else
           if (c1 = #0) and (c2 = CTLF4) then
begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end
           else
           if (c1 = #0) and (c2 = CTLF3) then
begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end
else
           if (c1 = #0) and (c2 = CTLF2) then
begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end
           else
           if (c1 = #0) and (c2 = CTLF1) then
begin
c := '2';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end
else

executa:
            case upcase(c1) of
                '.': leitorDeTela;
                'E': prepararCarta ('P', 0, false, '', dirAtual);
                ^U: prepararCarta ('T', 0, false, '', dirAtual);
                'T':  transmitirCartas (false, 'P');
                'R', ^R: begin
                            nCarRecebidas := receberCartas (c1 = ^R);
                            if c1 = ^R then
                                if nCarRecebidas <= 0 then
                                    mensagem ('CTNAOEXS', 1) {'No existem cartas no servidor.'}
                                else
                                   begin
                                        mensagem ('CTRECEBI', 0); {'Recebidas'}
                                        write (': ');
                                        sintWriteint (nCarRecebidas);
                                        writeln;
                                end;
                            if autoEnviaDuplicadasLixeira then
                                removeCartasDuplicadas (false);
                     end;
                'F', 'N', 'L', ^F, ^N, ^L:  folhearCartas (upcase(c1));
    '[': begin sintetiza ('verso'); sintetiza (VERSAO); end;
                    ^X: begin
delay (3);
    SintFim;
    doneWinCrt;
end;
                'J', ^J: folhearCartasServidor(c1);
                'G', ^G: begin
                        agruparPorAssunto := true;
                        if c1 = ^G then
                            folhearCartas (^N, '')
                        else
                            folhearCartas ('N', '');
                    end;
                    'I' : begin
                    mudafala := not mudafala;
                    if mudafala then
                begin
                         delay (1);
                         sintetiza (nomeConfiguracao);
                         delay (2);
                      end
                    else
                begin
                         sintSoletra (nomeConfiguracao);
                         delay (2);
                      end;
                      end;

                ^I:   begin
                    FALANOMEPRIMEIRO  := not FALANOMEPRIMEIRO ;
                    if FALANOMEPRIMEIRO  then
                begin
    mensagem ('CTNOMPRI', 1);  {'Nome primeiro'}
                         delay (2);
                      end
                    else
                begin
                         delay (1);
    mensagem ('CTASSPRI', 1);  {'Assunto primeiro'}
                         delay (2);
                      end;
                      end;

                ^V:   begin
                    cabecalhoResumido  := not cabecalhoResumido ;
                    if cabecalhoResumido  then
                begin
    mensagem ('CTCABRES', 1);  {'Cabealho resumido'}
                         delay (2);
                      end
                    else
                begin
                         delay (1);
    mensagem ('CTCABCPL', 1);  {'Cabealho completo'}
                         delay (2);
                      end;
                      end;

'Q': begin
    k := temCartasAEnviar;

    if k = 0 then
begin
            write (' ');
    mensagem ('CTNENPRP', 0); {'Nenhuma carta preparada'}
end;

    if k = 1 then
begin
            write (' ');
    mensagem ('CTUMAPRP', 0); {'Uma carta preparada'}
end;

    if k = 2 then
begin
            write (' ');
    mensagem ('CTDUAPRP', 0); {'Duas cartas preparadas'}
end;

    if k > 2 then
        begin
            write (' ');
            sintWriteInt (k);
            mensagem ('CTPRP', 0);   {'Preparadas'}
end;

begin
begin
begin
    m := temCartasRecebidas;
    n := temCartasLidas;

                    o := m - n;

    if o = 0 then
        begin
            write (' ');
    mensagem ('CTNENNLI', 0); {'Nenhuma carta no lida'}
end;

    if o = 1 then
        begin
            write (' ');
    mensagem ('CTUMANLI', 0); {'Uma carta no lida'}
end;

    if o = 2 then
        begin
            write (' ');
    mensagem ('CTDUANLI', 0); {'Duas cartas no lidas'}
end;

    if o > 2 then
        begin
            write (' ');
            sintWriteInt (o);
            mensagem ('CTNAOLID', 0);   {'No lidas'}
end;

    if n = 0 then
        begin
            write (' ');
    mensagem ('CTNENLID', 0); {'Nenhuma carta lida'}
end;

    if n = 1 then
        begin
            write (' ');
    mensagem ('CTUMALID', 0); {'Uma carta lida'}
end;

    if n = 2 then
        begin
            write (' ');
    mensagem ('CTDUALID', 0); {'Duas cartas lidas'}
end;

    if n > 2 then
        begin
            write (' ');
            sintWriteInt (n);
            mensagem ('CTLID', 0);   {'Lidas'}
end;

    if m = 0 then
        begin
            write (' ');
    mensagem ('CTNENREC', 0); {'Nenhuma carta recebida'}
end;

    if m = 1 then
        begin
            write (' ');
    mensagem ('CTUMAREC', 0); {'Uma carta recebida'}
end;

    if m = 2 then
        begin
            write (' ');
    mensagem ('CTDUAREC', 0); {'Duas cartas recebidas'}
end;

    if m > 2 then
        begin
            write (' ');
            sintWriteInt (m);
            mensagem ('CTREC', 0);   {'Recebidas'}
end;

begin
    l := temCartasEnviadas;

    if l = 0 then
        begin
            write (' ');
    mensagem ('CTNENENV', 0); {'Nenhuma carta enviada'}
end;

    if l = 1 then
        begin
            write (' ');
    mensagem ('CTUMAENV', 0); {'Uma carta enviada'}
end;

    if l = 2 then
        begin
            write (' ');
    mensagem ('CTDUAENV', 0); {'Duas cartas enviadas'}
end;

    if l > 2 then
        begin
            write (' ');
            sintWriteInt (l);
            mensagem ('CTENV', 0);   {'Enviadas'}
end;

end;
end;
end;
end;
end;

                ^S: mataSpam;
                'S': begin
                        mataSpam;
                        nCarRecebidas := receberCartas (true);
                        if nCarRecebidas <= 0 then
//                            mensagem ('CTNAOEXS', 1) {'No existem cartas no servidor.'}
                        else
                           begin
                                mensagem ('CTRECEBI', 0); {'Recebidas'}
                                write (': ');
                                sintWriteint (nCarRecebidas);
                                writeln;
                           end;
                            if autoEnviaDuplicadasLixeira then
                                removeCartasDuplicadas (false);
                    end;
                'C':  configurar;
                   'O': configuraTudo;
                ^O: prepararCarta ('T', 0, false, '', dirAtual);
                   'P': recuperaConfig;
                'A', 'W':  editarApelidos;
                'V':  verificarPreparadasOuTransmitidas;
                'M':  monitorarCorreio;
                ^P:  prelista;
                'D':  begin
                          debug := not debug;
                          if debug then
                              mensagem ('CTMODDEB', 2)   {'Modo debug: cartas no sero apagadas'}
                          else
                              mensagem ('CTMODNOR', 2);  {'Modo normal'}
                          writeln;
                      end;

                'Z': removeCartasDuplicadas (true);
                'B': inicializaRegras;
                'U': respostaAutomatica;
                'K': inicializaGrupoContas;
                'X': chamaIMAPUtil;
                'Y': matarSpansNaoLidas(false);
                ^Y: matarSpansNaoLidas(true);
                ^Z: receberGrupoContas;
                ^T: transmitirGrupoContas;
                ^C: monitorarGrupoContas;
                ^Q: informarCartasGrupoContas;

                ESC: processando := not terminaPrograma;
                #$0d: telaPrincipal;
            else
                mensagem ('CTOPVINV', 2);  {'Opo invlida, aperte F1 para ajuda'}
            end;
       end;

    if (guardaSenha) and (trim(senhaSalvaSmtp) <> '') then
        begin
            strPCopy (sz, codFraseMime64 (senhaSalvaSmtp));
            writePrivateProfileString('CARTAVOX', 'SCCV', sz, 'DOSVOX.INI');
            writePrivateProfileString('CARTAVOX', 'SCCVSMTP', sz, 'DOSVOX.INI');
    nomeConfig := nomeConfiguracao;
    strPCopy (szNomeConfig, nomeConfig);
    writePrivateProfileString(sznomeConfig, 'SCCV', sz, 'CARTAVOX.INI');
    writePrivateProfileString(sznomeConfig, 'SCCVSMTP', sz, 'CARTAVOX.INI');
        end;

    if (guardaSenha) and (trim(senhaSalvaPop3) <> '') then
        begin
            strPCopy (sz, codFraseMime64 (senhaSalvaPop3));
            writePrivateProfileString('CARTAVOX', 'SCCVPOP3', sz, 'DOSVOX.INI');
    nomeConfig := nomeConfiguracao;
    strPCopy (szNomeConfig, nomeConfig);
    writePrivateProfileString(sznomeConfig, 'SCCVPOP3', sz, 'CARTAVOX.INI');
        end;

    deletaArquivo(dirRecebe+ '\$.html');
    deletaArquivo(dirRecebe + '\$.html');
    deletaArquivo(dirRecebe+ '\$.htm');
    deletaArquivo(dirEnvia+ '\$.htm');
    deletaArquivo(dirEnvia+ '\$.$');
    deletaArquivo(dirEnvia+ '\$2.$');

    fechaRede;
    msgBaixo ('CTFIM');  {'Fim do Correio'}
    sintFim;
    doneWinCrt;
end.
