{--------------------------------------------------------}
{
{           cartaVox - rotinas utilitarias
{
{--------------------------------------------------------}

unit carUtil;

interface

uses
    classes,
    dvarq,
    dvcrt,
    dvexec,
    dvForm,
    dvWin,
    shellApi,
    sysutils,
    windows,
    ShDocVw,
    MSHTML,
    ActiveX,
    Variants,
    carDecod,
    carMsg,
    carVars;

function existeArq (nomearq: string): boolean;
function existeDir (dir: string): boolean;
function novoNomeCarta (var nbase: integer; diret, extensao: string): string;

function pegaPrefixoAssunto (assunto: string): string;
function limpaAssunto (assunto: string): string;
function limpaAssuntoLista (assunto: string): string;
function limpaTexto (s: string): string;

procedure marcaOuDesmarca(nCar: integer; mudo: boolean; var nBase: integer);
function apagaUmRegs (nCar: integer): integer;
function formataTamanhoArq (tam: longint): string;
procedure tamanhoCarta (nCar: integer);
procedure tamanhoTodasCartas;
function posicaoNomeArqCarta (nCar: integer): integer;
function posicaoCarta (var nCar: integer): integer;
procedure falaNumeroCartas;
function converteData (data: string; extenso: boolean): string;

procedure contemAnexos (nCar: integer);
function testaExtensao (nomeArq: string): boolean;

function carregaLinhasArquivo (nomeArq: string): boolean;
procedure destroiLinhasArquivo;

procedure MenuAdiciona (msg: string);
procedure deletaAspas (var s: string);
procedure deletaMenorMaior (var s: string);
procedure limpaParteTela(inicio, fim: integer);
function numeroDeCartas (tipoFolhe: char): integer;
function numeroDeCartasGrupoContas (tipoFolhe: char): integer;
function temMaisDeUmEndeereco (s: string): boolean;
function TypeOuContent_Type (parte: PEstrutura): string;

procedure selecionaOuNaoUmItem (nItem: integer);
procedure selecionaTodosItens (selecionar: boolean);
function temItemSelecionado: boolean;
function totalDeItensSelecionados: integer;
procedure falaQualItemDeQuantos (nItem: integer; Selecionados: boolean);
function apagaItensDoFolheamento (numFolhe: integer): integer;
procedure mataSpam;
procedure criaPrefixoNomeArq;
procedure split(Separator: Char; const S: String ; MyStringList: TStringList);
function htmlToText(html: string): string;
function verificaStringNumero(const s: string): boolean;

var
    linhasArquivo: TStringList;
    prefixoNomeArq: string;{nomeConfigurao sem caracteres proibidos}
implementation

{-------------------------------------------------------------}
{       Carrega todas as linhas do arquivo na memria
{-------------------------------------------------------------}

function carregaLinhasArquivo (nomeArq: string): boolean;
begin
    linhasArquivo := TStringList.create;
    carregaLinhasArquivo := true;
    try
        linhasArquivo.loadFromFile (nomeArq);
    except
         carregaLinhasArquivo := false;
    end;
end;

{-------------------------------------------------------------}
{       Destroi todas as linhas do arquivo da memria
{-------------------------------------------------------------}

procedure destroiLinhasArquivo;
begin
    linhasArquivo.free;
end;

{--------------------------------------------------------}
{ Testa se arquivo existe
{--------------------------------------------------------}

function existeArq (nomearq: string): boolean;
var existe: boolean;
    arq: file;
begin
    assign (arq, nomearq);
    {$I-}  reset (arq); {$i+}
    existe := ioresult = 0;
    if existe then close (arq);
    existeArq := existe;
end;

{-------------------------------------------------------------}
{       Testa se existe o diretrio.
{-------------------------------------------------------------}

function existeDir (dir: string): boolean;
var dirAtual: string;
begin
    getDir (0, dirAtual);
    {$I-}  chdir (dir);  {$I+}
    existeDir := ioresult = 0;
    chdir (dirAtual);
end;

{--------------------------------------------------------}
{       Retorna o ano, mes e dia para o nome do arquivo da carta
{--------------------------------------------------------}

function pegaAnoMesDia: string;
var
    diaSemana, dia, mes, ano: word;
    s, s2: string;
begin
    getDate (ano, mes, dia, diaSemana);
    str (ano, s2);
    str (mes, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;
    str (dia, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;

    pegaAnoMesDia := s2;
end;

{--------------------------------------------------------}
{       Retorna a hora e minuto para o nome do arquivo da carta
{--------------------------------------------------------}

function pegaHoraMinuto: string;
var
    hora, minuto, segundo, cent: word;
    s, s2: string;
begin
    dvcrt.gettime (hora, minuto, segundo, cent);
    str (hora, s);
    if length(s) < 2 then s := '0' + s;
    s2 := 'H' + s;
    str (minuto, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;
    str (segundo, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s + 'E';

    pegaHoraMinuto := s2;
end;

{-------------------------------------------------------------}
{       cria um novo nome para carta
{-------------------------------------------------------------}

function novoNomeCarta (var nbase: integer; diret, extensao: string): string;
var
    resulta, resulta2: integer;
    s, dirAtual, amdhm: string;
    arq: file;
begin
    resulta2 := 0;
    getDir (0, dirAtual);

    {$I-}  chdir (diret);  {$I+}
    if ioresult <> 0 then
        begin
            novoNomeCarta := '';
            exit;
        end;
    chDir (dirAtual);

    if diret [length(diret)] = '\' then
        delete (diret, length(diret), 1);

    if not antigoNomeArq then
        begin
            amdhm:= prefixoNomeArq;
            if amdhm <> '' then amdhm := amdhm + '_';
            amdhm:= amdhm + pegaAnoMesDia + pegaHoraMinuto;
        end;

    repeat
        str (nbase, s);
        nbase := nbase + 1;
        assign (arq, diret + '\' + amdhm + s + extensao);
        {$I-} reset (arq);  {$I+}
        resulta := ioresult;
        if resulta = 0 then   // carta j existia
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then;
                continue;
            end;

        if pos ('M.', extensao) <> 0 then
            assign (arq, diret + '\' + amdhm + s +  copy (extensao, 2, length (extensao)))
        else
            assign (arq, diret + '\' + amdhm + s + 'M' + extensao);

        {$I-} reset (arq);  {$I+}
        resulta2 := ioresult;
        if resulta2 = 0 then
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then ;
            end;

    until (resulta <> 0) and (resulta2 <> 0);
 
    novoNomeCarta := diret + '\' +amdhm + s + extensao;
end;

{--------------------------------------------------------}
{       Retorna o prefixo do assunto
{--------------------------------------------------------}

function pegaPrefixoAssunto (assunto: string): string;
var k, k2, k3, k4, k5, k6: integer;
    l, r: string;
begin
    if trim(assunto) = '' then
        begin
            pegaPrefixoAssunto := '';
            exit;
        end;

    l := '';
    r := '';

    k := pos ('[', assunto);
    k2 := pos (']', assunto);
    if (k > 0) and (k2 > 0) and (k2 > k) then
        begin
            l := copy (assunto, k, k2 - k + 1);
        end;

    k2 := pos ('{', assunto);
    k3 := pos ('}', assunto);
    if (k2 > 0) and (k3 > 0) and (k3 > k2) then
        if (k < k2) and (k > 0) then
            l := l + ' ' + copy (assunto, k2, k3 - k2 + 1)
        else
        if l <> '' then
            l := copy (assunto, k2, k3 - k2 + 1) + ' ' + l
        else
            l := copy (assunto, k2, k3 - k2 + 1);

    if ((k2 < k) or (k = 0)) and (k2 > 0) then k := k2;

    k2 := pos('RES: ', maiuscansi(assunto));
    k3 := pos('ENC: ', maiuscansi(assunto));
    k4 := pos('RE: ', maiuscansi(assunto));
    k5 := pos('EN: ', maiuscansi(assunto));
    k6 := pos('FW: ', maiuscansi(assunto));

    if ((k3 < k2) or (k2 = 0)) and (k3 > 0) then k2 := k3;
    if ((k4 < k2) or (k2 = 0)) and (k4 > 0) then k2 := k4;
    if ((k5 < k2) or (k2 = 0)) and (k5 > 0) then k2 := k5;
    if ((k6 < k2) or (k2 = 0)) and (k6 > 0) then k2 := k6;
    if k2 > 0 then
        begin
            r := copy (assunto, k2, 4);
            if (r <> '') and (r[4] <> ' ') then r := r + ' ';
        end;

    if k2 < k then
        assunto := r + l + ' '
    else
    if k = 0 then
        assunto := r
    else
        assunto := l + ' ' + r;

    pegaPrefixoAssunto := assunto;
end;

{--------------------------------------------------------}
{       Limpa o assunto.
{--------------------------------------------------------}

function limpaAssuntoLista (assunto: string): string;
var k, k2: integer;
begin
    k := pos ('[', assunto);
    k2 := pos (']', assunto);
    while (k <> 0) and (k2 <> 0) and (k2 > k) do
        begin
            delete (assunto, k, k2-k+1);
            k := pos ('[', assunto);
            k2 := pos (']', assunto);
        end;

    k := pos ('{', assunto);
    k2 := pos ('}', assunto);
    while (k <> 0) and (k2 <> 0) and (k2 > k) do
        begin
            delete (assunto, k, k2-k+1);
            k := pos ('{', assunto);
            k2 := pos ('}', assunto);
        end;

    while (assunto <> '') and ( assunto[1] = ' ') do
        delete (assunto, 1,1);

    limpaAssuntoLista := assunto;
end;


function limpaAssunto (assunto: string): string;
var k, k2, k3: integer;
begin
    k := pos ('RES: ', maiuscansi(assunto));
    k2 := pos ('ENC: ', maiuscansi(assunto));
    while (k <> 0) or (k2 <> 0) do
        begin
            if k = 0 then k := k2;
            delete (assunto, k, 5);
            k := pos ('RES: ', maiuscansi(assunto));
            k2 := pos ('ENC: ', maiuscansi(assunto));
        end;

    k := pos ('RE: ', maiuscansi(assunto));
    k2 := pos ('EN: ', maiuscansi(assunto));
    k3 := pos ('FW: ', maiuscansi(assunto));
    while (k <> 0) or (k2 <> 0) or (k3 <> 0) do
        begin
            if k = 0 then k := k2;
            if (k = 0) and ( k2 = 0) then k := k3;
            delete (assunto, k, 4);
        k := pos ('RE: ', maiuscansi(assunto));
            k2 := pos ('EN: ', maiuscansi(assunto));
            k3 := pos ('FW: ', maiuscansi(assunto));
        end;

    assunto := limpaAssuntoLista (assunto);

    while (assunto <> '') and ( assunto[1] = ' ') do
        delete (assunto, 1,1);

    limpaAssunto := assunto;
end;

{--------------------------------------------------------}
{       Devolve o texto limpo
{--------------------------------------------------------}

function limpaTexto (s: string): string;
var texto: string;
    p: integer;
begin
    s := trim (s);
    texto := s;

    p := pos ('(', texto);
    if p <> 0 then
        begin
            delete (texto, 1, p);
            while texto[length(texto)] = ' ' do
                delete (texto, length(texto), 1);
            if texto[length (texto)] = ')' then
                delete (texto, length(texto), 1);
        end;
    texto := trim (texto);
    if texto = '' then texto := s;    { casos estranhos... }

    for p := length (texto) downto 1 do
        if texto[p] = '"' then delete (texto, p, 1);

    limpaTexto := texto;
end;

{--------------------------------------------------------}
{       Marca ou desmarca o arquivo da carta lida
{--------------------------------------------------------}

procedure  marcaOuDesmarca(nCar: integer; mudo: boolean; var nBase: integer);
var
    arq: text;
    nomeArq, diret, s: string;
    marcar: boolean;
    i, total: integer;

    function  marcaArquivo: boolean;
    begin
        marcaArquivo := true;
        if marcar then
            begin
                if pos ('M.', nomeArq) <> 0 then exit;
                nomeArq := copy (nomeArq, 1, length (nomeArq) - 4) + 'M.car';
            end
        else
            begin
                if pos ('M.', nomeArq) = 0 then exit;
                delete (nomeArq, length (nomeArq) - 4, 1);
            end;
        assign (arq, nomeArq);
        {$I-} reset (arq); {$I+}
        if ioresult = 0 then
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then ;
                if marcar then
                    s := copy (nomeArq, pos ('.', nomeARq)-1, length (nomeArq))
                else
                    s := copy (nomeArq, pos ('.', nomeARq), length (nomeArq));
                nomeArq := novoNomeCarta (nBase, diret, s);
                while pos ('\', nomeArq) <> 0 do
                    delete (nomeArq, 1, pos ('\', nomeArq));
            end;
        assign (arq, regLido [i]^.carta^.nomArqCarta);
        {$i-} rename (arq, nomeArq);  {$I+}
        if ioresult <> 0 then
            begin
                msgBaixo ('CTERRDSK'); {'Erro de escrita no disco'}
                marcaarquivo := false;
            end
        else
            regLido [i]^.carta^.nomArqCarta := nomeArq;
    end;


begin
    getDir (0, diret);

    if nCar <> 0 then
        total := ncar
    else
        begin
            nCar := 1;
            total := numRegs;
        end;

    nomeArq := regLido [nCar]^.carta^.nomArqCarta;
    if pos ('M.', nomeArq) <> 0 then
        marcar := false
    else
        marcar := true;

    for i := nCar to total do
        begin
            nomeArq := regLido [i]^.carta^.nomArqCarta;
            if not marcaArquivo then exit;
            if (i mod 500) = 0 then
                sintclek;
        end;

    if not mudo then
        if marcar then
            msgBaixo ('CTMARCAD') {'Marcado'}
        else
            msgBaixo ('CTNMARCA'); {'Desmarcado'}
end;

{--------------------------------------------------------}
{       apaga um registro
{--------------------------------------------------------}

function apagaUmRegs (nCar: integer): integer;
var i: integer;
begin
    regLido[nCar]^.carta^.partesCarta.free;
    dispose (regLido [nCar]);
    numRegs := numRegs - 1;
    for i := nCar to numRegs do
        regLido [i] := regLido [i+1];
    nCar := nCar - 1;
    apagaUmRegs := nCar;
end;

{--------------------------------------------------------}
{       Formata o tamanho do arquivo
{--------------------------------------------------------}

function formataTamanhoArq (tam: longint): string;
var
    medida: char;
    decimal: integer;
begin
    medida := ' ';
    if tam >= 65536 then
        begin
            medida := 'K';
            decimal := tam mod 1024;
            tam := tam div 1024;
            if decimal > 512 then tam := tam + 1;
        end;

    formataTamanhoArq := intToStr (tam) + medida;
end;

{--------------------------------------------------------}
{       Fala o tamanho do arquivo da carta
{--------------------------------------------------------}

procedure tamanhoCarta (nCar: integer);
begin
    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTTAMAN', 0);
    write (' ');
    sintWrite (formataTamanhoArq (regLido [nCar]^.carta^.tamanho));
    textBackground (BLACK);
    writeln;
end;

{--------------------------------------------------------}
{       Fala o tamanho do arquivo de todas as cartas
{--------------------------------------------------------}

procedure tamanhoTodasCartas;
var
    i, tam: integer;
begin
    tam := 0;
    for i := 1 to numRegs do
        tam := tam + regLido [i]^.carta^.tamanho;

    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTTAMAN', 0);
    write ('  ');
    sintWrite (formataTamanhoArq (tam));
    textBackground (BLACK);
    writeln;
end;

{--------------------------------------------------------}
{       Procura a carta pelo nome do arquivo
{--------------------------------------------------------}

function posicaoNomeArqCarta (nCar: integer): integer;
var k: integer;
    nomeArq: string;
    c: char;
begin
    posicaoNomeArqCarta := nCar;
    repeat
        limpaParteTela (23, 25);
        textBackground (RED);
        mensagem ('CTINARQP', 0); {'Informe o nome do arquivo a procurar'}
        write (': ');
        textBackground (BLACK);
        writeln;
        nomeArq:= '';
        c := sintEditaCampo (nomeArq, 1, wherey, 255, 80, true);
        writeln;
    until c in [ENTER, ESC];
    if (c = ESC) or (nomeArq= '') then
        begin
            msgBaixo ('CTDESIST');
            exit;
        end;

    if (nCar + 1) >= numRegs then nCar := 1
    else nCar := nCar + 1;
    for k := nCar to numRegs do
        if pos (nomeArq, regLido [k]^.carta^.nomArqCarta) <> 0 then
            begin
                posicaoNomeArqCarta := k;
                msgBaixo ('CTACHEI');     {'Achei'}
                break;
            end;
    sintBip;
end;

{--------------------------------------------------------}
{       Posiciona na carta pegando o nmero.
{--------------------------------------------------------}

function posicaoCarta (var nCar: integer): integer;
var k: integer;
begin
    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTINFNCA', 0);    {'Informe o nmero da carta a procurar de '}
    sintWrite ('1');
    sintwrite (' a ');
    sintWriteInt (numRegs);
    write (': ');
    textBackground (BLACK);
    writeln;
    sintReadint (k);
    writeln;
    if (k < 1) or (k > numRegs) then k := nCar;
    posicaoCarta := k;
    sintbip;
end;

{--------------------------------------------------------}
{       Fala o nmero de cartas no folheamento.
{--------------------------------------------------------}

procedure falaNumeroCartas;
begin
    tocaOuSintetiza ('CTNUMCAR'); {'Nmero de cartas neste folheamento: '}
    sintetiza (intToStr(numRegs));
    if numRegs > 1 then
        tocaOuSintetiza ('CTCARTAS') {'cartas'}
    else
        tocaOuSintetiza ('CTCARTA'); {'carta'}
end;

{--------------------------------------------------------}
{       Retorna da data que a carta foi mandada
{--------------------------------------------------------}

function converteData (data: string; extenso: boolean): string;
var
    sem, dia, mes, ano, hora: string;
    i, erro: integer;

const
    tabMes: array [1..12] of string =
        ('Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho', 'Julho',
        'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');

begin
    data := trim (data);
    if (data = '') or (length(data) < 20) or (pos (':', data) = 0) then
        begin
            converteData := '';
            exit;
        end;

    if extenso then
        hora := copy (data, pos (':',data) - 2, 5);

    sem := '';
    if not (data[1] in ['0'..'9']) then
        begin
           sem := copy (data, 1, 3);
           delete (data, 1, 5);
        end;

    dia := data[1];
    delete (data, 1, 1);
    if data [1] <> ' ' then
        begin
            dia := dia + data[1];
            delete (data, 1, 1);
        end;
    delete (data, 1, 1);

    mes := copy (data, 1, 3);
    delete (data, 1, 4);
    ano := '';
    data := data + ' ';
    while data[1] <> ' ' do
        begin
            ano := ano + data [1];
            delete (data, 1, 1);
        end;

    if sem = 'Sun' then sem := 'Domingo' else
    if sem = 'Mon' then sem := 'Segunda' else
    if sem = 'Tue' then sem := 'Tera'   else
    if sem = 'Wed' then sem := 'Quarta'  else
    if sem = 'Thu' then sem := 'Quinta'  else
    if sem = 'Fri' then sem := 'Sexta'   else
    if sem = 'Sat' then sem := 'Sabado';

    if mes = 'Jan' then mes := '1'  else
    if mes = 'Feb' then mes := '2'  else
    if mes = 'Mar' then mes := '3'  else
    if mes = 'Apr' then mes := '4'  else
    if mes = 'May' then mes := '5'  else
    if mes = 'Jun' then mes := '6'  else
    if mes = 'Jul' then mes := '7'  else
    if mes = 'Aug' then mes := '8'  else
    if mes = 'Sep' then mes := '9'  else
    if mes = 'Oct' then mes := '10' else
    if mes = 'Nov' then mes := '11' else
    if mes = 'Dec' then mes := '12';

    if extenso then
        begin
            if sem <> '' then sem := sem + ', ';
            val (mes, i, erro);
            if erro = 0 then
                converteData := sem + dia+ ' de ' + tabMes [i] +                 ' de ' + ano + ' ' + hora
            else
                converteData := '';
        end
    else
        converteData := sem + ' ' + dia+ '/' + mes + '/' + ano;
end;

{--------------------------------------------------------}
{       Fala se tem anexo na carta
{--------------------------------------------------------}

procedure contemAnexos (nCar: integer);
begin
    if regLido [nCar]^.boundary <> '' then
        msgBaixo ('CTTEMATT');     {'Contm arquivos inclusos'}
end;

{--------------------------------------------------------}
{       Testa se o nome do arquivo tem extenso
{--------------------------------------------------------}

function testaExtensao (nomeArq: string): boolean;
begin
    while (pos ('\', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('\', nomearq));
    while (pos ('/', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('/', nomearq));

    if pos ('.', nomeArq) <> 0 then
        testaExtensao := true
    else
        testaExtensao := false;
end;

{-------------------------------------------------------------}
{       Utilizado para montar o menu de opes
{-------------------------------------------------------------}

procedure MenuAdiciona (msg: string);
begin
     popupMenuAdiciona (msg, pegaTextoMensagem (msg));
end;

{-------------------------------------------------------------}
{       Deleta as " do fim e do incio da string.
{-------------------------------------------------------------}

procedure deletaAspas (var s: string);
begin
    s := trim (s);
    if s = '' then exit;
    if pos ('"', s) <> 0 then
        if s[1] = '"' then delete (s, 1, 1);
    if pos ('"', s) <> 0 then
        if s[length(s)] = '"' then delete (s, length(s), 1);
end;

{-------------------------------------------------------------}
{       Deleta o sinal de < e > da extremidade da string
{-------------------------------------------------------------}

procedure deletaMenorMaior (var s: string);
begin
    s := trim (s);
    if s = '' then exit;
    if pos ('<', s) <> 0 then
        if s[1] = '<' then delete (s, 1, 1);
    if pos ('>', s) <> 0 then
        if s[length(s)] = '>' then delete (s,         length(s), 1);
end;

{----------------------------------------------------------------------}
{       Linpa a parte da tela desejada.
{----------------------------------------------------------------------}

procedure limpaParteTela(inicio, fim: integer);
var i: integer;
begin
    for i := inicio to fim do
    begin
        gotoxy (1,i); clreol;
    end;
    gotoxy (1, inicio);
end;

{-------------------------------------------------------------}
{       Retorna o nmero de cartas preparadas para o envio
{-------------------------------------------------------------}

function numeroDeCartas (tipoFolhe: char): integer;
var
    dirAtual, s: string;
    dirInfo: TSearchRec;
    ext: array [0..10] of char;
    dosError, i: integer;
label proximoArq;
begin
    numeroDeCartas := 0;
    getDir (0, dirAtual);
    case tipoFolhe of
        'F', 'N', 'L': begin
                            s := 'CAR';
                            {$I-}  chdir (dirRecebe);  {$I+}
                            if ioresult <> 0 then exit;
                       end;
        'P': begin
                s := 'CPR';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then exit;
             end;
        'T': begin
                s := 'ENV';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then exit;
             end;
    end;

    i := 0;
    strPcopy (ext, '*.' + s);
    dosError := FindFirst (ext, FaArchive, DirInfo);
    while DosError = 0 do
        begin
            s := trim(dirInfo.name);
            if (upcase (tipoFolhe) = 'L') and
               (upcase (s[length (s) - 4]) <> 'M') then
                    goto proximoArq
            else
            if (upcase (tipoFolhe) = 'N') and
               (upcase (s[length (s) - 4]) = 'M') then
                    goto proximoArq;
            i := i + 1;
proximoArq:
            dosError := FindNext (DirInfo);
        end;

    numeroDeCartas := i;

    {$I-}  chdir (dirAtual);  {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{      Retorna o nmero de cartas preparadas para o envio
{      de uma conta do grupo de contas
{-------------------------------------------------------------}

function numeroDeCartasGrupoContas (tipoFolhe: char): integer;
var
    dirAtual, s, nomeConfigCar, nomeConfigAtual: string;
    dirInfo: TSearchRec;
    ext: array [0..10] of char;
    dosError, i, j, tam: integer;
label proximoArq;
begin
    getDir (0, dirAtual);
    case tipoFolhe of
        'F', 'N', 'L': begin
                           s := 'CAR';
                           try
                               chdir (dirRecebe);
                           except
                           on E : Exception do
                               begin
                                   numeroDeCartasGrupoContas := -1;
                                   exit;
                               end;
                           end;
                       end;
        'P': begin
                 s := 'CPR';
                 try
                     chdir (dirEnvia);
                 except
                 on E : Exception do
                     begin
                         numeroDeCartasGrupoContas := -1;
                         exit;
                     end;
                 end;
             end;
        'T': begin
                 s := 'ENV';
                 try
                     chdir (dirEnvia);
                 except
                 on E : Exception do
                     begin
                         numeroDeCartasGrupoContas := -1;
                         exit;
                     end;
                 end;
             end;
    end;

    i := 0;
    strPcopy (ext, '*.' + s);
    dosError := FindFirst (ext, FaArchive, DirInfo);
    while DosError = 0 do
        begin
            s := trim(dirInfo.name);
            if (upcase (tipoFolhe) = 'L') and
               (upcase (s[length (s) - 4]) <> 'M') then
                    goto proximoArq
            else
            if (upcase (tipoFolhe) = 'N') and
               (upcase (s[length (s) - 4]) = 'M') then
                    goto proximoArq;

            nomeConfigCar := AnsiUpperCase(dirInfo.name);
            tam := length (nomeConfigCar);
            while tam > 0 do
                begin
                    if copy (nomeConfigCar, tam, 1) <> '_' then
                        begin
                            nomeConfigCar := copy (nomeConfigCar, 1, tam-1);
                            tam := tam - 1;
                        end
                    else
                        begin
                            nomeConfigCar := copy (nomeConfigCar, 1, tam-1);
                            break;
                    end;
                end;

            nomeConfigAtual := '';
            for j :=  length(nomeConfiguracao) downto 1 do
                if nomeConfiguracao [j] in ['-', '_', 'A'..'Z', 'a'..'z', '0'..'9'] then
                    nomeConfigAtual := nomeConfiguracao[j] + nomeConfigAtual;

            if nomeConfigCar <> nomeConfigAtual then goto proximoArq;

            i := i + 1;

proximoArq:
            dosError := FindNext (DirInfo);
        end;

    numeroDeCartasGrupoContas := i;

    try
        chdir (dirAtual);
    except
    on E : Exception do
        begin
            numeroDeCartasGrupoContas := -1;
            exit;
        end;
    end;
end;

{-------------------------------------------------------------}
{       Retorna true se encontrar mais de um @ na string
{-------------------------------------------------------------}

function temMaisDeUmEndeereco (s: string): boolean;
begin
    temMaisDeUmEndeereco := false;
    if (trim(s) <> '') and (pos ('>', s) <> 0) then
        begin
            delete (s, 1, pos ('>', s));
            if (trim(s) <> '') and (pos ('>', s) <> 0) then
                temMaisDeUmEndeereco := true;
        end
    else
    if (trim(s) <> '') and (pos ('@', s) <> 0) then
        begin
            delete (s, 1, pos ('@', s));
            if (trim(s) <> '') and (pos ('@', s) <> 0) then
                temMaisDeUmEndeereco := true;
        end;
end;

{-------------------------------------------------------------}
{       Retorna o type, se type = '', retorna o content-type
{-------------------------------------------------------------}

function TypeOuContent_Type (parte: PEstrutura): string;
var s: string;
begin
    if trim (parte^.type_) <> '' then
        s := parte^.type_
    else
        s := parte^.content_type;
    typeOuContent_Type := s;
end;

{-------------------------------------------------------------}
{       Seleciona ou no um item
{-------------------------------------------------------------}

procedure selecionaOuNaoUmItem (nItem: integer);
var
    selecionado: boolean;
    item: string;
begin
    folheiaObtemItem (nItem, item, selecionado);
    folheiaSeleciona (nItem, not selecionado);
end;

{-------------------------------------------------------------}
{       Seleciona ou tira a seleo de todos os itens
{-------------------------------------------------------------}

procedure selecionaTodosItens (selecionar: boolean);
var
    i: integer;
begin
    for i := 1 to folheiaNumItens do
        folheiaSeleciona (i, selecionar);
end;

{-------------------------------------------------------------}
{       Verifica se tem item selecionado.
{-------------------------------------------------------------}

function temItemSelecionado: boolean;
var
    i: integer;
    item: string;
    selecionado: boolean;
begin
    temItemSelecionado := FALSE;
    for i := 1 to folheiaNumItens do
        begin
            folheiaObtemItem (i, item, selecionado);
            if selecionado then
                begin
                    temItemSelecionado := TRUE;
                    break;
                end;
        end;
end;

{-------------------------------------------------------------}
{       Retorna a quantidade de itens selecionados.
{-------------------------------------------------------------}

function totalDeItensSelecionados: integer;
var
    i, itensSelecionados: integer;
    selecionado: boolean;
    item: string;
begin
    itensSelecionados := 0;
    for i := 1 to folheiaNumItens do
        begin
            folheiaObtemItem (i, item, selecionado);
            if selecionado then
                itensSelecionados := itensSelecionados + 1;
        end;

    totalDeItensSelecionados := itensSelecionados;
end;

{-------------------------------------------------------------}
{       Informa o total de itens do folheamento.
{       Fala em qual est ou as selecionadas do  total.
{-------------------------------------------------------------}

procedure falaQualItemDeQuantos (nItem: integer; Selecionados: boolean);
begin
    if selecionados then
        nItem := totalDeItensSelecionados;

    sintetiza (intToStr (nItem));
    if selecionados then
        if nItem >1 then
            tocaOuSintetiza ('CTSELECI') {'selecionadas'}
        else
            tocaOuSintetiza ('CTSELECS'); {'selecionada'}
    tocaOuSintetiza ('CTDE'); {'de'}
    sintetiza (intToStr(folheiaNumItens));
end;

{-------------------------------------------------------------}
{       Apaga os itens do folheamento padro
{-------------------------------------------------------------}

function apagaItensDoFolheamento (numFolhe: integer): integer;
var
    i: integer;
    item: string;
    selecionado: boolean;
    c, c2: char;
begin
    if not temItemSelecionado then
        repeat
            msgBaixo ('CTDEREIT'); {'Deseja remover este item?'}
            folheiaObtemItem (numFolhe, item, selecionado);
            sintetiza (item);
            sintletecla (c, c2);
            if upcase (c) in ['S', ENTER] then
                begin
                    folheiaRemoveItem (numFolhe);
                    numFolhe := numFolhe - 1;
                end
            else
            if upcase (c) in ['N', ESC] then
                msgBaixo ('CTDESIST'); {'Desistiu'}
        until upcase (c) in ['N', 'S', ENTER, ESC]
    else
        repeat
            msgBaixo ('CTDEREIS'); {'Deseja remover todos os itens selecionados?'}
            sintLeTecla (c, c2);
            if upcase (c) in ['N', ESC] then
                msgBaixo ('CTDESIST') {'Desistiu'}
            else
            if upcase (c) in ['S', ENTER] then
                for i  := folheiaNumItens downto 1 do
                    begin
                        folheiaObtemItem (i, item, selecionado);
                        if selecionado then
                            begin
                                folheiaRemoveItem (i);
                                if i <= numFolhe then
                                    numFolhe := numFolhe -1;
                            end;
                    end;
        until upcase (c) in ['N', 'S', ENTER, ESC];

    if numFolhe < 1 then numFolhe := 1;
    apagaItensDoFolheamento := numFolhe;
end;

{-------------------------------------------------------------}
{       Chama o programa externo MataSpam.exe em \Winvox
{-------------------------------------------------------------}

procedure mataSpam;
var
    s: string;
    c: char;
begin
    s := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\mataSpam.exe';
    if not fileExists (s) then exit;
    if usaSSL then c := 'S' else c := 'N';
    if executaProg ( s, dirRecebe, hostPOP3+ ' '+contaUsuario+ ' '+ c + ' '+ senhaSalva) >= 32 then
        esperaProgVoltar;
    while sintFalando do waitMessage;
end;

{-------------------------------------------------------------}
{       Cria o prefixo do nome do arquivo limpando o nome da configurao
{-------------------------------------------------------------}

procedure criaPrefixoNomeArq;
var
    i: integer;
    s: string;
begin
    s := '';
    for i :=  length(nomeConfiguracao) downto 1 do
        if nomeConfiguracao [i] in ['-', '_', 'A'..'Z', 'a'..'z', '0'..'9'] then
            s := nomeConfiguracao[i] + s;
    prefixoNomeArq := s;
end;

{-------------------------------------------------------------}
{       Retorna uma substring dentro de uma string a partir
{       de um caractere separador
{-------------------------------------------------------------}

function getNextToken (Const S: string; Separator: char; var StartPos: integer): String;
var Index: integer;
begin
   Result := '';

   While (S[StartPos] = Separator) and (StartPos <= length(S)) do
      StartPos := StartPos + 1;

   if StartPos > length(S) then Exit;
   Index := StartPos;

   While (S[Index] <> Separator) and (Index <= length(S)) do
      Index := Index + 1;

   Result := Copy(S, StartPos, Index - StartPos) ;
   StartPos := Index + 1;
end;

{-------------------------------------------------------------}
{    Separa as substrings de uma string atravs do caractere
{    separador e coloca as substrings separadas em uma lista
{-------------------------------------------------------------}

procedure split (Separator: Char; const S: String; MyStringList: TStringList) ;
var Start: integer;
begin
   Start := 1;
   While Start <= Length(S) do
       MyStringList.Add(GetNextToken(S, Separator, Start)) ;
end;

{-------------------------------------------------------------}
{     Transforma a string com as tags em HTML em texto
{-------------------------------------------------------------}

function htmlToText(html: string): string;

var
    WebBrowser: TWebBrowser;
    Document: IHtmlDocument2;
    Doc: OleVariant;
    v: Variant;
    Body: IHTMLBodyElement;
    TextRange: IHTMLTxtRange;
begin
    Result := '';

    WebBrowser := TWebBrowser.Create(nil);
    try
        Doc := 'about:blank';
        WebBrowser.Navigate2(Doc);
        Document := WebBrowser.Document as IHtmlDocument2;

        if (Assigned(Document)) then
            begin
                v := VarArrayCreate([0, 0], varVariant);
                v[0] := html;
                Document.Write(PSafeArray(TVarData(v).VArray));
                Document.Close;

                Body := Document.body as IHTMLBodyElement;
                TextRange := Body.createTextRange;
                Result := TextRange.text;
            end;
    finally
    WebBrowser.Free;
    end;
end;

{-------------------------------------------------------------}
{  Verifica se uma string contm apenas caracteres numricos
{-------------------------------------------------------------}

function verificaStringNumero(const s: string): boolean;
var 
    P: PChar;
begin 
    P := PChar(s);
    Result := False;
    while P^ <> #0 do
        begin
            if not (P^ in ['0'..'9']) then Exit;
            Inc(P);
        end;
    Result := True;
end;


{--------------------------------------------------------}
begin
end.
