{-------------------------------------------------------------}
{
{           CartaVox - Grupo de contas
{
{-------------------------------------------------------------}


unit carCont;

interface

uses
    dvcrt,
    dvhora,
    dvForm,
    dvWin,
    sysUtils,
    windows,
    carDecod,
    careMudo,
    carMsg,
    carUtil,
    carVars,
    carTela,
    dvExec,
    classes,
    carConf,
    carMonit,
    carPop3,
    carSMTP;

procedure inicializaGrupoContas;
procedure receberGrupoContas;
procedure transmitirGrupoContas;
procedure monitorarGrupoContas;
procedure informarCartasGrupoContas;

implementation

const
    NUMMAXCONTAS = 100;

type
    TConta= record
                nome: string;
                selecionado: boolean;
            end;

    Pconta= ^TConta;
    tcont = array [1..NUMMAXCONTAS] of Pconta;

var
    numContas, nFolhe: integer;
    cont : tcont;
    nomeBusc: string;

{-------------------------------------------------------------}
{       Ajuda do menu de seleo do grupo de contas
{-------------------------------------------------------------}

procedure ajudaSelecContas;
begin
    writeln;
    if not keypressed then
        mensagem ('CTAJUD01', 2); {'As opes so'}
    if not keypressed then
        mensagem ('CTAJGC01', 1); {'   A - Adicionar contas ao grupo de contas'}
    if not keypressed then
        mensagem ('CTAJGC02', 1); {'   R - Remover contas do grupo de contas'}
end;

{--------------------------------------------------------}
{  seleciona a opo do menu de seleo contas com as setas
{--------------------------------------------------------}

function selSetasSelecaoContas: char;
var n: integer;
const
    tabLetrasConfig: string [2] = 'AR';

begin
    popupMenuCria (wherex, wherey, 50, 2, MAGENTA);
    MenuAdiciona ('A - Adicionar contas ao grupo de contas');
    MenuAdiciona ('R - Remover contas do grupo de contas');

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasSelecaoContas := tabLetrasConfig[n]
    else
        selSetasSelecaoContas := ESC;
end;

{-------------------------------------------------------------}
{       Monta a tela do folheamento de contas
{-------------------------------------------------------------}

procedure telaFolheiaContas (numContas: integer);
var s: string;
begin
    clrscr;
    textBackGround (MAGENTA);
    s := pegaTextoMensagem ('CTFOGRCO'); {'Folheamento do grupo de contas'}
    s := s + ' - ' + intToStr(numContas) + ' ';
    s := s + pegaTextoMensagem('Contas'); {'Contas'}
    write (centralizaFrase (s));
    textBackground (BLACK);
    writeln;
    writeln;
    textColor (LightGray);
    write ('Nome das Contas');
    textColor (White);
    writeln;
    gotoxy (1,5); clreol;
end;

{----------------------------------------------------------------------}
{     Grava na memria ( ponteiro cont ) as informaes de cada conta
{     Parmetro adicionarContas - se  true, grava na memria as contas
{     que no esto no grupo de contas, se  false, grava na mamria as
{     contas que esto no grupo de contas
{----------------------------------------------------------------------}

procedure carregarContas(adicionarContas: boolean);
var
    nomes, nomeConta: array [0..1000] of char;
    sz: array [0..144] of char;
    p: pchar;
    estaNoGrupo: boolean;
    nomeStr: string;
    n: integer;

begin
    numContas :=  0;

    getprivateProfileString (NIL, NIL, '', nomes, 1000, 'CARTAVOX.INI');
    p := nomes;
    while p^ <> #$0 do
        begin
            nomeStr := StrPas(p);

            strPCopy (nomeConta, nomeStr);

            n := getPrivateProfileString(nomeConta, 'SERVIDORSMTP', '', sz, 144, 'CARTAVOX.INI');
            if n > 0 then
                begin
                    getPrivateProfileString(nomeConta, 'GRUPODECONTAS', '', sz, 144, 'CARTAVOX.INI');
                    estaNoGrupo := upcase(sz[0]) = 'S';

                    if adicionarContas then
                        begin
                            if estaNoGrupo = false then
                                begin
                                    numContas := numContas + 1;
                                    new(cont[numContas]);
                                    cont[numContas]^.nome := strPas(p);
                                    cont[numContas]^.selecionado := false;
                                end;
                        end
                    else
                    if estaNoGrupo = true then
                        begin
                            numContas := numContas + 1;
                            new (cont[numContas]);
                            cont[numContas]^.nome := strPas(p);
                            cont[numContas]^.selecionado := false;
                        end;
                end;

            p := p + strlen(p) + 1;
        end;
end;

{---------------------------------------------------------------}
{       Monta o folheamento de contas
{---------------------------------------------------------------}

procedure inicializaFolheamentoContas;
var
    i: integer;
    nome: string;
begin
    folheiaCria (1, 6, 80, 21);
    for i :=  1 to numContas do
        begin
            nome := copy (cont[i]^.nome+BRANCOS, 1, 30);

            folheiaAdicionaEspecial (nome, cont[i]^.selecionado, cont[i]^.nome);
        end;
end;

{-------------------------------------------------------------}
{       Ajuda das opes do folheamento de contas
{-------------------------------------------------------------}

procedure ajudaFolheContas;
begin
    telaFolheiaContas (folheiaNumItens);
    textBackground (BLUE);
    mensagem ('CTAJUD01', 0); {'As opes so:'}
    textBackground (BLACK);
    writeln;
    mensagem ('CTAJFA01', 1); {'ENTER - Escolhe atual ou selecionados e sai'}
    mensagem ('CTAJFC02', 1); {'CTRL+Q - Informa quantas do total'}
    mensagem ('CTAJFC03', 1); {'CTRL+S - Informa quantas selecionadas do total'}
    mensagem ('CTAJFL10', 1); {'F5 - Procurar'}
    mensagem ('CTAJFP11', 1); {'BARRA DE ESPAO - Seleciona ou tira seleo'}
    mensagem ('CTAJFP12', 1); {'* - Seleciona tudo'}
    mensagem ('CTAJFP13', 1); {'/ - Tira seleo de tudo'}
    mensagem ('CTAJFL07', 1); {'ESC - Terminar folheamento'}

    if keypressed and (readkey <> ESC) then
        begin
            limpaBufTec;
            readkey;
        end;
    limpaBufTec;
end;

{--------------------------------------------------------}
{   procura prxima conta que contm as palavras buscadas
{   na procura anterior
{--------------------------------------------------------}

function procuraProximoItem(numFolhe: integer): integer;
var
    i: integer;
    buscado, item: string;
begin
    buscado := semAcentos (nomeBusc);
     for i := numFolhe +1 to folheiaNumItens do
        begin
            item := cont[i]^.nome;
            if pos (buscado, semAcentos (item)) <> 0 then
                begin
                    procuraProximoItem := i;
                    exit;
                end;
        end;

    sintBip;
    procuraProximoItem := numFolhe;
end;

{----------------------------------------------------------------------}
{       Desaloca da memria o ponteiro cont
{----------------------------------------------------------------------}

procedure descarregarContas;
begin
    while numContas >0 do
    begin
        dispose (cont[numContas]);
        numContas := numContas - 1;
    end;
end;

{----------------------------------------------------------------------}
{    Procura uma conta pelo nome no folheamento de contas
{----------------------------------------------------------------------}

function procuraItem (numFolhe: integer): integer;
begin
    procuraItem := numFolhe;
    gotoxy (1, 24); clreol;
    textbackground (red);
    mensagem ('CTPALPRO', 0);{'Digite a palavra a procurar: '}
    textbackground (black);
    sintReadln (nomeBusc);
    if nomeBusc = '' then exit;
    procuraItem := procuraProximoItem (numFolhe);
end;

{--------------------------------------------------------}
{       Ordena pelo metodo quick sort
{--------------------------------------------------------}

procedure Sort(l, r: Integer);
var
    i, j: integer;
    x: string;
    ppes: PConta;

begin
    i := l;
    j := r;

    ppes := cont[(l+r) div 2];
    x := ppes^.nome;
    x := semAcentos (x);

    repeat
        while semAcentos (cont[i]^.nome) < x do
            i := i + 1;
        while x < semAcentos (cont[j]^.nome) do
            j := j - 1;

        if i <= j then
            begin
                ppes := cont[i];
                cont[i] := cont[j];
                cont[j] := ppes;
                i := i + 1;
                j := j - 1;
            end;
    until i > j;

    if l < j then Sort(l, j);
    if i < r then Sort(i, r);
end;

{--------------------------------------------------------}
{    Cria e controla o folheamento de contas
{--------------------------------------------------------}

procedure folhearContas(adicinarContas: boolean);
var
    c, c2: char;
    i, k, indice, opFinalizadas, portaPOP3Aux, erro: integer;
    podeFalar, usaSSLAux: boolean;
    aux, item, nomeConta, s, contaFinalizada, senhaSalvaAux: string;
    contasSelecionadas: TStringList;
    sz, szConta, szAdicionarConta: array [0..144] of char;
    hostPOP3Aux, contaUsuarioAux: shortString;
begin
    opFinalizadas := 0;
    senhaSalvaAux := senhaSalvaPop3;
    contasSelecionadas := TStringList.Create;
    telaFolheiaContas(0);

    carregarContas(adicinarContas);

    if numContas <= 0 then
        begin
            if adicinarContas then
                 msgBaixo('CTNEXCAD') {'No existem contas a serem adicionadas.'}
            else msgBaixo('CTNEXGRU'); {'No existem contas no grupo.'}
            exit;
        end;
    sort (1, numContas);
    inicializaFolheamentoContas;

    nFolhe:= 1;
    podeFalar := true;
    repeat
        telaFolheiaContas (folheiaNumItens);
        folheiaExecuta (nFolhe, nFolhe, c, c2, podeFalar);
        if nFolhe < 1 then NFolhe := 1;
        if nfolhe > folheiaNumItens then nFolhe := folheiaNumItens;
        sintPara;
        for k := 1 to folheiaNumItens do
            folheiaObtemItem (k, item, cont[k]^.selecionado);

        if c = #$0 then
            case c2 of
                ESQ: sintetiza (cont[nFolhe]^.nome);
                DIR: sintetiza (cont[nFolhe]^.nome);
                F1: ajudaFolheContas;
                f5: nFolhe := procuraItem (nFolhe);
                CTLF5: nFolhe := procuraProximoitem (nFolhe);
                f8: falaHora;
                CTLF8: falaDia;
            end
        else
            with cont[nFolhe]^ do
            begin
                case upcase(c) of
                    ESC: ;
                    ENTER: begin
                                aux := '';
                                if not temItemSelecionado then
                                    contasSelecionadas.add(nome)
                                else
                                    for i := 1 to numContas do
                                        if cont[i]^.selecionado then
                                            contasSelecionadas.add(cont[i]^.nome);
                                c := ESC;
                                writeln(aux);
                           end;

                    ^Q: falaQualItemDeQuantos (nFolhe, false);
                    ^S: falaQualItemDeQuantos (nFolhe, true);
                end;
            end;

        if (upCase(c) in[^Q, ^S]) or (c2 in [ESQ, DIR, f8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

        if (upcase (c) in ['A'..'Z']) or (upcase (c) in ['0' .. '9']) then
            begin
                i := nFolhe + 1;
                if i > folheiaNumItens then i := 1;
                while (i <> nFolhe) and  (maiuscAnsi (cont[i]^.nome[1]) <> upcase(c)) do
                    if i >= numContas then
                        i := 1
                    else
                        i := i + 1;
                if maiuscAnsi (cont[i]^.nome[1]) = upcase(c) then
                    nFolhe := i;

            end;

    until (c = ESC) or (numContas <= 0);

    if adicinarContas then
        strPCopy(szAdicionarConta, 'SIM')
    else strPCopy(szAdicionarConta, 'NAO');

    for indice := 0 to contasSelecionadas.Count - 1 do
        begin
            gotoxy (1, 23);
            nomeConta := contasSelecionadas.Strings[indice];
            strPCopy(szConta, nomeConta);

            if adicinarContas then
                begin
                    getPrivateProfileString(szConta, 'SCCVPOP3', '', sz, 255, 'CARTAVOX.INI');
                    s := StrPas(sz);
                    senhaSalvaPop3 := decodFraseMime64 (s);

                    if trim (senhaSalvaPop3) = '' then
                        begin
                            repeat
                                textBackground (BLACK);
                                if indice > 0 then
                                    begin
                                        writeln;
                                        writeln;
                                        writeln;
                                        writeln;
                                        writeln;
                                        gotoxy (1, 23);
                                    end;
                                mensagem('CTPAADCO', 0); {'Para adicionar a conta '}
                                sintWrite (nomeConta);
                                mensagem('CTAOGRCO', 1); {' ao grupo de contas, a senha precisa ser gravada. '}
                                mensagem('CTDEGRSE', 1); {'Deseja gravar a senha desta conta?'}
                                sintLeTecla (c, c2);
                                writeln;
                            until upcase (c) in ['S', 'N', ENTER, ESC];
                            if upcase (c) in ['N', ESC] then
                                begin
                                    mensagem ('CTACONT', 0); {'A conta '}
                                    sintWrite (nomeConta);
                                    mensagem ('CTNFAGRC', 1); {'no foi adicionada ao grupo de contas'}
                                end
                            else
                                begin
                                    getPrivateProfileString(szConta, 'SERVIDORPOP3', '', sz, 255, 'CARTAVOX.INI');
                                    hostPOP3Aux := StrPas(sz);

                                    getPrivateProfileString(szConta, 'CONTAUSUARIO', '', sz, 255, 'CARTAVOX.INI');
                                    contaUsuarioAux := StrPas(sz);

                                    getPrivateProfileString(szConta, 'USASSL', '', sz, 255, 'CARTAVOX.INI');
                                    usaSSLAux := upcase(sz[0]) = 'S';

                                    getPrivateProfileString(szConta, 'PORTAPOP3', '', sz, 255, 'CARTAVOX.INI');
                                    val (strPas (sz), portaPOP3Aux, erro);
                                    if erro <> 0 then
                                    if usaSSLAux then portaPOP3Aux := 995
                                    else portaPOP3Aux := 110;

                                    if senhaValida(hostPOP3Aux, contaUsuarioAux, portaPOP3Aux, usaSSLAux) = false then
                                        begin
                                            mensagem ('CTACONT', 0); {'A conta '}
                                            sintWrite (nomeConta);
                                            mensagem ('CTNFAGRC', 1); {' no foi adicionada ao grupo de contas'}
                                            continue;
                                        end;

                                    writePrivateProfileString(szConta, 'ARMAZENASENHA', 'SIM', 'CARTAVOX.INI');
                                    strPCopy (sz, codFraseMime64 (senhaSalvaPop3));
                                    writePrivateProfileString(szConta, 'SCCVPOP3', sz, 'CARTAVOX.INI');
                                    writePrivateProfileString(szConta, 'GRUPODECONTAS', szAdicionarConta, 'CARTAVOX.INI');

                                    opFinalizadas := opFinalizadas + 1;
                                    contaFinalizada := nomeConta;
                                end;
                        end
                        else
                            begin
                                writePrivateProfileString(szConta, 'GRUPODECONTAS', szAdicionarConta, 'CARTAVOX.INI');
                                opFinalizadas := opFinalizadas + 1;
                                contaFinalizada := nomeConta;
                            end;
                end
                else
                    begin
                        writePrivateProfileString(szConta, 'GRUPODECONTAS', szAdicionarConta, 'CARTAVOX.INI');
                        opFinalizadas := opFinalizadas + 1;
                        contaFinalizada := nomeConta;
                    end;
        end;

    if adicinarContas then
        begin
            if opFinalizadas = 1 then
                begin
                    msgbaixo ('CTACONT'); {'A conta '}
                    sintetiza (contaFinalizada);
                    msgBaixo ('CTFOADGR'); {'Foi adicionada ao grupo de contas'}
                end
            else if opFinalizadas > 1 then
                msgbaixo('CTADGRCO'); {'Contas adicionadas ao grupo de contas'}
        end
    else
        begin
            if opFinalizadas = 1 then
                begin
                    msgbaixo ('CTACONT'); {'A conta '}
                    sintetiza (contaFinalizada);
                    msgBaixo('CTREGRCO'); {'Foi retirada do grupo de contas'}
                end
            else if opFinalizadas > 1 then
                msgbaixo('CTCOREGR'); {'Contas retiradas do grupo de contas'}
        end;


    senhaSalvaPop3 := senhaSalvaAux;
    contasSelecionadas.Free;
    folheiaDestroi;
    descarregarContas;
    textColor (WHITE);
    telaPrincipal;
end;

{--------------------------------------------------------}
{ seleciona as contas para serem usadas no grupo de contas
{--------------------------------------------------------}

procedure selecionarGrupoContas;
var c, c2: char;
label inicioCont;

begin
    repeat
        telaPrincipal;
        textBackground (BLUE);
        mensagem ('CTSEGRCO', 1); {'Seleo do Grupo de contas'}
        textBackground (BLACK);
        mensagem ('CTQUALOP', 0); {'Qual sua opo ? '}
        mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
        sintLeTecla (c, c2);
        writeln;

        if (c = #0) and ((c2 = BAIX) or (c2 = CIMA)) then
            c := selSetasSelecaoContas
        else
            if c = #0 then ajudaSelecContas;

        case upcase (c) of
            'A':  folhearContas(true);
            'R':  folhearContas(false);
        end;

    until c = ESC;

    mensagem ('CTOK', 1);  {'OK'}
end;


{-------------------------------------------------------------}
{       Fala nmero de cartas nos folheamentos
{-------------------------------------------------------------}

function falaNumeroTotalDeCartas: boolean;
var
    i: integer;
    dirVazio: boolean;
label erro;
begin
    dirVazio := true;
    i := numeroDeCartasGrupoContas ('P');
    if i = -1 then goto erro
    else
    if i > 0 then
        begin
            mensagem  ('CTPREPAR', 0); {'Preparadas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartasGrupoContas ('N');
    if i = -1 then goto erro
    else
    if i > 0 then
        begin
            mensagem  ('CTNAOLID', 0); {'No lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartasGrupoContas ('L');
    if i = -1 then goto erro
    else
    if i > 0 then
        begin
            mensagem ('CTLIDAS', 0); {'Lidas'}
            sintwriteln ('  ' + intToStr(i));
            dirVazio := false;
        end;
    i := numeroDeCartasGrupoContas ('T');
    if i = -1 then goto erro
    else
    if i > 0 then
        begin
            mensagem ('CTTRANSM', 0); {'Transmitidas'}
            sintwriteln ('  ' + intTostr(i));
            dirVazio := false;
        end;
    if dirVazio then
        mensagem ('CTSEMCAR', 1); {'No tem carta neste diretrio'}
    writeln;
    falaNumeroTotalDeCartas := true;
    exit;

erro:
    falaNumeroTotalDeCartas := false;

end;

{--------------------------------------------------------}
{       recebe as cartas das contas selecionadas
{--------------------------------------------------------}

procedure receberGrupoContas;
var nomes, szNomeConta: array [0..1000] of char;
    sz: array [0..144] of char;
    p: pchar;
    c, c2: char;
    estaNoGrupo, contaPorConta, existemContas: boolean;
    confAtual: shortString;
    cod, numTrazidas, n: integer;
label desistiu;
begin
    cod := 0;
    numTrazidas := 0;
    contaPorConta := false;
    existemContas := false;

    confAtual := nomeConfiguracao;
    getprivateProfileString (NIL, NIL, '', nomes, 1000, 'CARTAVOX.INI');
    p := nomes;
    while p^ <> #$0 do
        begin
            if keypressed then
                begin
                    c := readkey;
                    if c = ESC then break;
                end;

            strPCopy (szNomeConta, StrPas(p));
            n := getPrivateProfileString(szNomeConta, 'SERVIDORSMTP', '', sz, 144, 'CARTAVOX.INI');
            if n > 0 then
                begin
                    getPrivateProfileString(szNomeConta, 'GRUPODECONTAS', '', sz, 144, 'CARTAVOX.INI');
                    estaNoGrupo := upcase(sz[0]) = 'S';

                    if estaNoGrupo = true then
                        begin
                            if existemContas = false then
                                begin
                                    repeat
                                        mensagem ('CTTRCAAU', 1); {'Deseja trazer as cartas de todas as contas automaticamente?'}
                                        sintLeTecla (c, c2);
                                        writeln;
                                    until upcase (c) in ['R', ^R, 'S', 'N', ENTER, ESC];
                                    if upcase (c) = ESC then goto desistiu
                                    else if upcase (c) in ['N', ^R] then contaPorConta := true
                                    else if upcase (c) in ['R', 'S', ENTER] then contaPorConta := false;
                                end;
                            existemContas := true;
                            recuperaConfigGrupoContas (AnsiUpperCase(StrPas(p)));
                            if contaPorConta then
                            else
if upcase (c) in ['R', ^R] then
begin
mataspam;
end;
                                begin
//                                    mensagem('CTACECON', -1); {'Acessando conta '}
                                    mensagem('CTPEGAND', -1); {'Pegando '}
                            sintWriteln (nomeConfiguracao);
//                                    sintetiza (StrPas(p)); //Nome da configurao
                                    while sintFalando and (not keypressed) do
                                        waitMessage;
                                    cod := receberCartasGrupoContas(true);

                                    numTrazidas := numTrazidas + cod;

if cod = 0 then
begin
        sintWriteInt (cod); //Nmero de trazidas em cada conta
        mensagem ('CTREC', 2); {'Recebidas'}
end;

if cod = 1 then
begin
        mensagem ('CTUMA', 2); {'Uma'}
    write (' ');
        mensagem ('CTREC1', 2); {'recebida'}
end;

if cod = 2 then
begin
        mensagem ('CTDUAS', 2); {'Duas'}
    write (' ');
        mensagem ('CTREC', 2); {'recebidas'}
end;

if cod > 2 then
begin
        sintWriteInt (cod); //Nmero de trazidas em cada conta
    write (' ');
        mensagem ('CTREC', 2); {'recebidas'}
end;

                                end;
                       end;
                    if cod = -1 then break;
                end;
            p := p + strlen(p) + 1;
        end;

    if (cod <> -1) and (contaPorConta = false) and (existemContas) then
        begin
           if(numTrazidas > 0) then
begin
sintWriteLn ('Total: ');

if numTrazidas = 1 then
begin
        mensagem ('CTUMA', 2); {'Uma'}
    write (' ');
        mensagem ('CTREC1', 2); {'recebida'}
end;

if numTrazidas = 2 then
begin
        mensagem ('CTDUAS', 2); {'Duas'}
    write (' ');
        mensagem ('CTREC', 2); {'recebidas'}
end;

if numTrazidas > 2 then
begin
        sintWriteInt (numTrazidas); //Nmero de trazidas em cada conta
    write (' ');
        mensagem ('CTREC', 2); {'recebidas'}
end;

               mensagem ('CTOKPEG', 1);  {'Ok, peguei a correspondncia'}
end
           else
               mensagem ('CTNECASE', 1); {'No existem cartas nos servidores'}
        end;

    if existemContas = false then
        mensagem ('CTNAECSE', 1); {'No existem contas selecionadas'}

    recuperaConfigGrupoContas (confAtual);
    setWindowTitle ('CARTAVOX ' + confAtual);
    exit;

desistiu:
    msgBaixo ('CTDESIST'); {'Desistiu'}

end;

{--------------------------------------------------------}
{      transmite as cartas das contas selecionadas
{--------------------------------------------------------}

procedure transmitirGrupoContas;

var
    nomes, szNomeConta: array [0..1000] of char;
    sz: array [0..144] of char;
    p: pchar;
    estaNoGrupo, existemContas: boolean;
    confAtual: string;
    n, cod: integer;

begin
    existemContas := false;
    confAtual := nomeConfiguracao;
    getprivateProfileString (NIL, NIL, '', nomes, 1000, 'CARTAVOX.INI');
    p := nomes;
    while p^ <> #$0 do
        begin
            strPCopy (szNomeConta, StrPas(p));
            n := getPrivateProfileString(szNomeConta, 'SERVIDORSMTP', '', sz, 144, 'CARTAVOX.INI');
            if n > 0 then
                begin
                    getPrivateProfileString(szNomeConta, 'GRUPODECONTAS', '', sz, 144, 'CARTAVOX.INI');
                    estaNoGrupo := upcase(sz[0]) = 'S';

                    if estaNoGrupo = true then
                        begin
                            existemContas := true;
                            recuperaConfigGrupoContas (AnsiUpperCase(StrPas(p)));
                            cod := transmitirCartasGrupoContas;
                            if cod = -1 then break;
                        end;
                end;
            p := p + strlen(p) + 1;
        end;

    if existemContas = false then
        mensagem ('CTNAECSE', 1); {'No existem contas selecionadas'}

    recuperaConfigGrupoContas (confAtual);
    setWindowTitle ('CARTAVOX ' + confAtual);
end;

{--------------------------------------------------------}
{           monitora as contas selecionadas
{--------------------------------------------------------}

procedure monitorarGrupoContas;
var
    nomes, szNomeConta: array [0..1000] of char;
    sz: array [0..144] of char;
    p: pchar;
    estaNoGrupo, existemContas: boolean;
    contasNoGrupo: TStringList;
    confAtual: shortString;
    n: integer;
    
begin
    existemContas := false;
    contasNoGrupo := TStringList.Create;

    getprivateProfileString (NIL, NIL, '', nomes, 1000, 'CARTAVOX.INI');
    p := nomes;
    while p^ <> #$0 do
        begin
            strPCopy (szNomeConta, StrPas(p));
            n := getPrivateProfileString(szNomeConta, 'SERVIDORSMTP', '', sz, 144, 'CARTAVOX.INI');
            if n > 0 then
                begin
                    getPrivateProfileString(szNomeConta, 'GRUPODECONTAS', '', sz, 144, 'CARTAVOX.INI');
                    estaNoGrupo := upcase(sz[0]) = 'S';

                    if estaNoGrupo = true then
                        begin
                            existemContas := true;
                            contasNoGrupo.add(AnsiUpperCase(StrPas(p)));
                        end;
                end;
            p := p + strlen(p) + 1;
        end;
    confAtual := nomeConfiguracao;

    if existemContas then monitorarCorreioGrupoContas(contasNoGrupo)
    else
        mensagem ('CTNAECSE', 1); {'No existem contas selecionadas'}

    recuperaConfigGrupoContas (confAtual);
    setWindowTitle ('CARTAVOX ' + confAtual);
    contasNoGrupo.Free;
end;

{--------------------------------------------------------}
{   informar o total de cartas das contas selecionadas
{--------------------------------------------------------}

procedure informarCartasGrupoContas;
var
    nomes, szNomeConta: array [0..1000] of char;
    sz: array [0..144] of char;
    p: pchar;
    estaNoGrupo, existemContas, cod: boolean;
    confAtual: string;
    n: integer;

begin
    existemContas := false;
    confAtual := nomeConfiguracao;
    getprivateProfileString (NIL, NIL, '', nomes, 1000, 'CARTAVOX.INI');
    p := nomes;
    while p^ <> #$0 do
        begin
            strPCopy (szNomeConta, StrPas(p));
            n := getPrivateProfileString(szNomeConta, 'SERVIDORSMTP', '', sz, 144, 'CARTAVOX.INI');
            if n > 0 then
                begin
                    getPrivateProfileString(szNomeConta, 'GRUPODECONTAS', '', sz, 144, 'CARTAVOX.INI');
                    estaNoGrupo := upcase(sz[0]) = 'S';

                    if estaNoGrupo = true then
                        begin
                            existemContas := true;
                            recuperaConfigGrupoContas (AnsiUpperCase(StrPas(p)));
                            sintWriteln (nomeConfiguracao);
                            cod := falaNumeroTotalDeCartas;
                            if cod = false then break;
                        end;
                end;
            p := p + strlen(p) + 1;
        end;

    while keypressed do readkey;
    if existemContas = false then
        mensagem ('CTNAECSE', 1); {'No existem contas selecionadas'}

    recuperaConfigGrupoContas (confAtual);
    setWindowTitle ('CARTAVOX ' + confAtual);
end;

{--------------------------------------------------------}
{       ajuda do menu principal do grupo de contas
{--------------------------------------------------------}

procedure ajudaConfig;
begin
    writeln;
    if not keypressed then
        mensagem ('CTAJUD01', 2); {'As opes so'}
    if not keypressed then
        mensagem ('CTAJSE01', 1); {'   S - Selecionar contas'}
    if not keypressed then
        mensagem ('CTAJSE02', 1); {'   R - Receber cartas das contas selecionadas'}
    if not keypressed then
        mensagem ('CTAJSE03', 1); {'   T - Transmitir cartas das contas selecionadas'}
    if not keypressed then
        mensagem ('CTAJSE04', 1); {'   M - Monitorar contas selecionadas'}
    if not keypressed then
        mensagem ('CTAJSE05', 1); {'   Q - Informar total de cartas das contas selecionadas'}
end;

{--------------------------------------------------------}
{  seleciona a funo com as setas, opes do menu
{  principal do grupo de contas
{--------------------------------------------------------}

function selSetasConfig: char;
var n: integer;
const
    tabLetrasConfig: string [5] = 'SRTMQ';

begin
    popupMenuCria (wherex, wherey, 55, 5, MAGENTA);
    MenuAdiciona ('S - Selecionar contas');
    MenuAdiciona ('R - Receber cartas das contas selecionadas');
    MenuAdiciona ('T - Transmitir cartas das contas selecionadas');
    MenuAdiciona ('M - Monitorar contas selecionadas');
    MenuAdiciona ('Q - Informar total de cartas das contas selecionadas');

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasConfig := tabLetrasConfig[n]
    else
        selSetasConfig := ESC;
end;

{--------------------------------------------------------}
{      execuo do menu principal do grupo de contas
{--------------------------------------------------------}

procedure inicializaGrupoContas;
var c, c2: char;
label inicioCont;
begin
inicioCont:
    telaPrincipal;
    textBackground (BLUE);
    mensagem ('CTGRDECO', 1); {'Grupo de contas'}
    textBackground (BLACK);
    mensagem ('CTQUALOP', 0); {'Qual sua opo ? '}
    mensagem ('CTF1AJUD', 1); {'F1 ajuda '}
    sintLeTecla (c, c2);
    writeln;

    if (c = #0) and ((c2 = BAIX) or (c2 = CIMA)) then
        c := selSetasConfig
    else
    if c = #0 then
        begin
            ajudaConfig;
            goto inicioCont;
        end;

    case upcase (c) of
        'S':  selecionarGrupoContas;
        'R':  receberGrupoContas;
        'T':  transmitirGrupoContas;
        'M':  monitorarGrupoContas;
        'Q':  informarCartasGrupoContas;
    else
        if c <> ESC then
            begin
                msgBaixo ('CTOPCINV');   {'Opo invlida'}
                goto inicioCont;
            end
        else
            msgBaixo ('CTDESIST'); {'Desistiu'}
    end;

end;

end.
