{--------------------------------------------------------}
{
{   Cartavox - Folheador de cartas interativo no servidor
{
{--------------------------------------------------------}

unit carFolInt;

interface

uses
    dvarq,
    dvcrt,
    dvform,
    dvhora,
    dvWin,
    sysutils,
    windows,
    classes,
    carApeli,
    carCopia,
    carDecod,
    carEst,
    carLeit,
    carList,
    carMsg,
    carTela,
    carUtil,
    carVars,
    carSpam,
    carRegras;

procedure criaListaNomeArqTemp;
procedure adicionaStrListaNomeArqTemp (str: string);
procedure folhearCartasServidor (tipoFolhe: char);

implementation

uses
    carPop3;

var
    listaNomeArqTemp: TStringList;

{ Retornos }
const
    COD_ERRO = -1;

{--------------------------------------------------------}
{  Exclu o nome passado atravs do parmetro 'nomeArqProcurado'
{  da lista que contm os nomes dos arquivos temporrios
{--------------------------------------------------------}

procedure removeListaNomeArqTemp(nomeArqProcurado: string);
var
    indice: integer;
    nomeArq: string;

begin
    for indice := 0 to listaNomeArqTemp.Count - 1 do
        begin
            nomeArq := listaNomeArqTemp.Strings [indice];
            if nomeArqProcurado = nomeArq then
                begin
                    listaNomeArqTemp.delete(indice);
                    DeleteFile(Pchar(nomeArq));
                    exit;
                end;
        end;
end;

{--------------------------------------------------------}
{     Pega a posio do arquivo temporrio na lista pelo seu nome
{--------------------------------------------------------}

function pegaPosListaNomeArqTemp(nomeArqProcurado: string): integer;
var
    indice: integer;
    nomeArq: string;

begin
    for indice := 0 to listaNomeArqTemp.Count - 1 do
        begin
            nomeArq := listaNomeArqTemp.Strings [indice];
            if nomeArqProcurado = nomeArq then
                begin
                    pegaPosListaNomeArqTemp := indice+1;
                    exit;
                end;
        end;
    pegaPosListaNomeArqTemp := -1;
end;

{--------------------------------------------------------}
{     Pega a posio do arquivo temporrio na lista pelo
{     seu nome e exclu o nome da lista
{--------------------------------------------------------}

function pegaPosEDeletaListaNomeArqTemp(nomeArqProcurado: string): integer;
var
    indice: integer;
    nomeArq: string;

begin
    for indice := 0 to listaNomeArqTemp.Count - 1 do
        begin
            nomeArq := listaNomeArqTemp.Strings [indice];
            if nomeArqProcurado = nomeArq then
                begin
                    pegaPosEDeletaListaNomeArqTemp := indice+1;
                    listaNomeArqTemp.delete(indice);
                    DeleteFile(Pchar(nomeArq));
                    exit;
                end;
        end;
    pegaPosEDeletaListaNomeArqTemp := -1;
end;

{--------------------------------------------------------}
{       retorna o tamanho do arquivo passado
{--------------------------------------------------------}

function pegaTamArq (nome: string): integer;
var
    f: file of byte;
    tamanho: integer;

begin
    Assign(f, nome);
    {$I-} Reset(f); {$I+}
    if (IOResult <> 0) then;
    tamanho := FileSize(f);
    Close(f);
    pegaTamArq := tamanho;
end;

{--------------------------------------------------------}
{       retorna a data de criao do arquivo passado
{--------------------------------------------------------}

function pegaDatArq (nome: string): integer;
var
    data: Integer;

begin
    data := FileAge(nome);
    pegaDatArq := data;
end;


{--------------------------------------------------------}
{       monta lista de cartas do servidor
{--------------------------------------------------------}

procedure montaListaDeCartasServidor;
var
    indice: integer;
    nomeArq: string;

begin
    numRegs := 0;

    for indice := 0 to listaNomeArqTemp.Count - 1 do
        begin
            nomeArq := listaNomeArqTemp.Strings [indice];

            numRegs := numregs + 1;
            regLido [numRegs] := inicializaPEstrutura;
            regLido [numRegs]^.carta := inicializaPCarta;
            regLido [numRegs]^.carta^.nomArqCarta := nomeArq;
            regLido [numRegs]^.carta^.dataHora := pegaDatArq (nomeArq);
            regLido [numRegs]^.carta^.tamanho := pegaTamArq (nomeArq);
        end;
end;

{--------------------------------------------------------}
{       remove arquivos temporrios cujos nomes esto
{       na lista de cartas e limpa a lista
{--------------------------------------------------------}

procedure limpaListaNomeArqTemp;
var
    indice: integer;
    nomeArq: string;
begin

    if listaNomeArqTemp <> nil then
        begin
            for indice := 0 to listaNomeArqTemp.Count - 1 do
                begin
                    nomeArq := listaNomeArqTemp.strings [indice];
                    DeleteFile(Pchar(nomeArq));
                end;
            listaNomeArqTemp.free;
            listaNomeArqTemp := nil;
        end;
end;

{--------------------------------------------------------}
{       cria a lista que guardar os nomes dos arquivos temporrios
{--------------------------------------------------------}

procedure criaListaNomeArqTemp;
begin
    if listaNomeArqTemp = nil then
        listaNomeArqTemp := TStringList.create;
end;

{--------------------------------------------------------}
{       adiciona na lista string com os nomes dos arquivos temporrios
{--------------------------------------------------------}

procedure adicionaStrListaNomeArqTemp (str: string);
begin
    if listaNomeArqTemp <> nil then
        listaNomeArqTemp.add (str);
end;

{-------------------------------------------------------------}
{       Retorna somente o e-mail de uma string
{-------------------------------------------------------------}

function retornaEmail (s: string): string;
var
    saida: string;
    i, f: integer;
label fim;
begin
    saida := s;
    if trim (s) = '' then goto fim;
    i := pos ('<', s);
    f := pos ('>', s);
    if i >= f then goto fim;
    saida := copy (s, i+1, f-i+1);
fim:
    retornaEmail := saida;
end;

{--------------------------------------------------------}
{  procura uma carta pela opo escolhida pelo usurio
{--------------------------------------------------------}

procedure procurarNaCartaServidor (folheiaAchados: boolean; nCar: integer);
var
    c, c2: char;
    atual, cont, i, total: integer;
    achouJaUma, selecionado: boolean;
    textoBusc: string;



    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;


    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := trim (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := trim (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'A': procuraUmItem := textoBusc = limpaAssunto(regLido [nCar]^.carta^.subject);
            'R': begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
            procuraUmItem := textoBusc = retornaEmail (regLido [nCar]^.carta^.x_original_from)
else
            procuraUmItem := textoBusc = retornaEmail (regLido [nCar]^.carta^.from);
end;
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;


    procedure ajuda;
    begin
        mensagem ('CTAJUD01', 2); {'As opes so'}
        if not keypressed then
            mensagem ('CTCABCAR', 1); {'    C - Cabealho da carta'}
        if not keypressed then
            mensagem ('CTPROASS',1); {' A - Assunto desta carta'}
        if not keypressed then
            mensagem ('CTPROREM',1); {' R - Remetente desta carta'}
        if not keypressed then
            mensagem ('CTPRODAT', 1); {' H - Data de chegada desta carta'}
    end;


    function selSetas: char;
    var
        n: integer;
    const tabOpc: string[4] = 'CARH';
    begin
        popupMenuCria (35, wherey, 50, 7, RED);
        MenuAdiciona ('CTCABCAR'); {'    C - Cabealho da carta'}
        MenuAdiciona ('CTPROASS'); {' A - Assunto desta carta'}
        MenuAdiciona ('CTPROREM'); {' R - Remetente desta carta'}
        MenuAdiciona ('CTPRODAT'); {' H - Data de chegada desta carta'}

        n := popupMenuSeleciona;
        if (n >=1) and (n <= 4) then
            selSetas := tabOpc [n]
        else
            selSetas := #0;
    end;


begin
    c2 := #$0;
    if agruparPorAssunto then
        c:= 'A'
    else
    repeat
        limpaParteTela (20, 25);
        if not folheiaAchados then
            mensagem ('CTPROINV', 1); {'Procura invertida'}
        mensagem ('CTTIPPRO', 0); {'Qual o tipo de procura?'}
        write ('   ');
        mensagem ('CTF1AJUD', 1);         {'F1 ajuda '}
        c := upcase (readkey);
        if c = #0 then
            begin
                c := readkey;
                if c = F1 then ajuda
                else
                if (c = BAIX) or (c = CIMA) then c := selSetas;
            end;
    until c in ['C', 'A', 'R', 'H', ESC, ENTER];
    if not agruparPorAssunto then
        sintWriteln (c);

    if c in ['A', 'R'] then
        for i := 1 to numRegs do
            if not regLido [i]^.carta^.preenchido then
                begin
                    selecionado := regLido [i]^.selecionado;
                    carregaArqPreencheCabPrin ( i);
                    regLido [i]^.selecionado := selecionado;
                    if (i mod 500) = 0 then sintclek;
                end;

    case c of
        'A': begin
                textoBusc := limpaAssunto(regLido [nCar]^.carta^.subject);
                if trim (textoBusc) = '' then
                    textoBusc := regLido [nCar]^.carta^.subject;
             end;
        'R': begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        textoBusc := retornaEmail (regLido [nCar]^.carta^.x_original_from);
        decodificarString (textoBusc);
end
else
        textoBusc := retornaEmail (regLido [nCar]^.carta^.from);
end;
        'H': textoBusc := dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
    else
        repeat
            textoBusc := 'reply-to';
            if c in ['C', ENTER] then
                mensagem ('CTINFPRO', 1)    {'Informe o texto a procurar no cabealho da carta'}
            else
                begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
                    exit;
                end;
            c2 := sintEditaCampo (textoBusc, 1, wherey, 255, 80, true);
            textoBusc := semAcentos (textoBusc);
        until c2 in [ENTER, ESC];
    end;

    if (c2 = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
            msgBaixo ('CTACHEI')     {'Achei'}
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;


{--------------------------------------------------------}
{       ajuda no folheamento do servidor
{--------------------------------------------------------}

procedure ajudaFolheiaServidor;
begin
    telaFolheamentoCartas;
    textBackground(BLUE);
    if not keypressed then
        mensagem ('CTAJFL01', 2);  {'Folheie as cartas com as setas, depois tecle:'}
    textBackground(BLACK);

    if not keypressed then
        mensagem ('CTAJFL21', 1); {'A - Apagar carta do servidor'}
    if not keypressed then
        mensagem ('CTAJFL22', 1); {'R - Receber cartas do servidor'}
    if not keypressed then
        mensagem ('CTAJFL23', 1); {'Control R - Receber cartas sem apag-las do servidor'}
    if not keypressed then
        mensagem ('CTAJFL09', 1);  {'S - selecionar o nome do remetente associando-o a um apelido'}
    if not keypressed then
        mensagem ('CTAJFL03', 1);  {'I - para obter informaes sobre a carta'}
    if not keypressed then
        mensagem ('CTAJFL13', 1);  {'Q - Informar qual a carta do total'}
    if not keypressed then
        mensagem ('CTAJFL29', 1);  {'CTRL+Q - Informar quantas cartas selecionadas do total'}
    if not keypressed then
        mensagem ('CTAJFL15', 1);  {'D - Informa o tamanho da carta'}
    if not keypressed then
        mensagem ('CTAJFL28', 1);  {'CTRL+D - Informa o tamanho de todas as cartas'}
    if not keypressed then
        mensagem ('CTAJFL17', 1);  {'CTRL + N - Informa o nmero da carta'}
    if not keypressed then
        mensagem ('CTAJFL19', 1);  {'CTRL + G - Busca carta pelo nmero'}
    if not keypressed then
        mensagem ('CTAJFL24', 1);  {'B - Editar apelidos'}
    if not keypressed then
        mensagem ('CTAJFL26', 1);  {'F - Fala o remetente da carta'}
    if not keypressed then
        mensagem ('CTAJFL27', 1);  {'CTRL+F - Fala o destinatrio da carta'}
    if not keypressed then
        mensagem ('CTAJFL11', 1);  {'CTRL + L - Liberar o remetente no MataSpam'}
    if not keypressed then
        mensagem ('CTAJFL14', 1);  {'CTRL + B - Bloquear o remetente no MataSpam'}
    if not keypressed then
        mensagem ('CTAJFL32', 1);  {'F3 - Ordenar'}
    if not keypressed then
        mensagem ('CTAJFL10', 1);  {'F5 - procurar'}
    if not keypressed then
        mensagem ('CTAJFL30', 1);  {'F6 - procura invertida'}
    if not keypressed then
        mensagem ('CTAJFL07', 2);  {'ESC terminar folheamento'}
    if not keypressed then
        mensagem ('CTATCLF9', 0);  {'Tecle F9 para selecionar a opo com as setas'}

    textBackground(BLACK);  clreol;
    writeln;
    if keypressed and (readkey <> ESC) then
        begin
            limpaBufTec;
            readkey;
        end;
    limpaBufTec;
end;

{--------------------------------------------------------}
{      imprime informaes sobre a carta do servidor
{--------------------------------------------------------}

procedure infoCartaServidor (nCar: integer);
var data: string;

const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sabado');

begin
    delay (10);
    sintetiza (nomeConfiguracao);
    delay (10);
    limpaParteTela (18, 25);
    textBackground (RED);
    mensagem ('CTASSUNT', 0);  {'Assunto: '}
    textBackground (BLACK);
    writeln;
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
    contemAnexos (nCar);
    textBackground (RED);
    mensagem ('CTENVPOR', 0);  {'Enviada por '}
    textBackground (BLACK);
    writeln;
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
    decodificarString (regLido [nCar]^.carta^.x_original_from);
    sintWriteln ( regLido [nCar]^.carta^.x_original_from);
end
else
    sintWriteln ( regLido [nCar]^.carta^.from);
end;
        limpaParteTela (22, 25);
        textBackground (RED);
    mensagem ('CTDATENV', 0);  {'Data de envio: '}
    textBackground (BLACK);
    data := regLido [nCar]^.carta^.date;
    data := converteData (data, true);
    if data <> '' then
        sintWriteln (data);
    textBackground (RED);
    mensagem ('CTDATCHE', 0);  {'Data de chegada: '}
    textBackground (BLACK);
    sintWriteln (tabDias [dayOfWeek (fileDateToDateTime (
        reglido [nCar]^.carta^.datahora))]    + ' ' +
        dateToStr (fileDateToDateTime (regLido[nCar].carta^.datahora))  + ' ' +
        timeToStr(FileDateToDateTime(regLido[nCar].carta^.datahora)));
end;

{--------------------------------------------------------}
{   Inicializa o folheamento de cartas no servidor
{--------------------------------------------------------}

procedure inicializaFolheamento;
var
    i: integer;
    s: string;
begin
    folheiaCria (1, 3, 80, 17);
    for i :=  1 to numRegs do
        begin
            s := '';
            folheiaAdicionaEspecial (s, regLido [i]^.selecionado, s);
        end;
end;

{-------------------------------------------------------------}
{  Preenche item com as informaes da carta, se ainda vazio
{-------------------------------------------------------------}

procedure preencheItemOnlineServidor (nItem: integer; var conteudo, fala: string;
                              var selec: boolean);
var
    s, s2: string;
begin
    if (conteudo <> '') or (fala <> '') then exit;
    folheiaObtemItem (nItem, s, regLido[nItem]^.selecionado);

    carregaArqPreencheCabPrin (nItem);
begin
    if trim (regLido [nItem]^.carta^.x_original_from) <> '' then
begin
decodificarString (regLido [nItem]^.carta^.x_original_from);
        s := regLido [nItem]^.carta^.x_original_from;
end
else
        s := regLido [nItem]^.carta^.from;
    s := retornarNome (s, false);
end;

    s2 := regLido [nItem]^.carta^.subject;
    s2 := pegaPrefixoAssunto(s2) + limpaAssunto(s2);
    deletaAspas (s2);
    if s2 = '' then s2:= 'NULO';

    conteudo := copy (s+BRANCOS, 1, 30) +  copy (s2+BRANCOS, 1, 50);
    if FALANOMEPRIMEIRO then
        fala := s + ' ' + s2
    else
        fala := s2 + ' ' + s;
    selec := regLido [nItem]^.selecionado;
end;

{-------------------------------------------------------------}
{  Escolhe o tipo de ordenao da lista de cartas do servidor
{-------------------------------------------------------------}

procedure escolheOrdenacaoServidor;

    procedure ajuda;
    begin
        telaFolheamentoCartas;
        textBackground(BLUE);
        if not keypressed then
            mensagem ('CTAJOR00', 2);  {'Os tipos de ordenao so:'}
        textBackground(BLACK);
        mensagem ('CTAJOR01', 1);  {'C - Data de chegada'}
        mensagem ('CTAJOR02', 1);  {'E - Data de Envio'}
        mensagem ('CTAJOR03', 1);  {'A - Assunto'}
        mensagem ('CTAJOR04', 1);  {'N - Nome'}
        mensagem ('CTAJOR05', 1);  {'T - Tamanho'}
        mensagem ('CTAJOR06', 1); {'I - Inversa'}
        clreol;
        writeln;
        if keypressed and (readkey <> ESC) then
            begin
                limpaBufTec;
                readkey;
            end;
        limpaBufTec;
    end;

    function selSetasFolheia: char;
    var
        n: integer;
    const
        tabOrd: string [6] = 'CEANTI';
    begin
        popupMenuCria (35, wherey, 50, 6, RED);
        MenuAdiciona ('CTAJOR01'); {'C - Data de chegada'}
        MenuAdiciona ('CTAJOR02');  {'E - Data de Envio'}
        MenuAdiciona ('CTAJOR03');  {'A - Assunto'}
        MenuAdiciona ('CTAJOR04');  {'N - Nome'}
        MenuAdiciona ('CTAJOR05');  {'T - Tamanho'}
        MenuAdiciona ('CTAJOR06');  {'I - Inversa'}
        n := popupMenuSeleciona;
        if (n > 0) and (n <= 6) then
            selSetasFolheia := tabOrd [n]
        else
            selSetasFolheia := ' ';
    end;

var c, c2: char;
begin
    telaFolheamentoCartas;
    writeln;
    writeln;

    mensagem ('CTQUATOR', 1); {'Qual o tipo de ordenao?'}
    mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
    sintLeTecla (c, c2);
    writeln;

    if (c = #0) and (c2 in [BAIX, CIMA]) then
        c := selSetasFolheia
    else
    if c = #0 then
        begin
            ajuda;
            escolheOrdenacaoServidor;
            exit;
        end;

    case upcase (c) of
        'C': ordenarLista ('datahora', ordemInversa, true);
        'E': ordenarLista ('date',ordemInversa, true);
        'N': ordenarLista ('from',ordemInversa, true);
        'A': ordenarLista ('subject',ordemInversa, true);
        'T': ordenarLista ('tamanho',ordemInversa, true);
        'I': begin
                    ordemInversa := not ordemInversa;
                    ordenarLista ('datahora', ordemInversa, true);
             end
    else
        if c <> ESC then
            mensagem ('CTOPCINV', 2)   {'Opo invlida'}
        else
            mensagem ('CTDESIST', 2); {'Desistiu'}
    end;
end;

{--------------------------------------------------------}
{       associa nome a um apelido no servidor
{--------------------------------------------------------}

procedure selecionaApelidoServidor (nCar: integer);
var
    c:char;
   nome, apelido, s: string;
   k: integer;

label outroApelido;
begin

begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        nome := regLido [nCar]^.carta^.x_original_from;
        decodificarString (nome);
end
else
        nome := regLido [nCar]^.carta^.from;
end;
    if pos ('<', nome) = 0 then
        nome := '"' + nome + '" <' + nome + '>'
    else
    if pos ('"', nome) = 0 then
        begin
            k := pos ('<', nome);
            s := copy (nome, 1, k-1);
            delete (nome, 1, k);
            nome := '"' + s + '" <' + nome;
        end;

outroApelido:
    repeat
        limpaParteTela (20, 25);
        textBackground (RED);
        mensagem ('CTQAPELI', 0);    {'Informe o apelido desejado para '}
        textBackground (BLACK);
        writeln;
        sintWriteln (nome);

        apelido := nome;
        delete (apelido, 1, 1);
        apelido := copy (apelido, 1, pos ('"', apelido)-1);
        c := sintEditaCampo (apelido, 1, wherey, 255, 80, true);
        writeln;
    until c in [ENTER, ESC];
    if c = ESC then
        begin
            msgBaixo ('CTDESIST');   {'Desistiu'}
            exit;
        end;

    if apelido <> '' then
        begin
            if apelido[1] in [';', '[', '.', '=', '<', '''', '"'] then
                begin
                    msgBaixo ('CTAPEINV'); {'Apelido invlido'}
                    exit;
                end;

            if buscaApelido (apelido) <> '' then
                begin
                    repeat
                        limpaParteTela (20, 25);
                        textBackground (RED);
                        mensagem ('CTAPJAEX', 1); {'Apelido j existe, se manter este, apagar o anterior'}
                        mensagem ('CTDEESOU', 0); {'Deseja escolher outro?'}
                        mensagem ('CTSIMNAO', 0); {'(S/N) ? '}
                        c := upcase (sintReadkey);
                        writeln (c);
                    until c in ['S', 'N', ENTER, ESC];
                    if c = ESC then
                        begin
                            msgBaixo ('CTDESIST');   {'Desistiu'}
                            exit;
                        end
                    else
                    if not (upcase (c) in ['N', ENTER]) then
                        goto outroApelido;
                end;

            s := copy (nome, (pos('<', nome)+1), (pos ('>', nome) -1) - (pos('<', nome)+1));
            if not procuraEmail (s) then
                begin
                    trocaApelido (apelido, nome);
                    msgBaixo ('CTOK');   {'Ok'}
                end
            else
        msgBaixo ('CTEMJAEX');   {'e-mail j existe.'}
        end
    else
        msgBaixo ('CTDESIST');   {'Desistiu'}
end;

{--------------------------------------------------------}
{       seleciona a funo com as setas
{--------------------------------------------------------}

function selSetasFolheiaServidor (Var c: char): char;
var
    n: integer;
const
    tabLRec: string [20] = 'AR' + ^R + 'SIQ'+ ^Q+ 'D'+ ^D+ ^N+ ^G+
                           'BF'+ ^F+ ^L+ ^B + F3+ F5+ F6+ ESC;
begin

    popupMenuCria (30, wherey, 55, 20, RED);
    MenuAdiciona ('CTAJFL21'); {'A - Apagar a carta do servidor'}
    MenuAdiciona ('CTAJFL22'); {'R - Receber a carta do servidor'}
    MenuAdiciona ('CTAJFL23'); {'Control R - Receber a carta sem apag-la do servidor'}
    MenuAdiciona ('CTAJFL09');   {'S - selecionar o nome do remetente associando-o a um apelido'}
    MenuAdiciona ('CTAJFL03');  {'I - para obter informaes sobre a carta'}
    MenuAdiciona ('CTAJFL13');  {'Q - Informar qual a carta do total'}
    MenuAdiciona ('CTAJFL29');  {'CTRL+Q - Informar quantas cartas selecionadas do total'}
    MenuAdiciona ('CTAJFL15');  {'D - Informa o tamanho da carta'}
    MenuAdiciona ('CTAJFL28');  {'CTRL+D - Informa o tamanho de todas as cartas'}
    MenuAdiciona ('CTAJFL17');  {'CTRL + N - Informa o nmero da carta'}
    MenuAdiciona ('CTAJFL19');  {'CTRL + G - Busca carta pelo nmero'}
    MenuAdiciona ('CTAJFL24');  {'B - Editar apelidos'}
    MenuAdiciona ('CTAJFL26');  {'F - Fala o remetente da carta'}
    MenuAdiciona ('CTAJFL27');  {'CTRL+F - Fala o destinatrio da carta'}
    MenuAdiciona ('CTAJFL11');  {'CTRL + L - Liberar o remetente no MataSpam'}
    MenuAdiciona ('CTAJFL14');  {'CTRL + B - Bloquear o remetente no MataSpam'}
    MenuAdiciona ('CTAJFL32');  {'F3 - Ordenar'}
    MenuAdiciona ('CTAJFL10');  {'F5 - procurar'}
    MenuAdiciona ('CTAJFL30');  {'F6 - procura invertida'}
    MenuAdiciona ('CTAJFL07');  {'ESC terminar folheamento'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= 20) then
         if n in [15 .. 19] then
            begin
                selSetasFolheiaServidor := #0;
                c := tabLRec [n];
            end
         else selSetasFolheiaServidor := tabLRec [n]
    else
        begin
            selSetasFolheiaServidor := #0;
            c := f12;
        end;
end;

{----------------------------------------------------------------------}
{       Cabealho da tela do folheamento das cartas no servidor
{----------------------------------------------------------------------}

procedure telaFolheamentoCartasServidor;
var s: string;
begin
    clrscr;
    textBackGround (MAGENTA);
    s := 'Folheamento interativo no servidor';
    s := s + ' - ' + intToStr(numRegs) + ' ';
    if numRegs > 1 then
         s := s  + pegaTextoMensagem('CTCARTAS') {'Cartas'}
    else
                  s := s  + pegaTextoMensagem('CTCARTA'); {'Carta'}
    write (centralizaFrase (s));
    textBackground (BLACK);
    writeln (centralizaFrase(pegaTextoMensagem ('CTUSESET')));  {'Folheando: use as setas, depois tecle sua opo'}
end;

{----------------------------------------------------------------------}
{  Traz as cartas do servidor para o Cartavox
{  Parmetros:
{  existemSelecionados - se exitem cartas selecionadas, traz as cartas
{  selecionadas, seno traz a carta cujo cursor est em cima
{  nCar - indica o nmero da carta na lista cujo cursor est em cima
{  numRegs - indica o nmero de cartas que esto sendo exibidas na lista
{  primeiraCartaPop3 - indica o nmero da primeira carta que est sendo
{  exibida na lista
{----------------------------------------------------------------------}

procedure trazCartasServidor(existemSelecionados: boolean; nCar, numRegs, primeiraCartaPop3: integer);
var
    laco, i, x: integer;
    codPega: integer;
    nomeArqTemp, email: string;
    c, c2: char;
    cartasATrazer: Array[0..MAXCARTAS] of integer;
begin
    laco := 1;
    for i:=0 to MAXCARTAS do
        cartasATrazer[i] := -1;
    i := 0;

    email := enderUsuario;
    x := pos ('@', email);
    delete(email, 1, x);
    x := pos ('.', email);
    delete(email, x, length(email));
    if email = 'gmail' then
        begin
            mensagem('CTOPINSE', 1); {'Opo indisponvel neste servidor'}
            exit;
        end;

    if existemSelecionados = true then
        begin
            repeat
                msgBaixo ('CTDETZSE'); {'Deseja trazer todas as selecionadas?'}
                sintLeTecla (c, c2);
                writeln;
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if upcase(c) <> 'S' then
                msgBaixo ('CTDESIST')   {'Desistiu'}
            else
                begin
                    while laco <= numRegs do
                         begin
                            if regLido[laco]^.selecionado then
                                begin
                                    nomeArqTemp := regLido[laco]^.carta^.nomArqCarta;
                                    cartasATrazer[i] := pegaPosListaNomeArqTemp(nomeArqTemp);
                                    i := i + 1;
                                end;
                            laco := laco + 1;
                         end;
                    codPega := trazCartaServidor(cartasATrazer, true, primeiraCartaPop3, enderUsuario);
                    if codPega = COD_ERRO then exit;
                    msgBaixo('CTOKPEG'); {'Ok, peguei a correspondncia'}
                end;
        end;
    if existemSelecionados = false then
        begin
            repeat
                gotoxy (1, 20);
                mensagem ('CTDETZAS', 0); {'Deseja trazer a carta com o assunto '}
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
                mensagem ('CTSIMNAO', 0);  {'(S/N)'}
                write ('?');
                c := sintReadkey;
                writeln (c);
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if upcase(c) <> 'S' then
                msgBaixo ('CTDESIST') {'Desistiu'}
            else
                begin
                    nomeArqTemp := regLido[nCar]^.carta^.nomArqCarta;
                    cartasATrazer[i] := pegaPosListaNomeArqTemp(nomeArqTemp);

                    codPega := trazCartaServidor(cartasATrazer, true, primeiraCartaPop3, enderUsuario);
                    if codPega = COD_ERRO then exit;
                    msgBaixo('CTOKPEG');  {'Ok, peguei a correspondncia'}
                end;
        end;
end;

{----------------------------------------------------------------------}
{  Traz e apaga as cartas do servidor ou simplismente apaga as cartas
{  do servidor
{  Parmetros:
{  existemSelecionados - se exitem cartas selecionadas, traz as cartas
{  selecionadas, seno traz a carta cujo cursor est em cima
{  trazer - se verdadeiro, as cartas so trazidas e apagadas, se falso,
{  as cartas somente so apagadas
{  nCar - indica o nmero da carta na lista cujo cursor est em cima
{  numRegs - indica o nmero de cartas que esto sendo exibidas na lista
{  primeiraCartaPop3 - indica o nmero da primeira carta que est sendo
{  exibida na lista
{----------------------------------------------------------------------}

function trazEApagaCartasServidor(existemSelecionados, trazer: boolean; nCar, primeiraCartaPop3: integer): integer;
var laco, i, codPega: integer;
    nomeArqTemp: string;
    c, c2: char;
    numCartas: Array[0..MAXCARTAS] of integer;
    nomesAApagar: Array[0..MAXCARTAS] of string;
label fim;
begin
    laco := 1;
    for i:=0 to MAXCARTAS do
        numCartas[i] := -1;
    i := 0;
    if existemSelecionados = true then
        begin
            repeat
                if trazer then
                    msgBaixo ('CTDETZSE') {'Deseja trazer todas as selecionadas?'}
                else
                    msgBaixo ('CTAPASEL');   {'Deseja apagar as selecionadas? '}
                sintLeTecla (c, c2);
                writeln;
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if upcase(c) <> 'S' then
                msgBaixo ('CTDESIST')   {'Desistiu'}
            else
                begin
                     while laco <= numRegs do
                         begin
                            if regLido[laco]^.selecionado then
                                begin
                                    nomeArqTemp := regLido[laco]^.carta^.nomArqCarta;
                                    nomesAApagar[i] := nomeArqTemp;
                                    numCartas[i] := pegaPosListaNomeArqTemp(nomeArqTemp);
                                    i := i + 1;
                                end;
                            laco := laco + 1;
                        end;
                    if trazer then codPega := trazCartaServidor(numCartas, false, primeiraCartaPop3, enderUsuario)
                    else codPega := apagaCartaServidor(numCartas, primeiraCartaPop3);
                    if codPega = COD_ERRO then goto fim;
                    laco := 1;
                    while laco <= numRegs do
                        begin
                            if regLido[laco]^.selecionado then
                                begin
                                    apagaUmRegs(laco);
                                    nCar := nCar - 1;
                                end
                             else
                                 laco := laco + 1;
                        end;
                    i := 0;
                    while nomesAApagar[i] <> '' do
                        begin
                            removeListaNomeArqTemp(nomesAApagar[i]);
                            i := i+1;
                        end;
                    if trazer then
                        msgBaixo('CTOKPEG') {'Ok, peguei a correspondncia'}
                    else
                        msgBaixo ('CTOKAPAS');  {'Ok, cartas apagadas'}
                end;
        end;
    if existemSelecionados = false then
        begin
            repeat
                gotoxy (1, 20);
                if trazer then
                    mensagem ('CTDETZAS', 0) {'Deseja trazer a carta com o assunto '}
                else
                    mensagem ('CTCNFAPA', 1);  {'Confirma o apagamento desta carta com assunto'}
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
                mensagem ('CTSIMNAO', 0);  {'(S/N)'}
                write ('?');
                c := sintReadkey;
                writeln (c);
            until upcase (c) in ['S', 'N', ENTER, ESC];
            if upcase(c) <> 'S' then
                msgBaixo ('CTDESIST') {'Desistiu'}
            else
                begin
                    nomeArqTemp := regLido [nCar]^.carta^.nomArqCarta;
                    nomesAApagar[i] := nomeArqTemp;
                    numCartas[i] := pegaPosListaNomeArqTemp(nomeArqTemp);

                    if trazer then codPega := trazCartaServidor(numCartas, false, primeiraCartaPop3, enderUsuario)
                    else codPega := apagaCartaServidor(numCartas, primeiraCartaPop3);
                    if codPega = COD_ERRO then goto fim;

                    apagaUmRegs(nCar);
                    removeListaNomeArqTemp(nomesAApagar[i]);
                    nCar := nCar - 1;
                    if trazer then msgBaixo('CTOKPEG')  {'Ok, peguei a correspondncia'}
                    else msgBaixo ('CTOKAPA');  {'Ok, carta apagada'}
                end;
        end;
    if nCar < 1 then nCar := 1;

fim:
    trazEApagaCartasServidor := nCar;
end;

{--------------------------------------------------------}
{           folheamento no servidor
{--------------------------------------------------------}

procedure folhearCartasServidor (tipoFolhe: char);
var
    c, c2: char;
    nCar, i, primeiraCartaPop3, totalAntes, totalDepois: integer;
    s: string;
    podeFalar, aux: boolean;
    existemSelecionados: boolean;
label procurarAchou;

begin
    totalAntes := numeroDeCartas ('F');
    primeiraCartaPop3 := receberCartasServidor;
    if primeiraCartaPop3 = COD_ERRO then exit;
    montaListaDeCartasServidor;
    if numRegs = 0 then
        begin
            msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
            exit;
        end;

    if ordenarDataEnvio then
        ordenarLista ('date', ordemInversa, true)
    else
        ordenarLista ('datahora', ordemInversa, true);

procurarAchou:
    setWindowTitle ('CARTAVOX ' + nomeConfiguracao + ' - Folheando servidor...');
    telaFolheamentoCartas;
    falaNumeroCartas;
    mensagem ('CTUSESET', -1);  {'Folheando: use as setas, depois tecle sua opo'}

    nCar := 1;
    podeFalar := true;
    repeat
        telaFolheamentoCartasServidor;
        inicializaFolheamento;
        folheiaCorDoMeio (1, 30, CYAN);

        FolheiaPreencheItemOnline := @preencheItemOnlineServidor;
        folheiaExecuta (nCar, nCar, c, c2, podeFalar);
        FolheiaPreencheItemOnline := NIL;

        if nCar < 1 then nCar := 1;
        if nCar > numRegs then nCar := numRegs;
        sintPara;
        existemSelecionados := false;
        for i := 1 to numRegs do
            begin
                folheiaObtemItem (i, s, regLido[i]^.selecionado);
                if regLido[i]^.selecionado then existemSelecionados := true;
            end;

        gotoxy (1, 19);
        if c2 = F9 then
            c := selSetasFolheiaServidor (c2);

        if c = #0 then
            begin
                case c2 of
                    DIR: begin
                            s := regLido [nCar]^.carta^.subject;
                            s := pegaPrefixoAssunto(s) + limpaAssunto(s);
                            if trim(s) = '' then
                                s := 'Nulo';
                            sintetiza (s);
                            contemAnexos (nCar);
                         end;
                    ESQ: begin
    sintetiza (intToStr (nCar));
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
                    decodificarString (regLido [nCar]^.carta^.x_original_from);
                    sintetiza (regLido [nCar]^.carta^.x_original_from);
end
else
                    sintetiza (regLido [nCar]^.carta^.from);
end;
                    F1:    ajudaFolheiaServidor;
                    F3:  begin
                                folheiaDestroi;
                                escolheOrdenacaoServidor;
                                goto procurarAchou;
                         end;
                    F5, f6:  begin
                                folheiaDestroi;
                                aux := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procurarNaCartaServidor (c2 = F5, nCar);
                                agruparPorAssunto := aux;
                                goto procurarAchou;
                         end;
                    F8:     falaHora;
                    CTLF8:   falaDia;
                    ^B, ^K: adicionaNoMataSpam (nCar, true);
                    ^L: adicionaNoMataSpam (nCar, false);
                end;
            end
        else
            begin
                c := upcase (c);
                case c of
                    'I': infoCartaServidor (nCar);
                    ^I:   begin
                             sintSoletra (nomeConfiguracao);
                             delay (20);
                          end;
                    'B': editarApelidos;
                    ^N : sintetiza (intToStr (nCar));
                    'D': tamanhoCarta (nCar);
                    ^D : tamanhoTotalServidor;
                    'P':
                        begin
                            folheiaDestroi;
                            if carregaLinhasArquivo (regLido[ncar]^.carta^.nomArqCarta) then//Aloca o arquivo da carta
                                begin
                                    preencheCartaPrincipal (regLido[ncar]);//preenche o cabealho principal da carta
                                    destroiLinhasArquivo;//Desaloca o arquivo da carta
                                end;
                            mostraItensCarta ( regLido[nCar]);
                        end;
                    'A', ^A: nCar := trazEApagaCartasServidor(existemSelecionados, false, nCar, primeiraCartaPop3);
                    'R': nCar := trazEApagaCartasServidor(existemSelecionados, true, nCar, primeiraCartaPop3);
                    ^R: trazCartasServidor(existemSelecionados, nCar, numRegs, primeiraCartaPop3);
                    'F': begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
                    decodificarString (regLido [nCar]^.carta^.x_original_from);
                    sintetiza (regLido [nCar]^.carta^.x_original_from);
end
else
                    sintetiza (regLido [nCar]^.carta^.from);
end;
                    ^F: if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
                            sintetiza (regLido [nCar]^.carta^.delivered_to)
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                            sintetiza (regLido [nCar]^.carta^.to_)
                        else
                            sintetiza (regLido [nCar]^.carta^.bcc);
                    'S': selecionaApelidoServidor (nCar);
                    ^S: for i := 1 to numRegs do
                            regLido [i]^.selecionado := true;

                    'Q', ^Q: falaQualItemDeQuantos (nCar, c = ^Q);
                    ^G: nCar := posicaoCarta (nCar);
                    'X':;

                    ESC: //if perguntaAoSairFolheamento then
                        repeat
                            msgBaixo('CTSAIFOL'); {'Deseja sair do folheamento?'}
                            sintLeTecla (c, c2);
                            if (upcase(c) in ['S', ENTER]) or (upcase (c2) = BAIX) then c := ESC
                            else
                                begin
//                                    msgBaixo('CTDESIST'); {'Desistiu'}
                                    c := 'N';
                                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}
                                end;
                        until (upcase(c) in ['S', 'N', ENTER, ESC]) or (upcase (c2) = BAIX);

                else
                    if c <> ESC then msgBaixo ('CTOPVINV'); {'Opo invalida'}
                end;

                if (numRegs >0) and (c <> ESC) and
                    (upcase(c) in ['I', 'B', 'P', 'A', ^A, 'S', 'R', ^R]) then
                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}

            end;

        if numRegs <= 0 then
            begin
                msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
                c := ESC;
            end;
        if (upCase(c) in[^N, 'D', ^D, 'F', ^F, 'Q', ^Q,
            'I', 'B', 'P', 'A', ^A, 'S', 'R', ^R]) or
            (c2 in [ESQ, DIR, f8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

        if not (upcase (c) = 'P') then folheiaDestroi;

    until c = #$1b;

//    if numRegs > 0 then msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
//    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
//    desmontaListaDeCartas;
//    limpaListaNomeArqTemp;

    setWindowTitle ('CARTAVOX ' + nomeConfiguracao);
    if numRegs > 0 then
        begin
            msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
//  --- Deleta os arquivos temporrios ---
            for i := 1 to numRegs do
                if maiuscansi(retornaExtensao(regLido [i]^.carta^.nomArqCarta)) = 'TMP' then
                    if not apagaCarta (i, false) then break;
            desmontaListaDeCartas;
        end;

    totalDepois := numeroDeCartas ('F');
    if (aplicRegras) and (totalDepois > totalAntes) then aplicarRegrasCartas('N');
end;

end.
