{-------------------------------------------------------------}
{
{           cartaVox - Regras
{
{           Autora: Tamires Maciel
{           Em Junho de 2010.
{
{-------------------------------------------------------------}

unit carRegras;

interface

uses
    dvcrt,
    dvform,
    dvWin,
    sysUtils,
    uuenc,
    windows,
    carCopia,
    carEst,
    carList,
    carMsg,
    carUtil,
    carVars,
    carFolhe,
    carTela,
    carResp;

    procedure aplicarRegrasCartas (sFuncao : string = ''; respAut: boolean = false);
    procedure inicializaRegras;

implementation

const
    NUMMAXREGRA= 30000;

type
    TRegra= record
                regra: string;
                nome: string;
                pasta: string;
                selecionado: boolean;
            end;

    Pregra= ^TRegra;
    treg = array [1..NUMMAXREGRA] of Pregra;

    TAux = record
        nome: string;
        numero: integer;
    end;

var
     arqRegras: text;
     reg: treg;
     numRegras, nFolhe: integer;


procedure carregarNomesPastas;
var
    k, i: integer;
    linha, pasta: string;
    pastaGuardada: boolean;
begin
    numRegras := 0;
    for i := 0 to (linhasArquivo.count -1) do
        begin
            linha := trim (linhasArquivo[i]);
            if (linha = '') or ((linha[1] = '[') and (pos('=', linha) = 0)) then continue;
            k := pos ('=', linha);
            if k > 1 then
                pasta := copy (linha, k+1, length (linha)-k);

            pastaGuardada := false;
            for k := 1 to numRegras do
                if uppercase(reg[k]^.pasta) = uppercase(pasta) then
                    begin
                        pastaGuardada := true;
                        break;
                    end;

            if not pastaGuardada then
            begin
                numRegras :=  numRegras + 1;
                new (reg[numRegras]);
                reg[numRegras]^.pasta := pasta;
            end;
        end;
end;

procedure criaPasta(nome: string);
var attributes: integer;
begin
     if not DirectoryExists(nome) then
     begin
     attributes := FileGetAttr(dirRecebe);
        if FileSetAttr (dirRecebe, Attributes xor faReadOnly) = 0 then
                ForceDirectories(nome);
     end;
end;

procedure carregarRegras;
var
    k: byte;
    i: integer;
    linha, regra, nome, pasta: string;

begin
    numRegras := 0;

    for i := 0 to (linhasArquivo.count -1) do
        begin
            linha := trim (linhasArquivo[i]);
            if linha = '' then continue;
            if (linha[1] in ['[']) and (pos('=', linha) = 0) then
            begin
                regra := copy(linha, 2, pos(']', linha) - 2);
                continue;
            end;

            k := pos ('=', linha);
            if k <> 0 then
            begin
                if k > 1 then
                    nome := copy (linha, 1, k-1)
                else
                    nome := '';
                if linha[k+1] = '"' then
                    delete (linha, 1, k+1)
                else
                    delete (linha, 1, k);
            end
            else
                nome := '';

            if k > 1 then
                pasta := copy (linha, 1, length (linha));

            numRegras :=  numRegras + 1;
            new (reg[numRegras]);
            reg[numRegras]^.regra := regra;
            reg[numRegras]^.nome := nome;
            reg[numRegras]^.pasta := pasta;
            reg[numRegras]^.selecionado := false;
        end;
end;

procedure buscaTodasCartas (extensao: string);
var
    DirInfo: TSearchRec;
    ext: array [0..10] of char;
    dosError: integer;
    nomeArq: string;

label proximoArq;

begin
    numRegs := 0;

    strPcopy (ext, '*.'+extensao);
    dosError := FindFirst (ext, FaArchive, DirInfo);
    while (DosError = 0) and (numRegs < maxCartas) do
        begin
            nomeArq := trim(dirInfo.name);

            numRegs := numregs + 1;
            regLido [numRegs] := inicializaPEstrutura;
            regLido [numRegs]^.carta := inicializaPCarta;
            regLido [numRegs]^.carta^.nomArqCarta := nomeArq;
            regLido [numRegs]^.carta^.dataHora := dirInfo.Time;
            regLido [numRegs]^.carta^.tamanho := dirInfo.size;
proximoArq:
            dosError := FindNext (DirInfo);
        end;
end;

function buscaRegraRemetente (nomeBusc: string): string;
var
    i : integer;
begin
    chdir(dirRecebe);
    if not carregaLinhasArquivo ('regras.ini') then
        exit;
    carregarRegras;
    destroiLinhasArquivo;

    for i :=  1 to numRegras do
        begin
            if(reg[i]^.regra = 'MOVER REMETENTE') then
            begin
                 if uppercase(reg[i]^.nome) = uppercase(nomeBusc) then
                 begin
                        buscaRegraRemetente := reg[i]^.pasta;
                        exit;
                 end;

            end
            else if(reg[i]^.regra = 'EXCLUIR') then
            begin
                 if(reg[i]^.pasta = 'REMETENTE') then
                 begin
                     if uppercase(reg[i]^.nome) = uppercase(nomeBusc) then
                     begin
                        buscaRegraRemetente := 'EXCLUIR';
                        exit;
                     end;
                 end;
            end;
        end;

    buscaRegraRemetente := '';
end;

function buscaRegraAssunto (nomeBusc: string): string;
var
    i : integer;
    nomeAux : string;
begin
    chdir(dirRecebe);
    if not carregaLinhasArquivo ('regras.ini') then
        exit;
    carregarRegras;
    destroiLinhasArquivo;

    for i :=  1 to numRegras do
        begin
            if(reg[i]^.regra = 'MOVER ASSUNTO') then
            begin
                 if pos('-[', reg[i]^.nome) = 1 then
                        nomeAux := copy(reg[i]^.nome, 2, length(reg[i]^.nome))
                 else
                        nomeAux := reg[i]^.nome;
                 if (pos (uppercase(nomeAux), uppercase(nomeBusc)) > 0) then
                 begin
                        buscaRegraAssunto := reg[i]^.pasta;
                        exit;
                 end;

            end
            else if(reg[i]^.regra = 'EXCLUIR') then
            begin
                 if(reg[i]^.pasta = 'ASSUNTO') then
                 begin
                 if pos('-[', reg[i]^.nome) = 1 then
                        nomeAux := copy(reg[i]^.nome, 2, length(reg[i]^.nome))
                 else
                        nomeAux := reg[i]^.nome;
                     if (pos(uppercase(nomeAux), uppercase(nomeBusc)) > 0) then
                     begin
                        buscaRegraAssunto := 'EXCLUIR';
                        exit;
                     end;
                 end;
            end;
        end;

    buscaRegraAssunto := '';
end;

procedure criarRegras;
var
    r1, c1, c2: char;
    keyname, newStr, amb: array [0..144] of char;
    nomeRegra, pastaCarta, res : string;

    function nomeArqPastaValido: boolean;
    var i: integer;
    begin
        nomeArqPastaValido := false;
        i := pos('\', pastaCarta);
        i := i + pos('/', pastaCarta);
        i := i + pos(':', pastaCarta);
        i := i + pos('<', pastaCarta);
        i := i + pos('>', pastaCarta);
        i := i + pos('?', pastaCarta);
        i := i + pos('*', pastaCarta);
        i := i + pos('|', pastaCarta);
        i := i + pos('"', pastaCarta);
        if i <> 0 then
            mensagem('CTCARCNP',0) {'Caracteres / \ < > " ? : * | no permitidos'}
        else
            nomeArqPastaValido:= true;
        writeln;
    end;

begin
    repeat
            mensagem('CTREGESC', 1); {'Digite A para aplicar regra sobre o assunto e R para remetente'}
            r1 := readkey();
    until upcase (r1) in ['A', 'R', ESC];

    if (upcase(r1) = 'A') then
    begin
            repeat
                    mensagem('CTREGAAS', 1); {'Digite o assunto sobre o qual deseja aplicar a regra'}
                    sintReadln (nomeRegra);
                    if nomeRegra = '' then
                    begin
                            mensagem ('CTDESIST', 2);    {'Desistiu...'}
                            exit;
                    end;
                    if pos('[', nomeRegra) = 1 then
                            nomeRegra := '-' + nomeRegra;

                    res := buscaRegraAssunto(nomeRegra);
                    if res <> '' then
                            mensagem('CTREGEXA',1); {'J existe regra para este assunto'}
            until res = '';
            strPCopy (keyName, nomeRegra);

            repeat
                    mensagem('CTREGFAZ', 1); {'O que voc deseja fazer com essas cartas? Digite P para mover para pasta ou E para excluir'}
                    c1 := readkey();
            until upcase (c1) in ['P', 'E', ESC];
            if c1 = ESC then
                begin
                    mensagem ('CTDESIST', 2);    {'Desistiu...'}
                    exit;
                end;

            strPCopy (amb, dirRecebe + '\regras.ini');
            if upcase(c1) = 'P' then
            begin
                    repeat
                            mensagem('CTREGPAS', 1); {'Para qual pasta voc deseja mover essa carta?'}
                            sintReadln(pastaCarta);
                            if pastaCarta = '' then
                            begin
                                    mensagem ('CTDESIST', 2);    {'Desistiu...'}
                                    exit;
                            end;
                    until nomeArqPastaValido;

                    strPCopy(newStr, pastaCarta);
                    WritePrivateProfileString('MOVER ASSUNTO', keyName, newStr, amb);
            end
            else
                    WritePrivateProfileString('EXCLUIR', keyName, 'ASSUNTO', amb);
            repeat
                    textBackGround (RED);
                    mensagem('CTREGAPE', 1); {'Deseja aplicar a regra sobre as cartas existentes?'}
                    sintLeTecla (c1, c2);
                    textBackGround (BLACK);
                    writeln;
            until upcase (c1) in ['S', 'N', ENTER, ESC];
            if upcase(c1) = 'S' then
                    aplicarRegrasCartas();
            end
    else if (upcase(r1) = 'R') then
    begin
            repeat
                    mensagem('CTREGARE', 1); {'Digite o email do remetente sobre o qual deseja aplicar a regra'}
                    sintReadln (nomeRegra);
                    if nomeRegra = '' then
                    begin
                            mensagem ('CTDESIST', 2);    {'Desistiu...'}
                            exit;
                    end;
                    res := buscaRegraRemetente(nomeRegra);
                    if res <> '' then
                            mensagem('CTREGEXR', 1); {'J existe regra para este remetente'}
                    if pos('[', nomeRegra) > 0 then
                    begin
                            sintwriteln('Caracter [ no permitido para email');
                            res := '';
                    end;
            until res = '';
            strPCopy (keyName, nomeRegra);
            repeat
                    mensagem('CTREGFAZ', 1); {'O que voc deseja fazer com essas cartas? Digite P para mover para pasta ou E para excluir'}
                    c1 := readkey();
            until upcase (c1) in ['P', 'E', ESC];
            if c1 = ESC then
                begin
                    mensagem ('CTDESIST', 2);    {'Desistiu...'}
                    exit;
                end;

            strPCopy (amb,  dirRecebe + '\regras.ini');
            if upcase(c1) = 'P' then
            begin
                    repeat
                            mensagem('CTREGPAS', 1); {'Para qual pasta voc deseja mover essa carta?'}
                            sintReadln(pastaCarta);
                            if pastaCarta = '' then
                            begin
                                    mensagem ('CTDESIST', 2);    {'Desistiu...'}
                                    exit;
                            end;
                    until nomeArqPastaValido;

                    strPCopy(newStr, pastaCarta);
                    WritePrivateProfileString('MOVER REMETENTE', keyName, newStr, amb);
            end
            else
                    WritePrivateProfileString('EXCLUIR', keyName, 'REMETENTE', amb);
            repeat
                    textBackGround (RED);
                    mensagem('CTREGAPE', 1); {'Deseja aplicar a regra sobre as cartas existentes?'}
                    sintLeTecla (c1, c2);
                    textBackGround (BLACK);
                    writeln;
            until upcase (c1) in ['S', 'N', ENTER, ESC];
            if upcase(c1) = 'S' then
                    aplicarRegrasCartas();
    end;
end;

procedure aplicarRegrasCartas (sFuncao : string = ''; respAut: boolean = false);
var
    j, aux, iLista, numLix, cont: integer;
    nome: string;
    arq: file;
    listaPasta : array [0..50] of Taux;
    encontrou : boolean;


    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintclek;
                cont := 0;
            end;
    end;

begin
    cont := 0;
    msgBaixo('CTMOMENT'); {'Um momento ...'}
numRegs := 0;
numLix := 0;
iLista := 0;

chdir (dirRecebe);
if sFuncao = '' then
        buscaTodasCartas('CAR')
else
        montaListaDeCartas ('CAR', 'N');

   if numRegs = 0 then
   begin
        mensagem('CTREGCAR', 1); {'No existem cartas para aplicar as regras'}
        exit;
   end;

   if not carregaLinhasArquivo ('regras.ini') then
   begin
        msgBaixo ('CTARQREG'); {'Arquivo com as regras no existe.'}
        exit;
   end;

   if linhasArquivo.Count = 0 then
   begin
        mensagem ('CTREGVAZ', 1); {'O arquivo de regras est vazio'}
        destroiLinhasArquivo;
        exit;
   end;
   destroiLinhasArquivo;

   for j := 1 to numRegs do
      begin
        contadorBipa (1500);
        carregaArqPreencheCabPrin (j);
begin
    if trim (regLido [j]^.carta^.x_original_from) <> '' then
        nome := copy(regLido [j]^.carta^.x_original_from, pos('<', regLido [j]^.carta^.from) + 1,  pos('>', regLido[j]^.carta^.from))
else
        nome := copy(regLido [j]^.carta^.from, pos('<', regLido [j]^.carta^.from) + 1,  pos('>', regLido[j]^.carta^.from));
end;
        nome := copy(nome, 0,  pos('>', nome) - 1);
        nome := buscaRegraRemetente(nome);
        if nome <> '' then
        begin
                if (nome <> 'REMETENTE') then
                begin
                        criaPasta(dirRecebe + '\' + nome);
                        copiaUm(regLido[j]^.carta^.nomArqCarta, dirRecebe + '\' + nome + '\' + regLido[j]^.carta^.nomArqCarta);
                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                        {$I-}  erase (arq); {$i+}

                        if respAut then
                            begin
                                excluirStrListaCAR (dirRecebe + '\' + regLido[j]^.carta^.nomArqCarta);
                                adicionaListaCAR (dirRecebe + '\' + nome + '\' + regLido[j]^.carta^.nomArqCarta);
                            end;

                        encontrou := false;
                        for aux := 0 to Length(listaPasta) do
                        begin
                                if listaPasta[aux].nome = '' then
                                        break;
                                if listaPasta[aux].nome = nome then
                                begin
                                        listaPasta[aux].numero := listaPasta[aux].numero + 1;
                                        encontrou := true;
                                        break;
                                end;
                        end;
                        if not encontrou then
                        begin
                                listaPasta [iLista].nome := nome;
                                listaPasta [iLista].numero := 1;
                                iLista := iLista + 1;
                        end;
                end
                else
                begin
                        copiaLixeira(regLido[j]^.carta^.nomArqCarta);
                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                        {$I-}  erase (arq); {$i+}
                        numLix := numLix + 1;
                end;

        end
        else
        begin
                nome := regLido[j]^.carta^.subject;
                nome := buscaRegraAssunto(nome);
                if (nome <> '') then
                begin
                    if (nome <> 'ASSUNTO') then
                    begin
                        criaPasta(dirRecebe + '\' + nome);
                        copiaUm(regLido[j]^.carta^.nomArqCarta, dirRecebe + '\' + nome + '\' + regLido[j]^.carta^.nomArqCarta);
                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                        {$I-}  erase (arq); {$i+}

                        if respAut then
                            begin
                                excluirStrListaCAR (dirRecebe + '\' + regLido[j]^.carta^.nomArqCarta);
                                adicionaListaCAR (dirRecebe + '\' + nome + '\' + regLido[j]^.carta^.nomArqCarta);
                            end;

                        encontrou := false;
                        for aux := 0 to Length(listaPasta) do
                        begin
                                if listaPasta[aux].nome = '' then
                                        break;
                                if listaPasta[aux].nome = nome then
                                begin
                                        listaPasta[aux].numero := listaPasta[aux].numero + 1;
                                        encontrou := true;
                                        break;
                                end;
                        end;
                        if not encontrou then
                        begin
                                listaPasta [iLista].nome := nome;
                                listaPasta [iLista].numero := 1;
                                iLista := iLista + 1;
                        end;
                    end
                    else
                    begin
                        copiaLixeira(regLido[j]^.carta^.nomArqCarta);
                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                        {$I-}  erase (arq); {$i+}
                        numLix := numLix + 1;
                    end;
                end;
        end;
      end;
      if numRegs > 0 then
      begin
        mensagem('CTREGAPL', 1); {'Regras aplicadas'}
        if numLix > 0 then
        begin
                sintWriteInt(numLix);
                mensagem('CTCARLIX',1); {'Cartas movidas para a lixeira'}
        end;
        if Length(listaPasta) > 0 then
        begin
                for aux := 0 to Length(listaPasta) do
                begin
                        if listaPasta[aux].nome <> '' then
                        begin
                                sintWriteInt(listaPasta[aux].numero);
                                mensagem('CTCARPAS', 1); {'Carta movida para a pasta '}
                                sintwriteln(listaPasta[aux].nome);
                        end
                        else
                                exit;
                end;
        end;
      end;
end;

procedure criaArquivoRegras;

var c1, c2 : char;

begin
        assign (arqRegras, 'regras.ini');
        if not existeArq('regras.ini') then
        repeat
                textBackGround (RED);
                mensagem ('CTARQNDC', 0); {'Arquivo no existe, deseja cria-lo? '}
                mensagem ('CTSIMNAO', 0); {'(S/N) ? '}
                sintLeTecla (c1, c2);
                textBackGround (BLACK);
                writeln;
        until upcase (c1) in ['S', 'N', ENTER, ESC];
        if c1 = ESC then
        begin
                mensagem ('CTDESIST', 2);    {'Desistiu...'}
                exit;
        end
        else
        if upcase (c1) = 'S' then
        begin
                {$I-} rewrite (arqRegras); {$I+}
                if ioresult <> 0 then exit
                else
                begin
                        {$i-} close (arqRegras); {$i+}
                        if ioresult <> 0 then;
                                mensagem ('CTOK', 2); {'Ok'}
                end;
        end;
end;

procedure folheiaPasta(nomePasta : string; tipo : char);
begin
        if (nomePasta <> '') then
        begin
                if DirectoryExists(dirRecebe + '\' + nomePasta) then
                begin
                if upcase(tipo) in ['F', 'N', 'L'] then
                   folhearCartas(tipo, dirRecebe + '\' + nomePasta)
                else
                   //avisa que s tem os trs tipos
                end
                else
                    mensagem('CTPASNEN', 1); {'Pasta no encontrada'}
        end;

end;


procedure inicializaFolheamentoRegras;
var
    i: integer;
    regra, nome, pasta, nomeAux: string;
begin
    folheiaCria (1, 6, 80, 21);
    for i :=  1 to numRegras do
        begin
            regra := copy (reg[i]^.regra+BRANCOS, 1, 20);
            nome := copy (reg[i]^.nome + BRANCOS, 1, 25);
            pasta := copy (reg[i]^.pasta + BRANCOS, 1, 45);

            if pos('-[', nome) = 1 then
                nomeAux := copy(nome, 2, length(nome))
            else
                nomeAux := nome;
            if (trim(regra) = 'EXCLUIR') then
                folheiaAdicionaEspecial (regra + pasta + nomeAux,
                                     reg[i]^.selecionado, regra + pasta + nomeAux)
            else
                folheiaAdicionaEspecial (regra + nomeAux + ' para a pasta ' + pasta,
                                     reg[i]^.selecionado, regra + nomeAux + ' para a pasta ' + pasta);

        end;
end;

procedure inicializaFolheamentoPastas;
var
    i: integer;
    pasta: string;

    function jaTemNaLista(k: integer): boolean;
    var j: integer;
    begin
        jaTemNaLista := true;
        for j := 1 to (k-1) do
            if reg[k]^.pasta = reg[j]^.pasta then
                exit;
        jaTemNaLista := false;
    end;

begin
    folheiaCria (1, 6, 80, 21);
    for i :=  1 to numRegras do
        begin
            if jaTemNaLista(i) then continue;

            pasta := copy (reg[i]^.pasta+BRANCOS, 1, 20);

            if DirectoryExists(dirRecebe + '\' + pasta) then
            begin
                numRegs := 0;
                chdir(dirRecebe + '\' + pasta);
                montaListaDeCartas ('CAR', 'N');
                if numRegs > 0 then
                begin
                        folheiaAdicionaEspecial ('Pasta: ' +pasta +' possui '+ IntToStr(numRegs)
                                                + ' Cartas no lidas', false,
                                                 pasta + ' ' + IntToStr(numRegs) +' '+ pegaTextoMensagem('CTNAOLID')); {'No lidas'}
                end
                else
                        folheiaAdicionaEspecial ('Pasta ' + pasta, false, pasta);
                chdir(dirRecebe);
            end
            else
            begin
                criaPasta (dirRecebe + '\' + reg[i]^.pasta);
                folheiaAdicionaEspecial ('Pasta ' + pasta, false, pasta);
            end;
        end;
end;

procedure apagaRegra (item: integer);

    procedure apagaUmaRegra ( item: integer);
    var
        keyName, keyReg, amb, pasta: array [0..144] of char;
        i, j: integer;
        arq: file;
        c1 : char;
    begin
        numRegs := 0;
        strPCopy (keyName, reg[item]^.nome);
        strPCopy (amb, dirRecebe + '\regras.ini');
        strPCopy (keyReg, reg[item]^.regra);

        if (keyReg <> 'EXCLUIR') then
        begin
                if DirectoryExists(dirRecebe + '\' + reg[item]^.pasta) then
                begin
                        repeat
                                mensagem('CTMOVCAR', 1); {'Deseja mover as cartas desta pasta para o diretrio principal?'}
                                mensagem('CTMOVCR2', 0); {'Se no mover, sero perdidas. '}
                                c1 := readkey();
                        until upcase(c1) in ['S', 'N', ENTER];

                        if (upcase(c1) = 'S') or (upcase(c1) = ENTER) then
                        begin
                                mensagem('CTMOMENT', 0); {'Um momento ...'}
                                chdir(dirRecebe + '\' + reg[item]^.pasta);
                                buscaTodasCartas('CAR');
                                for j := 1 to numRegs do
                                begin
                                        copiaUm(regLido[j]^.carta^.nomArqCarta, dirRecebe + '\'+ regLido[j]^.carta^.nomArqCarta);
                                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                                        {$I-}  erase (arq); {$i+}
                                end;
                                strPCopy(pasta, dirRecebe + '\' + reg[item]^.pasta);
                                mensagem('CTCARMOV', 0); {'Ok, cartas movidas'}
                       end
                       else
                       begin
                                chdir(dirRecebe + '\' + reg[item]^.pasta);
                                buscaTodasCartas('CAR');
                                for j := 1 to numRegs do
                                begin
                                        assign (arq, regLido[j]^.carta^.nomArqCarta);
                                        {$I-}  erase (arq); {$i+}
                                end;
                                strPCopy(pasta, dirRecebe + '\' + reg[item]^.pasta);
                       end;
                       chdir(dirRecebe);
                       RemoveDirectory(pasta);
                end;
        end;

        WritePrivateProfileString(keyReg, KeyName, NIL, amb);
        dispose (reg[item]);
        numRegras := numRegras - 1;
        for i := item to numRegras do
            reg[i] :=  reg[i + 1];

        folheiaRemoveItem (item);
        if item <= nFolhe then
        nFolhe :=  nFolhe - 1;
    end;

function perguntaSeApaga(item: integer): char;
var
    c1, c2: char;
    nomeAux : string;
begin
    repeat
        if pos('-[', reg[item]^.nome) = 1 then
                nomeAux := copy(reg[item]^.nome, 2, length(reg[item]^.nome))
        else
                nomeAux := reg[item]^.nome;

        mensagem ('CTAPAREG', 0); {'Deseja apagar a regra '}
        if(reg[item]^.regra <> 'EXCLUIR') then
               sintWrite (reg[item]^.regra + ' ' + nomeAux + ' para a pasta ' + reg[item]^.pasta + '  ')
        else
               sintWrite (reg[item]^.regra + ' ' + reg[item]^.pasta + ' ' + nomeAux + '  ');
        mensagem ('CTSIMNAO', 1); {'(S/N) '}
        sintLeTecla (c1, c2);
        c1 := upcase(c1);
    until c1 in ['S', 'N', 'T', ESC];
    perguntaSeApaga := c1;

end;

var
    c1, c2: char;
    i, numRegrasAux: integer;
    apagaSelecionados, apagaTodosSelecionados: boolean;
label desistiu;
begin
    telaFolheiaRegras (0);
    if temItemSelecionado then
        begin
            repeat
                msgBaixo ('CTDEREIS'); {'Deseja remover todos os itens selecionados?'}
                sintLeTecla (c1, c2);
            until upcase(c1) in ['S', 'N', ESC];
            if c1 = ESC then goto desistiu;
            apagaSelecionados := upcase (c1) = 'S';
        end
    else
        apagaSelecionados := false;

    if apagaSelecionados then
        begin
            numRegrasAux := numRegras;
            apagaTodosSelecionados := false;
            for i := numRegrasAux downto 1 do
                if reg[i]^.selecionado then
                    if apagaTodosSelecionados then
                        apagaUmaRegra (i)
                    else
                        begin
                            c1 := perguntaSeApaga(i);
                            if c1 in ['S', 'T'] then
                                apagaUmaRegra (i);
                            if c1 = ESC then goto desistiu;
                            if c1 = 'S' then
                                mensagem('CTOKRGAP', 1);  {'Ok, regra apagada'}
                        end;
        end
    else
        begin
            c1 := perguntaSeApaga(item);
            if c1 = 'S' then
                begin
                    apagaUmaRegra (item);
                    mensagem('CTOKRGAP', 1);  {'Ok, regra apagada'}
                end
            else
            if c1 in ['N',ESC] then goto desistiu;
        end;

    exit;
desistiu:
    msgBaixo ('CTDESIST');   {'Desistiu'}
end;

procedure descarregarRegras;
begin
    while numRegras >0 do
    begin
        dispose (reg[numRegras]);
        numRegras := numRegras - 1;
    end;
end;

procedure ajudaFolheamentoRegras;
begin
    writeln;
    if not keypressed then
        mensagem ('CTAJFR01', 2); {'Folheie as regras com as setas, depois tecle:'}
    if not keypressed then
        mensagem ('CTAJFR02', 2); {'A - Apagar regra'}
    if not keypressed then
        delay(30);
end;

procedure ajudaFolheamentoPastas;
begin
    writeln;
    if not keypressed then
        mensagem ('CTAJPA01', 2); {'Folheie as pastas com as setas, depois tecle:'}
    if not keypressed then
        mensagem ('CTAJPA02', 2); {'F - Folhear todas as cartas desta pasta'}
    if not keypressed then
        mensagem ('CTAJUD5A', 2); {'  N   Folhear as cartas no lidas'}
    if not keypressed then
        mensagem ('CTAJUD5B', 2); {'  L   Folhear as cartas lidas'}
    if not keypressed then
        delay(30);
end;

function folhearRegras: string;
var
    c, c2: char;
    k: integer;
    podeFalar: boolean;
    item: string;
begin
    chdir(dirRecebe);
    if not carregaLinhasArquivo ('regras.ini') then
        begin
            msgBaixo ('CTARQREG'); {'Arquivo com as regras no existe.'}
            exit;
        end;
    carregarRegras;
    destroiLinhasArquivo;
    if numRegras = 0 then
    begin
        mensagem ('CTREGVAZ', 1); {'O arquivo de regras est vazio'}
        exit;
    end;

    telaFolheiaRegras (numRegras);
    inicializaFolheamentoRegras;

    mensagem ('CTFOLREG', -1); {'Folheamento das regras'}
    mensagem ('CTUSESET', 0); {'Folheando: use as setas, depois tecle sua opo'}
    mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
    textBackground (BLACK);
    writeln;

    nFolhe:= 1;
    podeFalar := true;
    repeat
        folheiaExecuta (nFolhe, nFolhe, c, c2, podeFalar);
        if nFolhe < 1 then NFolhe := 1;
        if nfolhe > folheiaNumItens then nFolhe := folheiaNumItens;
        sintPara;
        for k := 1 to folheiaNumItens do
            folheiaObtemItem (k, item, reg[k]^.selecionado);

        if c = #$0 then
            case c2 of
                F1: ajudaFolheamentoRegras;
                F7: apagaRegra (nFolhe);
            end
        else
            with reg[nFolhe]^ do
            begin
                case upcase(c) of
                    ESC: folhearRegras := '';
                    'A': apagaRegra (nFolhe);
                    'Q': falaQualItemDeQuantos (nFolhe, false);
                    'S': falaQualItemDeQuantos (nFolhe, true);
                end;
            end;

        if (upCase(c) in[^Q, ^S]) or (c2 in [DIR, f8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

    until (c = ESC) or (numRegras <= 0);

    folheiaDestroi;
    descarregarRegras;
    msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
    textColor (WHITE);
    telaPrincipal;
end;

function folhearPastas: string;
var
    c, c2: char;
    k: integer;
    podeFalar, fezFolheamento: boolean;
    item, dirAtual: string;
begin
    getDir (0, dirAtual);
    chdir(dirRecebe);
    if not carregaLinhasArquivo ('regras.ini') then
        begin
            msgBaixo ('CTARQREG'); {'Arquivo com as regras no existe.'}
            chdir(dirAtual);
            exit;
        end;
    carregarNomesPastas;
    destroiLinhasArquivo;
    if numRegras = 0 then
        begin
            mensagem ('CTREGVAZ', 1); {'O arquivo de regras est vazio'}
            chdir(dirAtual);
            exit;
        end;

    telaFolheiaPastas (numRegras);
    inicializaFolheamentoPastas;
    chdir(dirAtual);

    mensagem ('CTFOLPAS', -1); {'Folheamento das pastas de regras'}
    mensagem ('CTUSESET', 0); {'Folheando: use as setas, depois tecle sua opo'}
    mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
    textBackground (BLACK);
    writeln;

    nFolhe:= 1;
    podeFalar := true;
    repeat
        folheiaExecuta (nFolhe, nFolhe, c, c2, podeFalar);
        if nFolhe < 1 then NFolhe := 1;
        if nfolhe > folheiaNumItens then nFolhe := folheiaNumItens;
        sintPara;
        for k := 1 to folheiaNumItens do
            folheiaObtemItem (k, item, reg[k]^.selecionado);

        if c = #$0 then
            case c2 of
                F1: ajudaFolheamentoPastas;
            end
        else
            begin
                case upcase(c) of
                    ESC: folhearPastas := '';
                    'F', 'L', 'N' :
                    begin
                        folheiaPasta(reg[nFolhe]^.pasta, upcase(c));
                        fezFolheamento := true;
                    end;
                    ENTER :
                    begin
                        folheiaPasta(reg[nFolhe]^.pasta, 'F');
                        fezFolheamento := true;
                    end;
                end;
            end;

        if (upCase(c) in[^Q, ^S]) or (c2 in [DIR, f8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

    until (c = ESC) or (numRegras <= 0) or fezFolheamento;

    descarregarRegras;
    if c = ESC then
        msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
    textColor (WHITE);
    telaPrincipal;
end;


function selSetasRegras: char;
var n: integer;
const
    tabLetrasConfig: string [4] = 'IAPR';

begin
    popupMenuCria (35, wherey, 44, 4, RED);
    MenuAdiciona ('CTREGO00'); {'   i - incluir regra'}
    MenuAdiciona ('CTREGO01'); {'   a - aplicar regras cartas'}
    MenuAdiciona ('CTREG002'); {'   p - pastas de regras'}
    MenuAdiciona ('CTREG003'); {'   r - folhear regras'}

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasRegras := tabLetrasConfig[n]
    else
        selSetasRegras := ESC;
end;

procedure ajudaRegras;
begin
    writeln;
    if not keypressed then
        mensagem ('CTAJUD01', 2); {'As opes so'}
    if not keypressed then
        mensagem ('CTREGO00', 1); {'    i - incluir regra'}
    if not keypressed then
        mensagem ('CTREGO01', 1); {'    a - aplicar regra cartas'}
    if not keypressed then
        mensagem ('CTREG002', 1); {'    p - pastas de regras'}
    if not keypressed then
        mensagem ('CTREG003', 1); {'    r - folhear regras'}
end;

procedure inicializaRegras;
var c, c2: char;
label inicio;
begin
inicio:
    telaPrincipal;
    textBackground (RED);
    mensagem ('CTREGINI', 1);{'Regras'}
    mensagem ('CTQUALOP', 0); {'Qual sua opo ? '}
    mensagem ('CTF1AJUD', 0); {'F1 ajuda '}
    sintLeTecla (c, c2);
    textBackground (BLACK);
    writeln;

    if (c = #0) and ((c2 = BAIX) or (c2 = CIMA)) then
        c := selSetasRegras
    else
    if c = #0 then
        begin
            ajudaRegras;
            goto inicio;
        end;

    case upcase (c) of
        'I':  criarRegras;
        'A':  aplicarRegrasCartas();
        'P':  folhearPastas;
        'R':  folhearRegras;
    else
        if c <> ESC then
            msgBaixo ('CTOPCINV')   {'Opo invlida'}
        else
            msgBaixo ('CTDESIST'); {'Desistiu'}
    end;
end;


begin
end. {--end da implementation---}
