{--------------------------------------------------------}
{
{           Cartavox - Folheador de cartas
{
{--------------------------------------------------------}

unit carFolhe;

interface

uses
    dvarq,
    dvcrt,
    dvform,
    dvhora,
    dvWin,
    sysutils,
    windows,
    videovox,
    carApeli,
    carCopia,
    carDecod,
    carEnvia,
    carEst,
    carLeit,
    carList,
    carMsg,
    carSMTP,
    carTela,
    carUtil,
    carVars,
    carSpam,
    carResp;

    procedure folhearCartas (tipoFolheamento: char; pastaRegra: string = '');

implementation

var
    folheiaRecebidas: boolean;
    posListArq: integer;
{-------------------------------------------------------------}
{       Retorna somente o e-mail de uma string
{-------------------------------------------------------------}

function retornaEmail (s: string): string;
var
    saida: string;
    i, f: integer;
label fim;
begin
    saida := s;
    if trim (s) = '' then goto fim;
    i := pos ('<', s);
    f := pos ('>', s);
    if i >= f then goto fim;
    saida := copy (s, i+1, f-i+1);
fim:
    retornaEmail := saida;
end;

{--------------------------------------------------------}

procedure procuraAutomatica1 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO1');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica2 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO2');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica3 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO3');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica4 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO4');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica5 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO5');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica6 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO6');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}

procedure procuraAutomatica7 (folheiaAchados: boolean; nCar: integer);
var
    c: char;
    atual, cont, i, total: integer;
    achouJaUma: boolean;
    textoBusc, textoBuscado: string;
    sz: array [0..144] of char;

    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;

    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;

begin
        c := 'C';
    textoBuscado := sintAmbiente ('CARTAVOX', 'BUSCAFIXO7');
    if textoBuscado = '' then
        begin
            textoBuscado := '';
        end;
textoBusc := textoBuscado;
sintetiza (textoBusc);

            textoBusc := semAcentos (textoBusc);

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if (c = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
begin
            msgBaixo ('CTACHEI');     {'Achei'}
end
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{--------------------------------------------------------}
{       procura uma string no cabealho da carta ou na carta toda
{--------------------------------------------------------}

procedure procurarNaCarta (folheiaAchados: boolean; nCar: integer);
var
    c, c2: char;
    atual, cont, i, total: integer;
    achouJaUma, selecionado: boolean;
    textoBusc, salva: string;
    sz: array [0..144] of char;
n, nbuscs: integer;
    s: string;



    procedure contadorBipa (limite: integer);
    begin
        cont := cont + 1;
        if (cont mod limite) = 0 then
            begin
                sintBip;
                cont := 0;
            end;
    end;


    function procuraEmUmArquivo (nCar: integer; tipoProcura: char): boolean;
    var
        s: string;
        i: integer;
    label naoAchou;
    begin
        if carregaLinhasArquivo (regLido [nCar]^.carta^.nomArqCarta) then
            begin
                i := 0;
                if tipoProcura = 'B' then
                    repeat
                        if (i >= 0) and (i < linhasArquivo.count) then  // programao defensiva
                            s := (linhasArquivo[i]);
                        i := i + 1;
                    until (s = '') or (i >= linhasArquivo.count);

                while i < linhasArquivo.count do
                    begin
                        s := (linhasArquivo[i]);
                        if (upcase (tipoProcura) in ['C', ENTER]) and (s = '') then
                            goto naoAchou;
                        decodificarString(s);
                        if pos (textoBusc, semAcentos (s)) <> 0 then
                            break;

                        i := i + 1;
                        if i >= linhasArquivo.count then
                            goto naoAchou;
                        contadorBipa (100000);
                    end;
            end
        else
            begin
                procuraEmUmArquivo := false;
                exit;
            end;

        procuraEmUmArquivo := true;
        destroiLinhasArquivo;
        exit;

    naoAchou:
        procuraEmUmArquivo := false;
        destroiLinhasArquivo;
    end;

    function procuraUmItem (nCar: integer; tipoProcura: char): boolean;
    begin
        case tipoProcura of
            'A': procuraUmItem := textoBusc = limpaAssunto(regLido [nCar]^.carta^.subject);
            'D': procuraUmItem := pos (textoBusc, regLido [nCar]^.carta^.delivered_to + regLido [nCar]^.carta^.to_ + regLido [nCar]^.carta^.bcc) <> 0;
            'R': begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
            procuraUmItem := textoBusc = retornaEmail (regLido [nCar]^.carta^.x_original_from)
else
            procuraUmItem := textoBusc = retornaEmail (regLido [nCar]^.carta^.from);
end;
            'H': procuraUmItem := textoBusc = dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
        else
            procuraUmItem := procuraEmUmArquivo (nCar, tipoProcura);
        end;
    end;


    procedure ajuda;
    begin
        mensagem ('CTAJUD01', 2); {'As opes so'}
        if not keypressed then
            mensagem ('CTCABCAR', 1); {'    C - Cabealho da carta'}
        if not keypressed then
            mensagem ('CTCORCAR',1); {' B - Corpo da carta'}
        if not keypressed then
            mensagem ('CTTODCAR',1); {' T - Toda carta'}
        if not keypressed then
            mensagem ('CTPROASS',1); {' A - Assunto desta carta'}
        if not keypressed then
            mensagem ('CTPROREM',1); {' R - Remetente desta carta'}
        if not keypressed then
            mensagem ('CTPRODES',1); {' D - Destinatrio desta carta'}
        if not keypressed then
            mensagem ('CTPRODAT', 1); {' H - Data de chegada desta carta'}
    end;


    function selSetas: char;
    var
        n: integer;
    const tabOpc: string[7] = 'CBTARDH';
    begin
        popupMenuCria (35, wherey, 50, 7, RED);
        MenuAdiciona ('CTCABCAR'); {'    C - Cabealho da carta'}
        MenuAdiciona ('CTCORCAR'); {' B - Corpo da carta'}
        MenuAdiciona ('CTTODCAR'); {' T - Toda carta'}
        MenuAdiciona ('CTPROASS'); {' A - Assunto desta carta'}
        MenuAdiciona ('CTPROREM'); {' R - Remetente desta carta'}
        MenuAdiciona ('CTPRODES'); {' D - Destinatrio desta carta'}
        MenuAdiciona ('CTPRODAT'); {' H - Data de chegada desta carta'}

        n := popupMenuSeleciona;
        if (n >=1) and (n <= 7) then
            selSetas := tabOpc [n]
        else
            selSetas := #0;
    end;


begin
    c2 := #$0;
    salva := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if salva = '' then
        begin
            salva := '';
        end;
    textoBusc := salva;
    if agruparPorAssunto then
        c:= 'A'
    else
    repeat
        limpaParteTela (20, 25);
        if not folheiaAchados then
            mensagem ('CTPROINV', 1); {'Procura invertida'}
        mensagem ('CTTIPPRO', 0); {'Qual o tipo de procura?'}
        write ('   ');
        mensagem ('CTF1AJUD', 1);         {'F1 ajuda '}
        c := upcase (readkey);
        if c = #0 then
            begin
                c := readkey;
                if c = F1 then ajuda
                else
                if (c = BAIX) or (c = CIMA) then c := selSetas;
            end;
    until c in ['C', 'T', 'B', 'A', 'R', 'D', 'H', ESC, ENTER];
    if not agruparPorAssunto then
        sintWriteln (c);

    if c in ['A', 'R', 'D'] then
        for i := 1 to numRegs do
            if not regLido [i]^.carta^.preenchido then
                begin
                    selecionado := regLido [i]^.selecionado;
                    carregaArqPreencheCabPrin ( i);
                    regLido [i]^.selecionado := selecionado;
                    if (i mod 500) = 0 then sintBip;
                end;

    case c of
        'A': begin
                textoBusc := limpaAssunto(regLido [nCar]^.carta^.subject);
                if trim (textoBusc) = '' then
                    textoBusc := regLido [nCar]^.carta^.subject;
             end;
        'D': if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
                textoBusc := retornaEmail (regLido [nCar]^.carta^.delivered_to)
             else
             if trim (regLido [nCar]^.carta^.to_) <> '' then
                textoBusc := retornaEmail (regLido [nCar]^.carta^.to_)
             else
                textoBusc := retornaEmail (regLido [nCar]^.carta^.bcc);
        'R': begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        textoBusc := retornaEmail (regLido [nCar]^.carta^.x_original_from);
        decodificarString (textoBusc);
end
else
        textoBusc := retornaEmail (regLido [nCar]^.carta^.from);
end;
        'H': textoBusc := dateToStr (fileDateToDateTime (regLido [nCar]^.carta^.datahora))
    else
        repeat
//            textoBusc := 'reply-to';
            if c in ['C', ENTER] then
begin
                mensagem ('CTINFPRO', 1);    {'Informe o texto a procurar no cabealho da carta'}
sintetiza (textoBusc);
end
            else
            if C = 'T' then
begin
                mensagem ('CTINPROT', 1);    {'Informe o texto a procurar em toda carta'}
sintetiza (textoBusc);
end
            else
            if c = 'B' then
begin
                mensagem ('CTPROCOR', 1); {'Informe o texto a procurar no corpo da carta'}
sintetiza (textoBusc);
end
            else
                begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
                    exit;
                end;
            c2 := sintEditaCampo (textoBusc, 1, wherey, 255, 80, true);
        writeln;
            textoBusc := semAcentos (textoBusc);

    textoBusc := trim(textoBusc);

    if (c2 = baix) or (c2 = cima) or (c2 = F9) then
begin
    writeln;
    nbuscs := 0;
    for n := 1 to 120 do
        begin
            s := sintAmbiente ('BUSCANACARTA', 'TEXTOABUSCAR' + intToStr (n));
            if s <> '' then nbuscs := nbuscs + 1;
        end;

    popupMenuCria (50, wherey, 60, nbuscs, RED);
    for n := 1 to 120 do
        begin
            s := sintAmbiente ('BUSCANACARTA', 'TEXTOABUSCAR' + intToStr (n));
                    popupMenuAdiciona ('', S);
                end;

    n := popupMenuSeleciona;

    str (n, s);
    s := 'TEXTOABUSCAR' + s;
    s := sintAmbiente ('BUSCANACARTA', s);
    textoBusc := (s);
end;

    if textoBusc = '' then
        begin
                    mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;

            textoBusc := semAcentos (textoBusc);

            strPCopy (sz, textoBusc);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

        until c2 in [ENTER, ESC, BAIX, CIMA, F9];
        end;

    if (c2 = ESC) or (textoBusc = '') then
        begin
            mensagem ('CTDESIST', 2);  {'Desistiu...'}
            exit;
        end;



    cont := 0;
    atual := numRegs;
    achouJaUma := false;
    while (atual > 0) and (not achouJaUma) do
        if folheiaAchados then
            begin
                if procuraUmItem (atual, c) then
                    achouJaUma := true
                else
                    begin
                        atual := atual -1;
                        contadorBipa (1500);
                    end;
            end
        else
            if not procuraUmItem (atual, c) then
                achouJaUma := true
            else
                begin
                    atual := atual -1;
                    contadorBipa (1500);
                end;

    if achouJaUma then
        begin
            total := numRegs;
            for i := total downto atual+1 do
                apagaUmRegs (i);
            atual := atual -1;
            while atual > 0 do
                begin
                    if folheiaAchados and (not procuraUmItem (atual, c)) then
                            apagaUmRegs (atual)
                        else
                    if (not folheiaAchados) and procuraUmItem (atual, c) then
                            apagaUmRegs (atual);
                    atual := atual -1;
                    contadorBipa (1500);
                end;
        end;

    if not agruparPorAssunto then
        if achouJaUma then
            msgBaixo ('CTACHEI')     {'Achei'}
        else
            msgBaixo ('CTNACHEI');    {'No achei'}
end;

{-------------------------------------------------------------}
{       Trata o reenvio da carta
{-------------------------------------------------------------}

procedure reenviarCarta (nCar: integer);
var
    c, c2: char;
    reenviarSelecionadas: boolean;
begin
    repeat
        limpaParteTela (19, 25);
        textBackground (RED);
        if temItemSelecionado then
            mensagem ('CTREESEL', 0)   {'Deseja reenviar todas as selecionadas? '}
        else
            mensagem ('CTREECAR', 0); {'Deseja reenviar esta carta? '}
        sintLeTecla (c, c2);
        textBackground (BLACK);
        writeln;
    until upcase (c) in ['S', 'N', ENTER, ESC];

    if (upcase(c) = ESC) or (not temItemSelecionado and (upcase(c) = 'N')) then
        begin
            msgBaixo ('CTDESIST');   {'Desistiu'}
            exit;
        end;

    if temItemSelecionado then
        reenviarSelecionadas := upcase(c) in ['S', ENTER]
    else
        reenviarSelecionadas := false;
    if not reenviarSelecionadas then
        begin
            if tiraCopia (regLido[nCar]^.carta^.nomArqCarta) then

        nomeDestOuRem := regLido [nCar]^.carta^.to_;

                msgBaixo ('CTCARPRP'); {'Carta preparada para envio'}
        end
    else
    for nCar := 1 to numRegs do
        if regLido[nCar]^.selecionado then
            if not tiraCopia (regLido[nCar]^.carta^.nomArqCarta) then exit;

    if reenviarSelecionadas then
        if totalDeItensSelecionados > 1 then
            msgBaixo ('CTCARPRS') {'Cartas preparadas para envio'}
        else
            msgBaixo ('CTCARPRP'); {'Carta preparada para envio'}
end;

{--------------------------------------------------------}
{       ajuda no folheamento
{--------------------------------------------------------}

procedure ajudaFolheia;
begin
    telaFolheamentoCartas;
    textBackground(BLUE);
    if not keypressed then
        mensagem ('CTAJFL01', 2);  {'Folheie as cartas com as setas, depois tecle:'}
    textBackground(BLACK);

    mensagem ('CTAJFL02', 1);  {'L ou ENTER - para ler carta'}
    if folheiaRecebidas then
        mensagem ('CTAJFL5B', 1);  {'R - responder carta'}
    if folheiaRecebidas or folheiaTransmitidas then
        mensagem ('CTAJFL5C', 1)  {'E - encaminhar carta'}
    else
    if not folheiaTransmitidas then
        mensagem ('CTAJFL5F', 1);  {'E - editar carta'}
    if folheiaRecebidas then
        mensagem ('CTAJFL09', 1)   {'S - selecionar o nome do remetente associando-o a um apelido'}
    else
        mensagem ('CTAJFL9A', 1);  {'S - selecionar o nome do destinatrio associando-o a um apelido'}
    mensagem ('CTAJFL04', 1);      {'A - apagar a carta'}
    if not folheiaRecebidas then
        mensagem ('CTAJFL03', 1);  {'I - para obter informaes sobre a carta'}
    mensagem ('CTAJFL06', 1);      {'C - copiar'}
    if folheiaRecebidas then
        mensagem ('CTAJFL08', 1);  {'T - transmitir cartas j digitadas'}
    if not folheiaRecebidas then
        mensagem ('CTAJFL12', 1);  {'O - editar o texto original da carta'}
    mensagem ('CTAJFL07', 2);      {'ESC terminar folheamento'}
    mensagem ('CTATCLF9', 0);      {'Tecle F9 para selecionar a opo com as setas'}

    textBackground(BLACK);  clreol;
    writeln;
    if keypressed and (readkey <> ESC) then
        begin
            limpaBufTec;
            readkey;
        end;
    limpaBufTec;
end;

{--------------------------------------------------------}
{       seleciona a funo com as setas
{--------------------------------------------------------}

function selSetasFolheia (Var c: char): char;
var
    n,nOpc: integer;
const
    tabLRec: string [48] = 'LR'+^R+'E'+^E+'SUAICTOQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'M'+
                           ^T+ ^V+ ^I+ 'WF'+ ^F+ 'H'+ F4+ CTLF1+ CTLF2+ CTLF3+ ^L+ 'KB'+ ^B+ ^W+ 'Z'+ ^Z+ 'P.'+F3+ F5+ F6+ F11+ CTLF4+ 'A'+ ESC;
    tabLTra: string [37] = 'L'+'E'+^E+'SAICTROQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'WF'+
                           ^F+ 'H'+ F4+ CTLF1+ CTLF2+ CTLF3+ 'Z'+ ^Z+ 'P.'+F3+ F5+ F6+ F11+ CTLF4+ 'A'+ ESC;
    tabLPre: string [35] = 'LESAICTOQ'+ ^Q+ 'D'+ ^D+ 'NG'+ ^N+ ^G+ 'WF'+
                           ^F+ 'H'+ F4+ CTLF1+ CTLF2+ CTLF3+ 'Z'+ ^Z+ 'P.'+ F3+ F5+ F6+ F11+ CTLF4+ 'A'+ ESC;

begin
    if folheiarecebidas then
        nOpc := 48
    else
    if folheiaTransmitidas then
        nOpc := 37
    else
        nOpc := 35;

    popupMenuCria (48, wherey, 50, nOpc, RED);

    MenuAdiciona ('CTAJFL02');  {'L ou ENTER - para ler carta'}
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL5B');  {'R - Responder carta'}
            MenuAdiciona ('CTAJFL5E');  {'CTRL+R - Responder para o remetente'}
        end;
    if folheiaRecebidas or folheiaTransmitidas then
        begin
            MenuAdiciona ('CTAJFL5C');  {'E - Encaminhar carta'}
            MenuAdiciona ('CTAJFL5D');  {'CTRL+E - Encaminhar em anexo'}
        end;
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL09');   {'S - selecionar o nome do remetente associando-o a um apelido'}
            MenuAdiciona ('CTAJFL05');  {'U - Preparar resposta automtica'}
        end
    else
        begin
            if not folheiaTransmitidas then
                menuAdiciona ('CTAJFL5F');  {'E - editar carta'}
            MenuAdiciona ('CTAJFL9A');  {'S - selecionar o nome do destinatrio associando-o a um apelido'}
        end;
    MenuAdiciona ('CTAJFL04');  {'A - apagar a carta'}
    MenuAdiciona ('CTAJFL03');  {'I - para obter informaes sobre a carta'}
    MenuAdiciona ('CTAJFL06');  {'C - copiar'}
    MenuAdiciona ('CTAJFL08');  {'T - transmitir cartas j digitadas'}
    if folheiaTransmitidas then
        MenuAdiciona ('CTAJFL8A');  {'R - reenviar carta'}
    MenuAdiciona ('CTAJFL12');  {'O - editar o texto original da carta'}
    MenuAdiciona ('CTAJFL13');  {'Q - Informar qual a carta do total'}
    MenuAdiciona ('CTAJFL29');  {'CTRL+Q - Informar quantas cartas selecionadas do total'}
    MenuAdiciona ('CTAJFL15');  {'D - Informa o tamanho da carta'}
    MenuAdiciona ('CTAJFL28');  {'CTRL+D - Informa o tamanho de todas as cartas'}
    MenuAdiciona ('CTAJFL16');  {'N - Informa o nome do arquivo da carta'}
    MenuAdiciona ('CTAJFL20');  {'G - Busca carta pelo nome do arquivo'}
    MenuAdiciona ('CTAJFL17');  {'CTRL + N - Informa o nmero da carta'}
    MenuAdiciona ('CTAJFL19');  {'CTRL + G - Busca carta pelo nmero'}
    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL18'); {'M - Marca ou desmarca a carta'}
            MenuAdiciona ('CTAJFL25'); {'CTRL+T - Marca ou desmarca todas as cartas'}
            MenuAdiciona ('CTAJFL38'); {'CTRL+V - Marca ou desmarca todas as cartas'}
            MenuAdiciona ('CTAJFL39'); {'CTRL+I - Soletra a configurao'}
        end;
    MenuAdiciona ('CTAJFL24');  {'W - Editar apelidos'}
    MenuAdiciona ('CTAJFL26');  {'F - Fala o remetente da carta'}
    MenuAdiciona ('CTAJFL27');  {'CTRL+F - Fala o destinatrio da carta'}
    MenuAdiciona ('CTAJFL31');  {'H - Vai para outro folheamento'}
            MenuAdiciona ('CTAJFL47'); {'F4 - Mudana de velocidade entre 1 e 5'}
            MenuAdiciona ('CTAJFL43'); {'CTRL+F1 - Velocidade 2'}
            MenuAdiciona ('CTAJFL44'); {'CTRL+F2 - Velocidade 3'}
            MenuAdiciona ('CTAJFL45'); {'CTRL+F3 - Velocidade 4'}

    if folheiaRecebidas then
        begin
            MenuAdiciona ('CTAJFL11');  {'CTRL + L - Liberar o remetente no MataSpam'}
            MenuAdiciona ('CTAJFL14');  {'K - Bloquear o remetente no MataSpam'}
            MenuAdiciona ('CTAJFL33');  {'B - Remover todas as cartas jogando pra lixeira'}
            MenuAdiciona ('CTAJFL34');  {'CTRL + B - Remover todas as cartas sem jogar pra lixeira'}
            MenuAdiciona ('CTAJFL35');  {'CTRL + W - Adiciona todos os remetentes de todas as cartas num s arquivo para ser usado pelo Prelistas'}
        end;
            MenuAdiciona ('CTAJFL36');  {'Z - Adiciona esta carta num arquivo'}
            MenuAdiciona ('CTAJFL37');  {'CTRL + Z - Adiciona todas as cartas num s arquivo'}
            MenuAdiciona ('CTAJFL40'); {'P - Folhear os itens do cabealho da carta'}
            MenuAdiciona ('CTAJFL41'); {'Ponto - Leitor de tela'}
    MenuAdiciona ('CTAJFL32');  {'F3 - Ordenar'}
    MenuAdiciona ('CTAJFL10');  {'F5 - procurar'}
    MenuAdiciona ('CTAJFL30');  {'F6 - procura invertida'}
            MenuAdiciona ('CTAJFL42'); {'F11 - Armazenamento de cartas com original ou sem original'}
            MenuAdiciona ('CTAJFL46'); {'CTRL+F4 - Velocidade 5'}
    MenuAdiciona ('CTAJFL04');  {'A - apagar a carta'}
    MenuAdiciona ('CTAJFL07');  {'ESC terminar folheamento'}

    n := popupMenuSeleciona;

    if (n > 0) and (n <= nOpc) then
        if n in [(Nopc-4) .. (Nopc-2)] then
            begin
                selSetasFolheia := #0;
                if folheiaRecebidas then c := tabLRec [n]
                else
                if folheiaTransmitidas then c := tabLTra [n]
                else c := tabLPre [n];
            end
        else
            if folheiaRecebidas then selSetasFolheia := tabLRec [n]
            else
            if folheiaTransmitidas then selSetasFolheia := tabLTra [n]
            else selSetasFolheia := tabLPre [n]
    else
        begin
            selSetasFolheia := #0;
//            c := f12;
        end;
end;

{--------------------------------------------------------}
{   Folheia e responde cartas
{   TipoFolheamento:
{       F - todas Recebidas
{       L - recebidas Lidas
{       N - recebidas No lidas
{       T Transmitidas
{       P Preparadas
{       CONTROL + <tipo folheamento>, mostram somente a da conta atual, no
{       caso de vrias contas no mesmo diretrio.
{--------------------------------------------------------}

procedure inicializaFolheamento;
var
    i: integer;
    s: string;
begin
    folheiaCria (1, 3, 80, 17);
    for i :=  1 to numRegs do
        begin
            s := '';
            folheiaAdicionaEspecial (s, regLido [i]^.selecionado, s);
        end;
end;

{-------------------------------------------------------------}
{  Preenche item com as informaes da carta, se ainda vazio
{-------------------------------------------------------------}

procedure preencheItemOnline (nItem: integer; var conteudo, fala: string;
                              var selec: boolean);
var
    s, s2, s3: string;
begin
    if (conteudo <> '') or (fala <> '') then exit;
    folheiaObtemItem (nItem, s, regLido[nItem]^.selecionado);

    carregaArqPreencheCabPrin (nItem);

    if folheiaRecebidas then
begin
    if trim (regLido [nItem]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nItem]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nItem]^.carta^.from;
end
    else
        s := regLido [nItem]^.carta^.to_;
        s := retornarNome (s, false);

                            s2 := regLido [nItem]^.carta^.subject;
                s2 := limpaAssunto(regLido[nItem]^.carta^.subject);
    s3 := regLido [nItem]^.carta^.subject;
s3 := pegaPrefixoAssunto (s3);
s2 := s2 + ' ' + s3;
//    deletaAspas (s2);
    if s2 = '' then s2:= 'NULO';

    conteudo := copy (s+BRANCOS, 1, 30) +  copy (s2+BRANCOS, 1, 50);
    if FALANOMEPRIMEIRO then
        fala := s + ' ' + s2
    else
        fala := s2 + ' ' + s;
    selec := regLido [nItem]^.selecionado;
end;

{-------------------------------------------------------------}
{       Troca de folheamento
{-------------------------------------------------------------}

function trocaDeFolheamento (dirAtual: string; pastaRegra: string = ''): boolean;
var c: char;
begin
    repeat
        msgBaixo ('CTQUAFOL'); {'Qual o tipo de folheamento? (F/N/L/P/T)'}
        c := upcase (readkey);
    until c in ['F', 'N', 'L', 'P', 'T', ^F, ^N, ^L, ^P, ^T, ENTER, ESC];

    if c in [ENTER, ESC] then
        begin
            trocaDeFolheamento := false;
            msgBaixo ('CTDESIST'); {'Desistiu'}
        end
    else
        begin
            trocaDeFolheamento := true;
            folheiaDestroi;
            desmontaListaDeCartas;
            {$I-}  chdir (dirAtual);  {$I+}
            if ioresult <> 0 then;
            folhearCartas (c, pastaRegra);
        end;
end;

{--------------------------------------------------------}
{                    folheamento
{--------------------------------------------------------}

    procedure folhearCartas (tipoFolheamento: char; pastaRegra: string = '');
var
    c, c2: char;
    nCar, i: integer;
    dirAtual, dirAtualCartas, extensao, s, s3, bloquear: string;
    podeFalar, auxBoolean: boolean;

label procurarAchou;

begin
    if not agruparPorAssunto then
    case tipoFolheamento of
        'F', ^F: msgBaixo ('CTRECEBI'); {'Recebidas'}
        'N', ^N: ; // msgBaixo ('CTNAOLID'); {'No lidas'}
        'L', ^l: msgBaixo ('CTLIDAS'); {'Lidas'}
        'P', ^P: ; // msgBaixo ('CTPREPAR'); {'Preparadas'}
        'T', ^T: msgBaixo ('CTTRANSM'); {'Transmitidas'}
    end;

    tipoFolheGlobal := tipoFolheamento;
    getDir (0, dirAtual);

    case tipoFolheamento of
        'F', 'L', 'N', ^F, ^L, ^N: begin
                            folheiaRecebidas := true;
                            folheiaTransmitidas := false;
                            extensao := 'CAR';
                            {$I-}  chdir (dirRecebe);  {$I+}
                            if ioresult <> 0 then ;
                       end;
        'P', ^P: begin
                folheiaRecebidas := false;
                folheiaTransmitidas := false;
                extensao := 'CPR';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then ;
             end;
        'T', ^T: begin
                folheiaRecebidas := false;
                folheiaTransmitidas := true;
                extensao := 'ENV';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then ;
             end;
    end;

    if pastaRegra <> '' then
        begin
            getDir (0, dirAtualCartas);
            dirRecebe := pastaRegra;
            {$I-}  chdir (dirRecebe);  {$I+}
            if ioresult <> 0 then ;

        end;

    montaListaDeCartas (extensao, tipoFolheamento);
    if numRegs = 0 then
        begin
            msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
            agruparPorAssunto := false;
            if pastaRegra <> '' then dirRecebe := dirAtualCartas;
            exit;
        end;

    if ordenarDataEnvio or agruparPorAssunto then
        ordenarLista ('date', ordemInversa, not agruparPorAssunto)
    else
        ordenarLista ('datahora', ordemInversa, true);

    if agruparPorAssunto then
        procurarNaCarta (true, 1);

procurarAchou:
    telaFolheamentoCartas;
    if not agruparPorAssunto then
        begin
            falaNumeroCartas;
//            mensagem ('CTUSESET', -1);  {'Folheando: use as setas, depois tecle sua opo'}
        end
    else
        sintetiza (intToStr(numRegs));

    nCar := 1;
    podeFalar := true;
    repeat
        telaFolheamentoCartas;
        inicializaFolheamento;
        folheiaCorDoMeio (1, 30, CYAN);

        FolheiaPreencheItemOnline := @preencheItemOnline;
        folheiaExecuta (nCar, nCar, c, c2, podeFalar);
        FolheiaPreencheItemOnline := NIL;

        if nCar < 1 then nCar := 1;
        if nCar > numRegs then nCar := numRegs;
        sintPara;
        for i := 1 to numRegs do
            folheiaObtemItem (i, s, regLido[i]^.selecionado);

        gotoxy (1, 19);
        if c2 = F9 then
            c := selSetasFolheia (c2);

        if c = #0 then
            begin
                case c2 of

                    CTLESQ:
    begin
    sintetiza (intToStr (nCar));
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('<', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
                            contemAnexos (nCar);
    end;

                    ESQ: begin
                            s := regLido [nCar]^.carta^.subject;
                s := limpaAssunto(regLido[nCar]^.carta^.subject);
    s3 := regLido [nCar]^.carta^.subject;
s3 := pegaPrefixoAssunto (s3);
s := s + ' ' + s3;
                            if trim(s) = '' then
                                s := 'Nulo';
                            sintetiza (s);
                            contemAnexos (nCar);
                         end;

                    DIR: if folheiaRecebidas then
                        begin
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
                            contemAnexos (nCar);
                            sintetiza (regLido [nCar]^.carta^.nomArqCarta);
                         end
                         else
                        begin
                            if trim(regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
                            contemAnexos (nCar);
                            sintetiza (regLido [nCar]^.carta^.nomArqCarta);
                         end;

                    F1:    ajudaFolheia;
F4: begin
        mensagem ('CTVELOC', 1);  {'Qual a velocidade, de 1 a 5'}
    sintLeTecla (c, c2);
    writeln;
    if c in ['1'..'5'] then
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF4: begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF3: begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF2: begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF1: begin
c := '2';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF5: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica1 (c2 = CTLF5, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
CTLF6: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica2 (c2 = CTLF6, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
CTLF7: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica3 (c2 = CTLF7, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
CTLF9: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica4 (c2 = CTLF9, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
F12: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica5 (c2 = F12, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
F7: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica6 (c2 = F7, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;
CTLF12: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica7 (c2 = CTLF12, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;

                    F3:  begin
                                folheiaDestroi;
                                escolheOrdenacao(folheiaRecebidas);
                                goto procurarAchou;
                         end;
                    F5, f6:  begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procurarNaCarta (c2 = F5, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                         end;
F11: begin
    adicionaOriginal := not adicionaOriginal;
    if adicionaOriginal then
    mensagem ('CTCOMORI', 1)  {'Com original'}
    else
    mensagem ('CTSEMORI', 1);  {'Sem original'}
end;
//                    F7: nCar := removerCarta (nCar, true, false);
                    F8:     falaHora;
                    CTLF8:   falaDia;
//                    F12: begin {No faz nada, continua folheando}
//                            textBackGround (MAGENTA);
//                            msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}
//                            textBackGround (BLACK);
//                            writeln;
//                         end;
                end;
            end
        else

            begin
                c := upcase (c);
                case c of
                    'J': begin
                            falaNomePrimeiro := not falaNomePrimeiro;
                            if falaNomePrimeiro then begin sintClek; sintClek; sintClek; end
                            else begin sintBip; sintBip; sintBip; end;
                         end;
                    'I': infoCarta (nCar);
                    ^I:   begin
                             sintSoletra (nomeConfiguracao);
                             delay (20);
                          end;
//                    'B': editarApelidos;
        'B':
begin
    mensagem ('CTRMTDJL', 1);  {'Removo todas jogando pra lixeira?'}
    mensagem ('CTSIMNAO', 0);  {'(S/N) ? '}
    c := sintReadkey;
    if c = ESC then break;
    writeln (c);
    if upcase(c) = 'S' then
                         begin
                                fazCopiasLix (ncar, dirAtual);
                             end;
                if numRegs >= 1 then
begin
                            textBackGround (MAGENTA);
//                            mensagem ('CTCNTFOL', 0);  {'Continue folheando ou tecle ESC'}
                            textBackGround (BLACK);
                            writeln;
                                str (ncar, s);
sintetiza (s);
                    end;
                if numRegs < 1 then
                    begin
                        mensagem ('CTSEMCAR', 1);  {'No tem carta neste diretrio'}
                        exit;
                    end;
            end;
        ^B:
begin
    mensagem ('CTRMTDSL', 1);  {'Removo todas sem jogar pra lixeira?'}
    mensagem ('CTSIMNAO', 0);  {'(S/N) ? '}
    c := sintReadkey;
    if c = ESC then break;
    writeln (c);
    if upcase(c) = 'S' then
                         begin
                                fazCopiasLix1 (ncar, dirAtual);
                             end;
                if numRegs >= 1 then
begin
                            textBackGround (MAGENTA);
//                            mensagem ('CTCNTFOL', 0);  {'Continue folheando ou tecle ESC'}
                            textBackGround (BLACK);
                            writeln;
                                str (ncar, s);
sintetiza (s);
                    end;
                if numRegs < 1 then
                    begin
                        mensagem ('CTSEMCAR', 1);  {'No tem carta neste diretrio'}
                        exit;
                    end;
                    end;

^c: begin
                                folheiaDestroi;
                                auxBoolean := agruparPorAssunto;
                                agruparPorAssunto := false;
                                procuraAutomatica7 (c = ^c, nCar);
                                agruparPorAssunto := auxBoolean;
                                goto procurarAchou;
                                end;

                    'N': sintetiza (regLido [nCar]^.carta^.nomArqCarta);
                    ^N : sintetiza (intToStr (nCar));
                    'M', ^T: if (folheiaRecebidas) and (c = 'M') then
                                  marcaOuDesmarca(nCar, false, nbaseRecebe)
                             else
                             if folheiaRecebidas then
                                  marcaOuDesmarca(0, false, nbaseRecebe)
                             else
                                  msgBaixo ('CTOPVINV');

F4: begin
        mensagem ('CTVELOC', 1);  {'Qual a velocidade, de 1 a 5'}
    sintLeTecla (c, c2);
    writeln;
    if c in ['1'..'5'] then
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF3: begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF2: begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;
CTLF1: begin
c := '2';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('CARTAVOX', 'DIRCARTAVOX'));
end;
end;

                    'H', ^U: begin
                            agruparPorAssunto := false;
                            if trocaDeFolheamento (dirAtual, pastaRegra) then
                                begin
                                    if pastaRegra <> '' then
                                        dirRecebe := dirAtualCartas;
                                    exit;
                                end;
                         end;
                    'V', ^V: if (folheiaRecebidas) and (c = 'V') then
                                  marcaOuDesmarca(nCar, false, nbaseRecebe)
                             else
                             if folheiaRecebidas then
                                  marcaOuDesmarca(0, false, nbaseRecebe)
                             else
                                  msgBaixo ('CTOPVINV');
                    'D': tamanhoCarta (nCar);
                    ^D : tamanhoTodasCartas;
                    'L', ENTER, CTLENTER:
                         begin
                             folheiaDestroi;
                             leCarta (nCar, c <> CTLENTER);
                             if (folheiaRecebidas) and
                                (pos ('M.', regLido[nCar]^.carta^.nomArqCarta) = 0) then
                                     marcaOuDesmarca(nCar, true, nbaseRecebe);
                             limpaBufTec;
                         end;
                    'P':
                        begin
                            folheiaDestroi;
                            if carregaLinhasArquivo (regLido[ncar]^.carta^.nomArqCarta) then//Aloca o arquivo da carta
                                begin
                                    preencheCartaPrincipal (regLido[ncar]);//preenche o cabealho principal da carta
                                    destroiLinhasArquivo;//Desaloca o arquivo da carta
                                end;
                            mostraItensCarta ( regLido[nCar]);
                        end;
                    'A', ^A: nCar := removerCarta (nCar, (c = 'A'), false);
                    'W':  editarApelidos;

                    'R', 'E': if folheiaRecebidas or (folheiaTransmitidas  and (c = 'E')) then
                            begin
                                folheiaDestroi;
                                prepararCarta (c, nCar, false, '', dirAtual);
                            end
                         else
                         if (folheiaTransmitidas) and (c = 'R') then
                            reenviarCarta (nCar)
                         else
                         if  (not folheiaTransmitidas) and (c = 'E') then
                            begin
                                folheiaDestroi;
                                prepararCarta ('E', nCar, true, '', dirAtual);
                            end
                         else
                            msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}
                    ^R, ^E: if folheiaRecebidas  or (folheiaTransmitidas  and (c = ^E)) then
                            begin
                                folheiaDestroi;
                                prepararCarta (c, nCar, false, '', dirAtual);
                            end
                         else msgBaixo ('CTOPVINV'); {'Opo invlida, aperte F1 para ajuda'}

                    'F' : begin
//                    mudafala := not mudafala;
                    if not mudafala then
                        begin
                        begin
                            sintwrite (' De ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
decodificarString (regLido [nCar]^.carta^.x_original_from);
sintetiza (regLido [nCar]^.carta^.x_original_from)
end
else
sintetiza (regLido [nCar]^.carta^.from);
end;
    sintetiza (intToStr (nCar));
                            end;
    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
    end;
//                            sintetiza (regLido[nCar]^.carta^.delivered_to);
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.to_);
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.bcc);
                        end;
                        end
                    else
                        begin
                        begin
                            sintwrite (' De ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
decodificarString (regLido [nCar]^.carta^.x_original_from);
sintSoletra (regLido [nCar]^.carta^.x_original_from);
end
else
sintSoletra (regLido [nCar]^.carta^.from);
end;
    sintetiza (intToStr (nCar));
                            end;
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintSoletra (s);
    end;
//                            sintSoletra (regLido[nCar]^.carta^.delivered_to);
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintWrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.to_);
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.bcc);
                        end;
                        end;
                        end;

                    ^F : begin
//                    mudafala := not mudafala;
                    if not mudafala then
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
    end;
//                            sintetiza (regLido[nCar]^.carta^.delivered_to);
    sintetiza (intToStr (nCar));
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.to_);
    sintetiza (intToStr (nCar));
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.bcc);
    sintetiza (intToStr (nCar));
                        end
                    else
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintSoletra (s);
    end;
//                            sintSoletra (regLido[nCar]^.carta^.delivered_to);
    sintetiza (intToStr (nCar));
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintWrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.to_);
    sintetiza (intToStr (nCar));
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.bcc);
    sintetiza (intToStr (nCar));
                        end;
                        end;

                    '\' : begin
//                    mudafala := not mudafala;
                    if mudafala then
                        begin
                        begin
                            sintwrite (' De ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
decodificarString (regLido [nCar]^.carta^.x_original_from);
sintetiza (regLido [nCar]^.carta^.x_original_from);
end
else
sintetiza (regLido [nCar]^.carta^.from);
end;
    sintetiza (intToStr (nCar));
                            end;
    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
    end;
//                            sintetiza (regLido[nCar]^.carta^.delivered_to);
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.to_);
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.bcc);
                        end;
                        end
                    else
                        begin
                        begin
                            sintwrite (' De ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
decodificarString (regLido [nCar]^.carta^.x_original_from);
sintSoletra (regLido [nCar]^.carta^.x_original_from);
end
else
sintSoletra (regLido [nCar]^.carta^.from);
end;
    sintetiza (intToStr (nCar));
                            end;
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintSoletra (s);
    end;
//                            sintSoletra (regLido[nCar]^.carta^.delivered_to);
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintWrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.to_);
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.bcc);
                        end;
                        end;
                        end;

                    ^\ : begin
//                    mudafala := not mudafala;
                    if mudafala then
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
    end;
//                            sintetiza (regLido[nCar]^.carta^.delivered_to);
    sintetiza (intToStr (nCar));
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.to_);
    sintetiza (intToStr (nCar));
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintetiza (regLido [nCar]^.carta^.bcc);
    sintetiza (intToStr (nCar));
                        end
                    else
                    if trim (regLido [nCar]^.carta^.delivered_to) <> '' then
    begin
                        begin
    if folheiaRecebidas then
                                    begin
                                    sintwrite (' Para ');
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end;
    end
    else
                                    sintwrite (' Para ');
        s := regLido [nCar]^.carta^.to_;
    i := pos ('>', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintSoletra (s);
    end;
//                            sintSoletra (regLido[nCar]^.carta^.delivered_to);
    sintetiza (intToStr (nCar));
                            end
                        else
                        if trim (regLido [nCar]^.carta^.to_) <> '' then
                        begin
                                    sintWrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.to_);
    sintetiza (intToStr (nCar));
                        end
                        else
                        begin
                                    sintwrite (' Para ');
                            sintSoletra (regLido [nCar]^.carta^.bcc);
    sintetiza (intToStr (nCar));
                        end;
                        end;

                    'X':;

                    ^X: begin
delay (3);
    SintFim;
    doneWinCrt;
end;

                    'C': begin
                            nCar := fazCopias (nCar, dirAtual);
                            if nCar > numRegs then nCar := numRegs;
                         end;
                    ^K, 'K': if folheiaRecebidas then
    begin
                             adicionaNoMataSpam (nCar, true);
    bloquear := ansiUpperCase(copy (sintAmbiente ('CARTAVOX', 'BLOQUEAR'), 1, 1));
if bloquear = 'S' then
                    nCar := removerCarta1 (nCar, (c = 'K'), false);
    end
                         else
                             msgBaixo ('CTOPVINV');
                    ^L: if folheiaRecebidas then
                             adicionaNoMataSpam (nCar, false)
                         else
                             msgBaixo ('CTOPVINV');
        '.': leitorDeTela;
        'Z': begin
    if temItemSelecionado then
adicionaArquivo (posListArq, 1, dirAtual)
else
adicionaArquivo (nCar, 1, dirAtual);
end;
        ^Z: adicionaArquivo (posListArq, numRegs, dirAtual);
        ^W: adicionaArquivoFrom (posListArq, numRegs, dirAtual);
                    'S': selecionaApelido (nCar, folheiaRecebidas);
                    ^S: for i := 1 to numRegs do
                            regLido [i]^.selecionado := true;

                    'O':
                        begin
                            editaArquivo (regLido [nCar]^.carta^.nomarqCarta);
                            regLido [nCar]^.carta^.preenchido := false;
                            carregaArqPreencheCabPrin (nCar);
                        end;
                    'T': if tipoFolheamento in ['P', ^P] then
                                begin
                                    transmitirCartas (true, tipoFolheamento);
                                    folheiaDestroi;
                                    desmontaListaDeCartas;
                                    {$I-}  chdir (dirAtual);  {$I+}
                                    if ioresult <> 0 then;
                                    folhearCartas (tipoFolheamento);
                                    exit;
                                end
                          else
                                transmitirCartas (false, 'P');

                    'Q', ^Q: falaQualItemDeQuantos (nCar, c = ^Q);
                    ^G: nCar := posicaoCarta (nCar);
                    'G': begin nCar := posicaoNomeArqCarta (nCar);
    sintetiza (regLido [nCar]^.carta^.nomArqCarta); end;

                    ^P: begin
                            agruparPorAssunto := false;
                            c := ESC;
                        end;

                    'U': if folheiaRecebidas then ativaRespAut (true, false, nCar);

                    ESC: if perguntaAoSairFolheamento then
                        repeat
                            msgBaixo('CTSAIFOL'); {'Deseja sair do folheamento?'}
                            sintLeTecla (c, c2);
                            if upcase(c) in ['S', ENTER] then c := ESC
                            else
                                begin
                                    msgBaixo('CTDESIST'); {'Desistiu'}
                                    c := 'N';
                                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}
                                end;
                        until upcase(c) in ['S', 'N', ENTER, ESC];

                else
                    if (c <> ESC) and (c in[CTLF1, CTLF2, CTLF3]) then msgBaixo ('CTOPVINV');
                end;

                if (numRegs >0) and (c <> ESC) and
                    (upcase(c) in ['H', 'I', 'B', ENTER, 'L', CTLENTER, ^L, 'P', 'A', ^A,
                    'R', ^R, 'E', ^E, 'C', 'S', 'O', 'T', 'U']) then
    begin

    if (nCar) = 0 then
                    msgBaixo ('CTCNTFOL');  {'Continue folheando ou tecle ESC'}

    if (nCar) > 0 then
    begin
    if folheiaRecebidas then
begin
    if trim (regLido [nCar]^.carta^.x_original_from) <> '' then
begin
        s := regLido [nCar]^.carta^.x_original_from;
        decodificarString (s);
end
else
        s := regLido [nCar]^.carta^.from;
end
    else
        s := regLido [nCar]^.carta^.to_;
    i := pos ('<', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    if s = '' then s:= 'NULO';
    sintWriteln(s);
                            if trim (regLido [nCar]^.carta^.subject) = '' then
                                sintetiza ('NULO')
                            else
                                sintetiza (regLido [nCar]^.carta^.subject);
    end;
    end;
            end;

        if numRegs <= 0 then
            begin
                if (not agruparPorAssunto) and
                    not ((tipoFolheamento in ['P', ^P]) and (numRegs=0)) then
                    msgBaixo ('CTSEMCAR');  {'No tem carta neste diretrio'}
                c := ESC;
            end;
        if (upCase(c) in['V', 'F', 'M', ^F, 'I', 'B', ENTER, 'L', CTLENTER, ^L, 'P', 'A', ^A, 'R', ^R, 'E', ^E, 'C',
            'X', 'S', 'O', 'T']) or
            (c2 in [ESQ, DIR, F8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

        if not (upcase (c) in ['L',ENTER, CTLENTER, ^L, 'P', 'R', ^R, 'E', ^E]) then
            folheiaDestroi;

    until c = #$1b;
    if (numRegs > 0) and (not agruparPorAssunto) then
        msgBaixo ('CTFOLFIM');  {'Folheamento terminado'}
    desmontaListaDeCartas;
    {$I-}  chdir (dirAtual);  {$I+}
    if ioresult <> 0 then;

    if agruparPorAssunto then folhearCartas (tipoFolheamento);
    if pastaRegra <> '' then dirRecebe := dirAtualCartas;
end;

end.
