{--------------------------------------------------------}
{
{           cartaVox - rotinas utilitarias
{
{--------------------------------------------------------}

unit carUtil;

interface

uses
    classes,
    dvarq,
    dvcrt,
    dvexec,
    dvForm,
    dvWin,
    shellApi,
    sysutils,
    windows,
    ActiveX,
MSHTML,
SHDocVw,
    Variants,
    carDecod,
    carMsg,
    carVars;

function pegaAnoMesDia1: string;
function pegaHoraMinuto1: string;
function existeArq (nomearq: string): boolean;
function existeDir (dir: string): boolean;
function novoNomeCarta (var nbase: integer; diret, extensao: string): string;

function pegaPrefixoAssunto (assunto: string): string;
function limpaAssunto (assunto: string): string;
function limpaAssuntoLista (assunto: string): string;
function limpaTexto (s: string): string;
function retornaEMail(s: string): string;
function retornarNome (s: string; primeiroNome: boolean): string;

procedure marcaOuDesmarca(nCar: integer; mudo: boolean; var nBase: integer);
function apagaUmRegs (nCar: integer): integer;
function pegaTamanhoArq (nomeArq: string): longint;
function formataTamanhoArq (tam: longint): string;
procedure mostraDadosArq (nomeArq: string);
procedure tamanhoCarta (nCar: integer);
procedure tamanhoTodasCartas;
function posicaoNomeArqCarta (nCar: integer): integer;
function posicaoCarta (var nCar: integer): integer;
procedure falaNumeroCartas;
procedure infoCarta (nCar: integer);

function converteData (data: string; extenso: boolean): string;

procedure contemAnexos (nCar: integer);
function testaExtensao (nomeArq: string): boolean;
function retornaExtensao (s: string): string;

function carregaLinhasArquivo (nomeArq: string): boolean;
procedure destroiLinhasArquivo;

procedure MenuAdiciona (msg: string);
procedure deletaAspas (var s: string);
procedure deletaMenorMaior (var s: string);
procedure limpaParteTela(inicio, fim: integer);
function numeroDeCartas (tipoFolhe: char): integer;
function numeroDeCartasGrupoContas (tipoFolhe: char): integer;
function temMaisDeUmEndeereco (s: string): boolean;
function TypeOuContent_Type (parte: PEstrutura): string;

procedure selecionaOuNaoUmItem (nItem: integer);
procedure selecionaTodosItens (selecionar: boolean);
function temItemSelecionado: boolean;
function totalDeItensSelecionados: integer;
procedure falaQualItemDeQuantos (nItem: integer; Selecionados: boolean);
function apagaItensDoFolheamento (numFolhe: integer): integer;
procedure mataSpam;
procedure criaPrefixoNomeArq;
procedure split(Separator: Char; const S: String ; MyStringList: TStringList);
procedure converteArqParaTxt (nomeArq: string);
procedure converteArqParaTxt1 (nomeArq: string);
function verificaStringNumero(const s: string): boolean;
function deletaArquivo(nomeArq: string): boolean;
function pegaDirAtual: string;
function pegaDirTemp: string;
function trocaDir (dirTrocar: string): boolean;

var
    linhasArquivo: TStringList;
    prefixoNomeArq: string;{nomeConfigurao sem caracteres proibidos}

implementation

{-------------------------------------------------------------}
{       Carrega todas as linhas do arquivo na memria
{-------------------------------------------------------------}

function carregaLinhasArquivo (nomeArq: string): boolean;
begin
    linhasArquivo := TStringList.create;
    carregaLinhasArquivo := true;
    try
        linhasArquivo.loadFromFile (nomeArq);
    except
         carregaLinhasArquivo := false;
    end;
end;

{-------------------------------------------------------------}
{       Destroi todas as linhas do arquivo da memria
{-------------------------------------------------------------}

procedure destroiLinhasArquivo;
begin
    linhasArquivo.free;
end;

{--------------------------------------------------------}
{ Testa se arquivo existe
{--------------------------------------------------------}

function existeArq (nomearq: string): boolean;
var existe: boolean;
    arq: file;
begin
    assign (arq, nomearq);
    {$I-}  reset (arq); {$i+}
    existe := ioresult = 0;
    if existe then close (arq);
    existeArq := existe;
end;

{-------------------------------------------------------------}
{       Testa se existe o diretrio.
{-------------------------------------------------------------}

function existeDir (dir: string): boolean;
var dirAtual: string;
begin
    getDir (0, dirAtual);
    {$I-}  chdir (dir);  {$I+}
    existeDir := ioresult = 0;
    chdir (dirAtual);
end;

{--------------------------------------------------------}
{       Retorna o ano, mes e dia para o nome do arquivo da carta
{--------------------------------------------------------}

function pegaAnoMesDia: string;
var
    diaSemana, dia, mes, ano: word;
    s, s2: string;
    nCar: integer;
begin
    getDate (ano, mes, dia, diaSemana);
    str (ano, s2);
    str (mes, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;
    str (dia, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;

    pegaAnoMesDia := s2;
end;

{--------------------------------------------------------}
{       Retorna a hora e minuto para o nome do arquivo da carta
{--------------------------------------------------------}

function pegaHoraMinuto: string;
var
    hora, minuto, segundo, cent: word;
    s, s2: string;
begin
    dvcrt.gettime (hora, minuto, segundo, cent);
    str (hora, s);
    if length(s) < 2 then s := '0' + s;
    s2 := 'H' + s;
    str (minuto, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s;
    str (segundo, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + s + 'E';

    pegaHoraMinuto := s2;
end;

{--------------------------------------------------------}
{       Retorna o ano, mes e dia para o nome do arquivo da carta com hfen
{--------------------------------------------------------}

function pegaAnoMesDia1: string;
var
    diaSemana, dia, mes, ano: word;
    s, s2: string;
begin
    getDate (ano, mes, dia, diaSemana);
    str (ano, s2);
    str (mes, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + '-' + s;
    str (dia, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + '-' + s;

    pegaAnoMesDia1 := s2;
end;

{--------------------------------------------------------}
{       Retorna a hora e minuto para o nome do arquivo da carta com hfen
{--------------------------------------------------------}

function pegaHoraMinuto1: string;
var
    hora, minuto, segundo, cent: word;
    s, s2: string;
begin
    dvcrt.gettime (hora, minuto, segundo, cent);
    str (hora, s);
    if length(s) < 2 then s := '0' + s;
    s2 := 's ' + s;
    str (minuto, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + 'h ' + s;
    str (segundo, s);
    if length(s) < 2 then s := '0' + s;
    s2 := s2 + 'min ' + s + 'seg';

    pegaHoraMinuto1 := s2;
end;

{-------------------------------------------------------------}
{       cria um novo nome para carta
{-------------------------------------------------------------}

function novoNomeCarta (var nbase: integer; diret, extensao: string): string;
var
    resulta, resulta2: integer;
    s, dirAtual, amdhm, extensaoAux: string;
    arq: file;
begin
    extensaoAux := '';
    resulta2 := 0;
    getDir (0, dirAtual);

    {$I-}  chdir (diret);  {$I+}
    if ioresult <> 0 then
        begin
            novoNomeCarta := '';
            exit;
        end;
    chDir (dirAtual);

    if diret [length(diret)] = '\' then
        delete (diret, length(diret), 1);

    if not antigoNomeArq then
        begin
            amdhm:= prefixoNomeArq;
            if amdhm <> '' then amdhm := amdhm + '_';
            amdhm:= amdhm + pegaAnoMesDia + pegaHoraMinuto;
        end;

    If extensao = '.$$$' then
        begin
            extensaoAux := extensao;
            extensao := '.car';
        end
    else
    If (maiuscansi(extensao) = '.ENV') or (maiuscansi(extensao) = '.CPR') then
        extensao := 'M' + extensao;

    repeat
        str (nbase, s);
        nbase := nbase + 1;
        assign (arq, diret + '\' + amdhm + s + extensao);
        {$I-} reset (arq);  {$I+}
        resulta := ioresult;
        if resulta = 0 then   // carta j existia
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then;
                continue;
            end;

        if pos ('M.', extensao) <> 0 then
            assign (arq, diret + '\' + amdhm + s +  copy (extensao, 2, length (extensao)))
        else
            assign (arq, diret + '\' + amdhm + s + 'M' + extensao);

        {$I-} reset (arq);  {$I+}
        resulta2 := ioresult;
        if resulta2 = 0 then
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then ;
            end;

    until (resulta <> 0) and (resulta2 <> 0);

    if extensaoAux <> '' then extensao := extensaoAux;
    novoNomeCarta := diret + '\' +amdhm + s + extensao;
end;

{--------------------------------------------------------}
{       Retorna o prefixo do assunto
{--------------------------------------------------------}

function pegaPrefixoAssunto (assunto: string): string;
var k, k2, k3, k4, k5, k6: integer;
    l, r: string;
begin
    pegaPrefixoAssunto := '';
    k := pos ('[{', assunto);
    if (trim(assunto) = '') or (k > 0) then exit;

    l := '';
    r := '';

    k := pos ('- T', assunto);
    if k > 0 then
        begin
delete (assunto, k, 3);
        insert ('{ T', assunto,  k);
        end;

    k2 := pos ('d -', assunto);
    if k2 > 0 then
        begin
delete (assunto, k2, 3);
        insert ('d }', assunto,  k2);
        end;

    k := pos ('[', assunto);
    k2 := pos (']', assunto);
    if (k > 0) and (k2 > 0) and (k2 > k) then
        begin
            l := copy (assunto, k, k2 - k + 1);
        end;

    k2 := pos ('{', assunto);
    k3 := pos ('}', assunto);
    if (k2 > 0) and (k3 > 0) and (k3 > k2) then
        if (k < k2) and (k > 0) then
            l := l + ' ' + copy (assunto, k2, k3 - k2 + 1)
        else
        if l <> '' then
            l := copy (assunto, k2, k3 - k2 + 1) + ' ' + l
        else
            l := copy (assunto, k2, k3 - k2 + 1);

    if ((k2 < k) or (k = 0)) and (k2 > 0) then k := k2;

    k2 := pos('RES: ', maiuscansi(assunto));
    k3 := pos('ENC: ', maiuscansi(assunto));
    k4 := pos('RE: ', maiuscansi(assunto));
    k5 := pos('EN: ', maiuscansi(assunto));
    k6 := pos('FW: ', maiuscansi(assunto));

    if ((k3 < k2) or (k2 = 0)) and (k3 > 0) then k2 := k3;
    if ((k4 < k2) or (k2 = 0)) and (k4 > 0) then k2 := k4;
    if ((k5 < k2) or (k2 = 0)) and (k5 > 0) then k2 := k5;
    if ((k6 < k2) or (k2 = 0)) and (k6 > 0) then k2 := k6;
    if k2 > 0 then
        begin
            r := copy (assunto, k2, 4);
            if (r <> '') and (r[4] <> ' ') then r := r + ' ';
        end;

    if k2 < k then
        assunto := r + l + ' '
    else
    if k = 0 then
        assunto := r
    else
        assunto := l + ' ' + r;

    pegaPrefixoAssunto := assunto;
end;

{--------------------------------------------------------}
{       Limpa o assunto.
{--------------------------------------------------------}

function limpaAssuntoLista (assunto: string): string;
var k, k2: integer;
label fim;
begin
    k := pos ('[{', assunto);
    if k > 0 then goto fim;

    k := pos ('- T', assunto);
    if k > 0 then
        begin
delete (assunto, k, 3);
        insert ('{ T', assunto,  k);
        end;

    k2 := pos ('d -', assunto);
    if k2 > 0 then
        begin
delete (assunto, k2, 3);
        insert ('d }', assunto,  k2);
        end;

    k := pos ('[', assunto);
    k2 := pos (']', assunto);
    while (k <> 0) and (k2 <> 0) and (k2 > k) do
        begin
            delete (assunto, k, k2-k+1);
            k := pos ('[', assunto);
            k2 := pos (']', assunto);
        end;

    k := pos ('{', assunto);
    k2 := pos ('}', assunto);
    while (k <> 0) and (k2 <> 0) and (k2 > k) do
        begin
            delete (assunto, k, k2-k+1);
            k := pos ('{', assunto);
            k2 := pos ('}', assunto);
        end;

    while (assunto <> '') and ( assunto[1] = ' ') do
        delete (assunto, 1,1);
fim:
    limpaAssuntoLista := assunto;
end;


function limpaAssunto (assunto: string): string;
var k, k2, k3: integer;
label fim;
begin
    k := pos ('[{', assunto);
    if (trim(assunto) = '') or (k > 0) then goto fim;

    k := pos ('RES: ', maiuscansi(assunto));
    k2 := pos ('ENC: ', maiuscansi(assunto));
    while (k <> 0) or (k2 <> 0) do
        begin
            if k = 0 then k := k2;
            delete (assunto, k, 5);
            k := pos ('RES: ', maiuscansi(assunto));
            k2 := pos ('ENC: ', maiuscansi(assunto));
        end;




    k := pos ('FWD: ', maiuscansi(assunto));
    k2 := pos ('ENC: ', maiuscansi(assunto));
    while (k <> 0) or (k2 <> 0) do
        begin
            if k = 0 then k := k2;
            delete (assunto, k, 5);
            k := pos ('FWD: ', maiuscansi(assunto));
            k2 := pos ('ENC: ', maiuscansi(assunto));
        end;

    k := pos ('RE: ', maiuscansi(assunto));
    k2 := pos ('EN: ', maiuscansi(assunto));
    k3 := pos ('FW: ', maiuscansi(assunto));
    while (k <> 0) or (k2 <> 0) or (k3 <> 0) do
        begin
            if k = 0 then k := k2;
            if (k = 0) and ( k2 = 0) then k := k3;
            delete (assunto, k, 4);
        k := pos ('RE: ', maiuscansi(assunto));
            k2 := pos ('EN: ', maiuscansi(assunto));
            k3 := pos ('FW: ', maiuscansi(assunto));
        end;

    assunto := limpaAssuntoLista (assunto);

    while (assunto <> '') and ( assunto[1] = ' ') do
        delete (assunto, 1,1);

fim:
    limpaAssunto := assunto;
end;

{--------------------------------------------------------}
{       Devolve o texto limpo
{--------------------------------------------------------}

function limpaTexto (s: string): string;
var texto: string;
    p: integer;
begin
    s := trim (s);
    texto := s;

    p := pos ('(', texto);
    if p <> 0 then
        begin
            delete (texto, 1, p);
            while texto[length(texto)] = ' ' do
                delete (texto, length(texto), 1);
            if texto[length (texto)] = ')' then
                delete (texto, length(texto), 1);
        end;
    texto := trim (texto);
    if texto = '' then texto := s;    { casos estranhos... }

    for p := length (texto) downto 1 do
        if texto[p] = '"' then delete (texto, p, 1);

    limpaTexto := texto;
end;

{-------------------------------------------------------------}
{           Limpa sobrando somente o e-mail
{-------------------------------------------------------------}

function retornaEMail(s: string): string;
var
    p, k: integer;
begin
    retornaEMail := s;
    s := trim(s);
    k := pos('<', s);
    if k > 0 then delete(s, 1, k);
    p := pos('@', s);
    if (s = '') or (p = 0) then exit;
    k := pos('<', s);
    if (k > 0) and (k < p) then delete(s, 1, k);
    p := pos('@', s);
    k := pos('>', s);
    if (k <> 0) and (k > p) then delete(s, k, length(s)-k+1);
    retornaEMail:= s;
end;

{-------------------------------------------------------------}
{       Retorna o nome, da string nome + e-mail
{-------------------------------------------------------------}

function retornarNome (s: string; primeiroNome: boolean): string;
var i, i1, i2: integer;
begin
    i1 := pos ('-', s);
    i2 := pos ('&', s);
    i := pos ('<', s);
    if i > 1 then s := copy (s, 1, i-1);
    deletaMenorMaior (s);
    deletaAspas (s);
    s := trim(s);
    if s = '' then s:= 'NULO'
    else
    if((length(s) > 3) and(s[3] = '/')) or //considera a barra na terceira coluna
      (i2 > 1) or //considera o & em qualquer posio
      (i1 > 1) and //considera o hfen sem espaos em branco antes e depois
      (primeiroNome) and ( pos (' - ', s) < 4) then //desconsidera o hfen entre espaos
        retornarNome := s
    else
    if (primeiroNome) and ( pos (' ', s) > 2) then
        s := copy (s, 1, pos(' ', s) -1);
    retornarNome := s;
end;

{--------------------------------------------------------}
{       Marca ou desmarca o arquivo da carta lida
{--------------------------------------------------------}

procedure  marcaOuDesmarca(nCar: integer; mudo: boolean; var nBase: integer);
var
    arq: text;
    nomeArq, diret, s: string;
    marcar: boolean;
    i, total: integer;

    function  marcaArquivo: boolean;
    begin
        marcaArquivo := true;
        if marcar then
            begin
                if pos ('M.', nomeArq) <> 0 then exit;
                nomeArq := copy (nomeArq, 1, length (nomeArq) - 4) + 'M.car';
            end
        else
            begin
                if pos ('M.', nomeArq) = 0 then exit;
                delete (nomeArq, length (nomeArq) - 4, 1);
            end;
        assign (arq, nomeArq);
        {$I-} reset (arq); {$I+}
        if ioresult = 0 then
            begin
                {$I-} close (arq);  {$I+}
                if ioresult <> 0 then ;
                if marcar then
                    s := copy (nomeArq, pos ('.', nomeARq)-1, length (nomeArq))
                else
                    s := copy (nomeArq, pos ('.', nomeARq), length (nomeArq));
                nomeArq := novoNomeCarta (nBase, diret, s);
                while pos ('\', nomeArq) <> 0 do
                    delete (nomeArq, 1, pos ('\', nomeArq));
            end;
        assign (arq, regLido [i]^.carta^.nomArqCarta);
        {$i-} rename (arq, nomeArq);  {$I+}
        if ioresult <> 0 then
            begin
                msgBaixo ('CTERRDSK'); {'Erro de escrita no disco'}
                marcaarquivo := false;
            end
        else
            regLido [i]^.carta^.nomArqCarta := nomeArq;
    end;


begin
    getDir (0, diret);

    if nCar <> 0 then
        total := ncar
    else
        begin
            nCar := 1;
            total := numRegs;
        end;

    nomeArq := regLido [nCar]^.carta^.nomArqCarta;
    if pos ('M.', nomeArq) <> 0 then
        marcar := false
    else
        marcar := true;

    for i := nCar to total do
        begin
            nomeArq := regLido [i]^.carta^.nomArqCarta;
            if not marcaArquivo then exit;
            if (i mod 500) = 0 then
                sintclek;
        end;

    if not mudo then
        if marcar then
            msgBaixo ('CTMARCAD') {'Marcado'}
        else
            msgBaixo ('CTNMARCA'); {'Desmarcado'}
end;

{--------------------------------------------------------}
{       apaga um registro
{--------------------------------------------------------}

function apagaUmRegs (nCar: integer): integer;
var i: integer;
begin
    regLido[nCar]^.carta^.partesCarta.free;
    dispose (regLido [nCar]);
    numRegs := numRegs - 1;
    for i := nCar to numRegs do
        regLido [i] := regLido [i+1];
    nCar := nCar - 1;
    apagaUmRegs := nCar;
end;

{--------------------------------------------------------}
{       retorna o tamanho do arquivo passado
{--------------------------------------------------------}

function pegaTamanhoArq (nomeArq: string): longint;
var
    f: file of byte;
begin
    pegaTamanhoArq := 0;
    Assign(f, nomeArq);
    {$I-} Reset(f); {$I+}
    if IOResult <> 0 then exit;
    pegaTamanhoArq := FileSize(f);
    Close(f);
end;

{--------------------------------------------------------}
{       Formata o tamanho do arquivo
{--------------------------------------------------------}

function formataTamanhoArq (tam: longint): string;
var
    medida: char;
    decimal: integer;
begin
    medida := ' ';
    if tam >= 65536 then
        begin
            medida := 'K';
            decimal := tam mod 1024;
            tam := tam div 1024;
            if decimal > 512 then tam := tam + 1;
        end;

    formataTamanhoArq := intToStr (tam) + medida;
end;

{--------------------------------------------------------}
{                mostra dados de arquivo
{--------------------------------------------------------}

procedure mostraDadosArq (nomeArq: string);
const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado');
var
    srec: TSearchRec;
begin
    sintWriteln (nomeArq);
    if FindFirst(nomeArq, faAnyFile, srec) <> 0 then
        begin
//            mensagem ('DVINDISP', 1);   {'Dado no disponvel'}
            exit;
        end;

    if (fileGetAttr (srec.FindData.cFileName) and faReadOnly) <> 0 then
//         mensagem ('DVPRO', 1);    { Protegido }
;
    falaTamanhoArq (srec.Size);
    writeln;

//    mensagem ('DVDATCRI', 0);
sintWriteln (tabDias [dayOfWeek (FileDateToDateTime(srec.Time))]
        + ' ' + dateToStr (FileDateToDateTime(srec.Time))
        + ' ' + timeToStr (FileDateToDateTime(srec.Time)));
    writeln;

//    findClose (srec);
end;

{--------------------------------------------------------}
{       Fala o tamanho do arquivo da carta
{--------------------------------------------------------}

procedure tamanhoCarta (nCar: integer);
begin
    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTTAMAN', 0); {'Tamanho '}
    write (' ');
    sintWrite (formataTamanhoArq (regLido [nCar]^.carta^.tamanho));
    textBackground (BLACK);
    writeln;
end;

{--------------------------------------------------------}
{       Fala o tamanho do arquivo de todas as cartas
{--------------------------------------------------------}

procedure tamanhoTodasCartas;
var
    i, tam: integer;
begin
    tam := 0;
    for i := 1 to numRegs do
        tam := tam + regLido [i]^.carta^.tamanho;

    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTTAMAN', 0); {'Tamanho '}
    write ('  ');
    sintWrite (formataTamanhoArq (tam));
    textBackground (BLACK);
    writeln;
end;

{--------------------------------------------------------}
{       Procura a carta pelo nome do arquivo
{--------------------------------------------------------}

function posicaoNomeArqCarta (nCar: integer): integer;
var k: integer;
    nomeArq: string;
    c: char;
begin
    posicaoNomeArqCarta := nCar;
    repeat
        limpaParteTela (23, 25);
        textBackground (RED);
        mensagem ('CTINARQP', 0); {'Informe o nome do arquivo a procurar'}
        write (': ');
        textBackground (BLACK);
        writeln;
        nomeArq:= '';
        c := sintEditaCampo (nomeArq, 1, wherey, 255, 80, true);
        writeln;
    until c in [ENTER, ESC];
    if (c = ESC) or (nomeArq= '') then
        begin
            msgBaixo ('CTDESIST'); {'Desistiu'}
            exit;
        end;

    if (nCar + 1) >= numRegs then nCar := 1
    else nCar := nCar + 1;
    for k := nCar to numRegs do
        if pos (nomeArq, regLido [k]^.carta^.nomArqCarta) <> 0 then
            begin
                posicaoNomeArqCarta := k;
                msgBaixo ('CTACHEI');     {'Achei'}
                break;
            end;
    sintBip;
end;

{--------------------------------------------------------}
{       Posiciona na carta pegando o nmero.
{--------------------------------------------------------}

function posicaoCarta (var nCar: integer): integer;
var k: integer;
begin
    limpaParteTela (23, 25);
    textBackground (RED);
    mensagem ('CTINFNCA', 0);    {'Informe o nmero da carta a procurar de '}
    sintWrite ('1');
    sintwrite (' a ');
    sintWriteInt (numRegs);
    write (': ');
    textBackground (BLACK);
    writeln;
    sintReadint (k);
    writeln;

            if (k >= 1) and (k <= numRegs) then
            posicaoCarta := k
            else
                begin
                    if (k < 1) or (k > folheiaNumItens) then k := nCar;
                    mensagem ('CTNAOARQ', 0);  {'No existe'}
                    posicaoCarta := k;
                    sintWriteInt (k);
                    exit;
            end;
                    sintWriteInt (k);
        end;

{--------------------------------------------------------}
{       Fala o nmero de cartas no folheamento.
{--------------------------------------------------------}

procedure falaNumeroCartas;
begin
//    mensagem ('CTNUMCAR', -1); {'Nmero de cartas neste folheamento: '}
//    sintetiza (intToStr(numRegs));
    if numRegs = 1 then
    begin
            mensagem ('CTUMACAR', 0);  {'Uma carta'}
    write ('1 carta');
end;

    if numRegs = 2 then
    begin
            mensagem ('CTDUACAR', 0);  {'Duas cartas'}
    write ('2 cartas');
    end;
    if numRegs > 2 then
    begin
    sintetiza (intToStr(numRegs));
        tocaOuSintetiza ('CTCARTAS'); {'cartas'}
    end;
    end;

{--------------------------------------------------------}
{       informacoes sobre a carta
{--------------------------------------------------------}

procedure infoCarta (nCar: integer);
var data: string;

const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sabado');

begin
    delay (10);
    sintetiza (nomeConfiguracao);
    delay (100);
    limpaParteTela (18, 25);
    textBackground (RED);
    mensagem ('CTASSUNT', 0);  {'Assunto: '}
    textBackground (BLACK);
    writeln;
    if regLido [nCar]^.carta^.subject = '' then
        sintWriteLn ('Nulo')
    else
        sintWriteln (regLido [nCar]^.carta^.subject);
    contemAnexos (nCar);
    textBackground (RED);
    mensagem ('CTENVPOR', 0);  {'Enviada por '}
    textBackground (BLACK);
    writeln;
    sintWriteln ( regLido [nCar]^.carta^.from);
        limpaParteTela (22, 25);
        textBackground (RED);
    mensagem ('CTDATENV', 0);  {'Data de envio: '}
    textBackground (BLACK);
    data := regLido [nCar]^.carta^.date;
    data := converteData (data, true);
    if data <> '' then
        sintWriteln (data);
    textBackground (RED);
    mensagem ('CTDATCHE', 0);  {'Data de chegada: '}
    textBackground (BLACK);
    sintetiza (tabDias [dayOfWeek (fileDateToDateTime (
        reglido [nCar]^.carta^.datahora))]         + ' ' +
        dateToStr (fileDateToDateTime (regLido[nCar].carta^.datahora)) + ' ' +
        timeToStr(FileDateToDateTime(regLido[nCar].carta^.datahora)));
    textBackground (RED);
    mensagem ('CTARQUIV', 0);  {'Arquivo '}
    textBackground (BLACK);
    sintwriteln(regLido [nCar]^.carta^.nomArqCarta);
end;

{--------------------------------------------------------}
{       Retorna da data que a carta foi mandada
{--------------------------------------------------------}

function converteData (data: string; extenso: boolean): string;
var
    sem, dia, mes, ano, hora: string;
    i, erro: integer;

const
    tabMes: array [1..12] of string =
        ('Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho', 'Julho',
        'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');

begin
    data := trim (data);
    if (data = '') or (length(data) < 20) or (pos (':', data) = 0) then
        begin
            converteData := '';
            exit;
        end;

    if extenso then
        hora := copy (data, pos (':',data) - 2, 5);

    sem := '';
    if not (data[1] in ['0'..'9']) then
        begin
           sem := copy (data, 1, 3);
           delete (data, 1, 5);
        end;

    dia := data[1];
    delete (data, 1, 1);
    if data [1] <> ' ' then
        begin
            dia := dia + data[1];
            delete (data, 1, 1);
        end;
    delete (data, 1, 1);

    mes := copy (data, 1, 3);
    delete (data, 1, 4);
    ano := '';
    data := data + ' ';
    while data[1] <> ' ' do
        begin
            ano := ano + data [1];
            delete (data, 1, 1);
        end;

    if sem = 'Sun' then sem := 'Domingo' else
    if sem = 'Mon' then sem := 'Segunda' else
    if sem = 'Tue' then sem := 'Tera'   else
    if sem = 'Wed' then sem := 'Quarta'  else
    if sem = 'Thu' then sem := 'Quinta'  else
    if sem = 'Fri' then sem := 'Sexta'   else
    if sem = 'Sat' then sem := 'Sabado';

    if mes = 'Jan' then mes := '1'  else
    if mes = 'Feb' then mes := '2'  else
    if mes = 'Mar' then mes := '3'  else
    if mes = 'Apr' then mes := '4'  else
    if mes = 'May' then mes := '5'  else
    if mes = 'Jun' then mes := '6'  else
    if mes = 'Jul' then mes := '7'  else
    if mes = 'Aug' then mes := '8'  else
    if mes = 'Sep' then mes := '9'  else
    if mes = 'Oct' then mes := '10' else
    if mes = 'Nov' then mes := '11' else
    if mes = 'Dec' then mes := '12';

    if extenso then
        begin
            if sem <> '' then sem := sem + ', ';
            val (mes, i, erro);
            if erro = 0 then
                converteData := sem + dia+ ' de ' + tabMes [i] +                 ' de ' + ano + ' ' + hora
            else
                converteData := '';
        end
    else
        converteData := sem + ' ' + dia+ '/' + mes + '/' + ano;
end;

{--------------------------------------------------------}
{       Fala se tem anexo na carta
{--------------------------------------------------------}

procedure contemAnexos (nCar: integer);
begin
    if regLido [nCar]^.boundary <> '' then
        msgBaixo ('CTTEMATT');     {'Contm arquivos inclusos'}
end;

{--------------------------------------------------------}
{       Testa se o nome do arquivo tem extenso
{--------------------------------------------------------}

function testaExtensao (nomeArq: string): boolean;
begin
    while (pos ('\', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('\', nomearq));
    while (pos ('/', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('/', nomearq));

    if pos ('.', nomeArq) <> 0 then
        testaExtensao := true
    else
        testaExtensao := false;
end;

{-------------------------------------------------------------}
{       Retorna a extenso de um arquivo
{-------------------------------------------------------------}

function retornaExtensao (s: string): string;
var i: integer;
begin
    if pos ('.', s) = 0 then s := ''
    else
        begin
            i := length (s);
            while s[i] <> '.' do i := i - 1;
            delete (s, 1, i);
        end;
        retornaExtensao := s;
end;

{-------------------------------------------------------------}
{       Utilizado para montar o menu de opes
{-------------------------------------------------------------}

procedure MenuAdiciona (msg: string);
begin
     popupMenuAdiciona (msg, pegaTextoMensagem (msg)); {}
end;

{-------------------------------------------------------------}
{       Deleta as " do fim e do incio da string.
{-------------------------------------------------------------}

procedure deletaAspas (var s: string);
begin
    s := trim (s);
    if s = '' then exit;
    if pos ('"', s) <> 0 then
        if s[1] = '"' then delete (s, 1, 1);
    if pos ('"', s) <> 0 then
        if s[length(s)] = '"' then delete (s, length(s), 1);
end;

{-------------------------------------------------------------}
{       Deleta o sinal de < e > da extremidade da string
{-------------------------------------------------------------}

procedure deletaMenorMaior (var s: string);
begin
    s := trim (s);
    if s = '' then exit;
    if pos ('<', s) <> 0 then
        if s[1] = '<' then delete (s, 1, 1);
    if pos ('>', s) <> 0 then
        if s[length(s)] = '>' then delete (s,         length(s), 1);
end;

{----------------------------------------------------------------------}
{       Linpa a parte da tela desejada.
{----------------------------------------------------------------------}

procedure limpaParteTela(inicio, fim: integer);
var i: integer;
begin
    for i := inicio to fim do
    begin
        gotoxy (1,i); clreol;
    end;
    gotoxy (1, inicio);
end;

{-------------------------------------------------------------}
{       Retorna o nmero de cartas preparadas para o envio
{-------------------------------------------------------------}

function numeroDeCartas (tipoFolhe: char): integer;
var
    dirAtual, s: string;
    dirInfo: TSearchRec;
    ext: array [0..10] of char;
    dosError, i: integer;
label proximoArq;
begin
    numeroDeCartas := 0;
    getDir (0, dirAtual);
    case tipoFolhe of
        'F', 'N', 'L': begin
                            s := 'CAR';
                            {$I-}  chdir (dirRecebe);  {$I+}
                            if ioresult <> 0 then exit;
                       end;
        'P': begin
                s := 'CPR';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then exit;
             end;
        'T': begin
                s := 'ENV';
                {$I-}  chdir (dirEnvia);  {$I+}
                if ioresult <> 0 then exit;
             end;
    end;

    i := 0;
    strPcopy (ext, '*.' + s);
    dosError := FindFirst (ext, FaArchive, DirInfo);
    while DosError = 0 do
        begin
            s := trim(dirInfo.name);
            if (upcase (tipoFolhe) = 'L') and
               (upcase (s[length (s) - 4]) <> 'M') then
                    goto proximoArq
            else
            if (upcase (tipoFolhe) = 'N') and
               (upcase (s[length (s) - 4]) = 'M') then
                    goto proximoArq;
            i := i + 1;
proximoArq:
            dosError := FindNext (DirInfo);
        end;

    numeroDeCartas := i;

    {$I-}  chdir (dirAtual);  {$I+}
    if ioresult <> 0 then;
end;

{-------------------------------------------------------------}
{      Retorna o nmero de cartas preparadas para o envio
{      de uma conta do grupo de contas
{-------------------------------------------------------------}

function numeroDeCartasGrupoContas (tipoFolhe: char): integer;
var
    dirAtual, s, nomeConfigCar, nomeConfigAtual: string;
    dirInfo: TSearchRec;
    ext: array [0..10] of char;
    dosError, i, j, tam: integer;
label proximoArq;
begin
    getDir (0, dirAtual);
    case tipoFolhe of
        'F', 'N', 'L': begin
                           s := 'CAR';
                           try
                               chdir (dirRecebe);
                           except
                           on E : Exception do
                               begin
                                   numeroDeCartasGrupoContas := -1;
                                   exit;
                               end;
                           end;
                       end;
        'P': begin
                 s := 'CPR';
                 try
                     chdir (dirEnvia);
                 except
                 on E : Exception do
                     begin
                         numeroDeCartasGrupoContas := -1;
                         exit;
                     end;
                 end;
             end;
        'T': begin
                 s := 'ENV';
                 try
                     chdir (dirEnvia);
                 except
                 on E : Exception do
                     begin
                         numeroDeCartasGrupoContas := -1;
                         exit;
                     end;
                 end;
             end;
    end;

    i := 0;
    strPcopy (ext, '*.' + s);
    dosError := FindFirst (ext, FaArchive, DirInfo);
    while DosError = 0 do
        begin
            s := trim(dirInfo.name);
            if (upcase (tipoFolhe) = 'L') and
               (upcase (s[length (s) - 4]) <> 'M') then
                    goto proximoArq
            else
            if (upcase (tipoFolhe) = 'N') and
               (upcase (s[length (s) - 4]) = 'M') then
                    goto proximoArq;

            nomeConfigCar := AnsiUpperCase(dirInfo.name);
            tam := length (nomeConfigCar);
            while tam > 0 do
                begin
                    if copy (nomeConfigCar, tam, 1) <> '_' then
                        begin
                            nomeConfigCar := copy (nomeConfigCar, 1, tam-1);
                            tam := tam - 1;
                        end
                    else
                        begin
                            nomeConfigCar := copy (nomeConfigCar, 1, tam-1);
                            break;
                    end;
                end;

            nomeConfigAtual := '';
            for j :=  length(nomeConfiguracao) downto 1 do
                if nomeConfiguracao [j] in ['-', '_', 'A'..'Z', 'a'..'z', '0'..'9'] then
                    nomeConfigAtual := nomeConfiguracao[j] + nomeConfigAtual;

            if nomeConfigCar <> nomeConfigAtual then goto proximoArq;

            i := i + 1;

proximoArq:
            dosError := FindNext (DirInfo);
        end;

    numeroDeCartasGrupoContas := i;

    try
        chdir (dirAtual);
    except
    on E : Exception do
        begin
            numeroDeCartasGrupoContas := -1;
            exit;
        end;
    end;
end;

{-------------------------------------------------------------}
{       Retorna true se encontrar mais de um @ na string
{-------------------------------------------------------------}

function temMaisDeUmEndeereco (s: string): boolean;
begin
    temMaisDeUmEndeereco := false;
    if (trim(s) <> '') and (pos ('>', s) <> 0) then
        begin
            delete (s, 1, pos ('>', s));
            if (trim(s) <> '') and (pos ('>', s) <> 0) then
                temMaisDeUmEndeereco := true;
        end
    else
    if (trim(s) <> '') and (pos ('@', s) <> 0) then
        begin
            delete (s, 1, pos ('@', s));
            if (trim(s) <> '') and (pos ('@', s) <> 0) then
                temMaisDeUmEndeereco := true;
        end;
end;

{-------------------------------------------------------------}
{       Retorna o type, se type = '', retorna o content-type
{-------------------------------------------------------------}

function TypeOuContent_Type (parte: PEstrutura): string;
var s: string;
begin
    if trim (parte^.type_) <> '' then
        s := parte^.type_
    else
        s := parte^.content_type;
    typeOuContent_Type := s;
end;

{-------------------------------------------------------------}
{       Seleciona ou no um item
{-------------------------------------------------------------}

procedure selecionaOuNaoUmItem (nItem: integer);
var
    selecionado: boolean;
    item: string;
begin
    folheiaObtemItem (nItem, item, selecionado);
    folheiaSeleciona (nItem, not selecionado);
end;

{-------------------------------------------------------------}
{       Seleciona ou tira a seleo de todos os itens
{-------------------------------------------------------------}

procedure selecionaTodosItens (selecionar: boolean);
var
    i: integer;
begin
    for i := 1 to folheiaNumItens do
        folheiaSeleciona (i, selecionar);
end;

{-------------------------------------------------------------}
{       Verifica se tem item selecionado.
{-------------------------------------------------------------}

function temItemSelecionado: boolean;
var
    i: integer;
    item: string;
    selecionado: boolean;
begin
    temItemSelecionado := FALSE;
    for i := 1 to folheiaNumItens do
        begin
            folheiaObtemItem (i, item, selecionado);
            if selecionado then
                begin
                    temItemSelecionado := TRUE;
                    break;
                end;
        end;
end;

{-------------------------------------------------------------}
{       Retorna a quantidade de itens selecionados.
{-------------------------------------------------------------}

function totalDeItensSelecionados: integer;
var
    i, itensSelecionados: integer;
    selecionado: boolean;
    item: string;
begin
    itensSelecionados := 0;
    for i := 1 to folheiaNumItens do
        begin
            folheiaObtemItem (i, item, selecionado);
            if selecionado then
                itensSelecionados := itensSelecionados + 1;
        end;

    totalDeItensSelecionados := itensSelecionados;
end;

{-------------------------------------------------------------}
{       Informa o total de itens do folheamento.
{       Fala em qual est ou as selecionadas do  total.
{-------------------------------------------------------------}

procedure falaQualItemDeQuantos (nItem: integer; Selecionados: boolean);
begin
    if selecionados then
        nItem := totalDeItensSelecionados;

    sintetiza (intToStr (nItem));
    if selecionados then
        if nItem >1 then
            mensagem ('CTSELECS', -1) {'selecionada'}
        else
            mensagem ('CTSELECI', -1); {'selecionadas'}
    mensagem ('CTDE', -1); {'de'}
    sintetiza (intToStr(folheiaNumItens));
end;

{-------------------------------------------------------------}
{       Apaga os itens do folheamento padro
{-------------------------------------------------------------}

function apagaItensDoFolheamento (numFolhe: integer): integer;
var
    i: integer;
    item: string;
    selecionado: boolean;
    c, c2: char;
begin
    if not temItemSelecionado then
        repeat
            msgBaixo ('CTDEREIT'); {'Deseja remover este item?'}
            folheiaObtemItem (numFolhe, item, selecionado);
            sintetiza (item);
            sintletecla (c, c2);
            if upcase (c) in ['S', ENTER] then
                begin
                    folheiaRemoveItem (numFolhe);
                    numFolhe := numFolhe - 1;
                end
            else
            if upcase (c) in ['N', ESC] then
                msgBaixo ('CTDESIST'); {'Desistiu'}
        until upcase (c) in ['N', 'S', ENTER, ESC]
    else
        repeat
            msgBaixo ('CTDEREIS'); {'Deseja remover todos os itens selecionados?'}
            sintLeTecla (c, c2);
            if upcase (c) in ['N', ESC] then
                msgBaixo ('CTDESIST') {'Desistiu'}
            else
            if upcase (c) in ['S', ENTER] then
                for i  := folheiaNumItens downto 1 do
                    begin
                        folheiaObtemItem (i, item, selecionado);
                        if selecionado then
                            begin
                                folheiaRemoveItem (i);
                                if i <= numFolhe then
                                    numFolhe := numFolhe -1;
                            end;
                    end;
        until upcase (c) in ['N', 'S', ENTER, ESC];

    if numFolhe < 1 then numFolhe := 1;
    apagaItensDoFolheamento := numFolhe;
end;

{-------------------------------------------------------------}
{       Chama o programa externo MataSpam.exe em \Winvox
{-------------------------------------------------------------}

procedure mataSpam;
var
    s: string;
    c: char;
begin
    s := sintAmbiente('DOSVOX', 'PGMDOSVOX') + '\mataSpam.exe';
    if not fileExists (s) then exit;
    if usaSSL then c := 'S' else c := 'N';
    if executaProg ( s, dirRecebe, hostPOP3+ ' '+contaUsuario+ ' '+ c + ' '+ senhaSalvaPop3) >= 32 then
        esperaProgVoltar;
    while sintFalando do waitMessage;
end;

{-------------------------------------------------------------}
{       Cria o prefixo do nome do arquivo limpando o nome da configurao
{-------------------------------------------------------------}

procedure criaPrefixoNomeArq;
var
    i: integer;
    s: string;
begin
    s := '';
    for i :=  length(nomeConfiguracao) downto 1 do
        if nomeConfiguracao [i] in ['-', '_', 'A'..'Z', 'a'..'z', '0'..'9'] then
            s := nomeConfiguracao[i] + s;
    prefixoNomeArq := s;
end;

{-------------------------------------------------------------}
{       Retorna uma substring dentro de uma string a partir
{       de um caractere separador
{-------------------------------------------------------------}

function getNextToken (Const S: string; Separator: char; var StartPos: integer): String;
var Index: integer;
begin
   Result := '';

   While (S[StartPos] = Separator) and (StartPos <= length(S)) do
      StartPos := StartPos + 1;

   if StartPos > length(S) then Exit;
   Index := StartPos;

   While (S[Index] <> Separator) and (Index <= length(S)) do
      Index := Index + 1;

   Result := Copy(S, StartPos, Index - StartPos) ;
   StartPos := Index + 1;
end;

{-------------------------------------------------------------}
{    Separa as substrings de uma string atravs do caractere
{    separador e coloca as substrings separadas em uma lista
{-------------------------------------------------------------}

procedure split (Separator: Char; const S: String; MyStringList: TStringList) ;
var Start: integer;
begin
   Start := 1;
   While Start <= Length(S) do
       MyStringList.Add(GetNextToken(S, Separator, Start)) ;
end;

{-------------------------------------------------------------}
{     Transforma a string com as tags em HTML em texto
{-------------------------------------------------------------}

function  StripHTML(S: string): string;
var
  TagBegin, TagEnd, TagLength: integer;
begin
  TagBegin := Pos( '<', S);      // search position of first <

  while  (TagBegin > 0) do begin   // while there is a < in S
    TagEnd := Pos('>', S);              // find the matching >
    TagLength := TagEnd - TagBegin + 1;
    Delete(S, TagBegin, TagLength);     // delete the tag
        insert ('&nbsp;', s,  TagBegin);
    TagBegin:= Pos( '<', S);            // search for next <
  end;

  Result := S;                   // give the result

    {convert system characters}
    Result := StringReplace(Result, '&quot;', '"',  [rfReplaceAll]);
    Result := StringReplace(Result, '&apos;', '''', [rfReplaceAll]);
    Result := StringReplace(Result, '&gt;',   '>',  [rfReplaceAll]);
    Result := StringReplace(Result, '&lt;',   '<',  [rfReplaceAll]);
    Result := StringReplace(Result, '&amp;',  '&',  [rfReplaceAll]);

    Result := StringReplace(Result, 'v\:*{behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'o\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'w\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '.shape {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'v\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '&#8220;', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '&#8221;', '',  [rfReplaceAll]);
    {here you may add another symbols from RFC if you need}

end;

{-------------------------------------------------------------}
{     Transforma a string com as tags em HTML em texto
{-------------------------------------------------------------}

function GetPlainText(Const Html: string): string;
var
DummyWebBrowser: TWebBrowser;
Document       : IHtmlDocument2;
DummyVar       : Variant;
p: integer;
begin
   Result := '';
   DummyWebBrowser := TWebBrowser.Create(nil);
   try
     //open an blank page to create a IHtmlDocument2 instance
     DummyWebBrowser.Navigate('about:blank');
     Document := DummyWebBrowser.Document as IHtmlDocument2;
     if (Assigned(Document)) then //Check the Document
     begin
DummyVar      := VarArrayCreate([0, 0], varVariant); //Create a variant array to write the html code to the  IHtmlDocument2
DummyVar[0]   := Html; //assign the html code to the variant array
Document.Write(PSafeArray(TVarData(DummyVar).VArray)); //set the html in the document
       Document.Close;
Result :=(Document.body as IHTMLBodyElement).createTextRange.text
;//get the plain text

            repeat
                p := pos (' ', result);
            if p > 0 then
begin
delete (result, p, 2);
        insert ('&nbsp;', result,  p);
end;
            until p = 0;

     end;
   finally
     DummyWebBrowser.Free;
   end;
end;

{-------------------------------------------------------------}
{     Transforma a string com as tags em HTML em texto
{-------------------------------------------------------------}

function StripHTMLTags(const strHTML: string): string;
var
    P: PChar;
    InTag: Boolean;
begin
    P := PChar(strHTML);
    Result := '';

    InTag := False;
    repeat
        case P^ of
            '<': InTag := True;
            '>': InTag := False;
            #10: ; {do nothing}
            #13: Result := Result + '&nbsp;'; //Neno: para forar a quebra da linha
            #32: Result := Result + ' '; //para adicionar espaos em branco entre palavras
            else
                if not InTag then
                begin
                    if (P^ in [#9, #32]) and ((P+1)^ in [#10, #13, #32, #9, '<']) then
                    else
                        Result := Result + P^;
                end;
        end;

        Inc(P);
    until (P^ = #0);

    {convert system characters}
    Result := StringReplace(Result, '&quot;', '"',  [rfReplaceAll]);
    Result := StringReplace(Result, '&apos;', '''', [rfReplaceAll]);
    Result := StringReplace(Result, '&gt;',   '>',  [rfReplaceAll]);
    Result := StringReplace(Result, '&lt;',   '<',  [rfReplaceAll]);
    Result := StringReplace(Result, '&amp;',  '&',  [rfReplaceAll]);

    Result := StringReplace(Result, 'v\:*{behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'o\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'w\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '.shape {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, 'v\:* {behavior:url(#default#VML);}', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '&#8220;', '',  [rfReplaceAll]);
    Result := StringReplace(Result, '&#8221;', '',  [rfReplaceAll]);
    {here you may add another symbols from RFC if you need}
end;

function formataTString(ts: TStringList; tamanho: integer): TStringList;
var
    i, p: integer;
    s: string;
    tsAux: TStringList;
begin
    tsAux := TStringList.Create;
    s := '';
    // Junta as linhas como pargrafos
    for i := 0 to (ts.count -1) do
    begin
        // Testa caracteres iniciais para juntar as linhas ou no
        if (ts[i] <> '') and not (ts[i][1] in['A' .. 'Z', '', '"', '`', '_', '*', '>', '<', '.'])
and not (ts[i][2] in[ ' ', '']) then
            s := s + ' ' + ts[i]
        else
        begin
            tsAux.add(s);
            s := ts[i];
        end;
    end;
    tsAux.add(s);
    ts.free;

//Quebra as linhas grandes no tamanho passado como parmetro
    ts := TStringList.Create;
    for i := 0 to (tsAux.count -1) do
    begin
        s := tsAux[i];
        while length(s) > tamanho do
        begin
            if pos (' ', copy(s, 1, tamanho)) <> 0 then
            begin
                for p := tamanho downto 1 do
                    if s[p] = ' ' then
                    begin
                        ts.add(copy(s, 1, p-1));
                        delete(s, 1, p);
                        break;
                    end;
            end
            else
            begin
                p := pos (' ', s);
                if p <> 0 then
                begin
                    ts.add(copy(s, 1, p-1));
                    delete(s, 1, p);
                end
                else
                begin
                    ts.add(s);
                    s := '';
                end
            end;
        end;
        if s <> '' then ts.add(s);
    end;

    tsAux.free;
    formataTString := ts;
end;

function quebraLinhasTString(ts: TStringList): TStringList;
var
    i, p: integer;
    s: string;
    tsAux: TStringList;
begin
    tsAux := TStringList.Create;
    for i:= 0 to (ts.count -1) do
        begin
            s := ts[i];

            repeat
                p := pos('&nbsp;', s);
                if p > 0 then
                    begin
                              tsAux.add(copy(s, 1, p - 1));
                        delete(s, 1, p + 5);
                    end
                else
                    tsAux.add(s);
            until p <= 0;
        end;
    ts.free;
    tsAux := formataTString(tsAux, 74);
    quebraLinhasTString := tsAux;
end;

procedure converteArqParaTxt (nomeArq: string);
var
    sl: TStringList;
    s: string;
begin
    sl := TStringList.Create;
    sl.LoadFromFile(nomeArq);
    s := sl.Text;
s := GetPlainText (s);
    sl.Text := s;
    sl := quebraLinhasTString(sl);
    sl.SaveToFile(nomeArq);
    sl.Free;
end;

procedure converteArqParaTxt1 (nomeArq: string);
var
    sl: TStringList;
begin
    sl := TStringList.Create;
    sl.LoadFromFile(nomeArq);
    sl.SaveToFile(nomeArq);
    sl.Free;
end;

{-------------------------------------------------------------}
{  Verifica se uma string contm apenas caracteres numricos
{-------------------------------------------------------------}

function verificaStringNumero(const s: string): boolean;
var
    P: PChar;
begin
    P := PChar(s);
    Result := False;
    while P^ <> #0 do
        begin
            if not (P^ in ['0'..'9']) then Exit;
            Inc(P);
        end;
    Result := True;
end;

{-------------------------------------------------------------}
{   Deleta um arquivo, recebendo o nome do arquivo.
{-------------------------------------------------------------}

function deletaArquivo(nomeArq: string): boolean;
var
    arqTemp: text;
begin
    deletaArquivo := true;
    deletaAspas (nomeArq);
    assign (arqTemp, nomearq);
    {$I-}  erase (arqTemp);  {$I+}
    if ioresult <> 0 then
        deletaArquivo := false;
end;

{-------------------------------------------------------------}
{ Retorna o caminho do diretrio atual
{-------------------------------------------------------------}

function pegaDirAtual: string;
var s: string;
begin
    getDir(0, s);
    pegaDirAtual := s;
end;

{-------------------------------------------------------------}
{       Retorna o caminho do diretrio temporrio do usurio logado
{-------------------------------------------------------------}

function pegaDirTemp: string;
var
    tempPath: array [0..144] of char;
begin
    getTempPath (144, tempPath);
    pegaDirTemp := strPas(tempPath);
end;

{-------------------------------------------------------------}
{        Troca diretrio, recebendo como parmetro.
{-------------------------------------------------------------}

function trocaDir (dirTrocar: string): boolean;
begin
    {$I-}  chdir (dirTrocar);  {$I+}
    trocaDir := ioresult = 0;
end;

{--------------------------------------------------------}
begin
end.
